/*
// Client specific code
*/

function do_login(username, password, language) {
	if (username == "") {
		on_login_error();
		return;
	}
	
	$("loginStatus").style.display = "None";
	
	dax_bridge.isClient = true;
	
	if (AdminShowAdmin)
		isAdminLoggedIn = true;
	else
		isAdminLoggedIn = false;
	
	var url = connection.address.login + "?username=" + dax_bridge.encode(username) + "&password=" + dax_bridge.encode(password);
	
	connection.username = username;
	
	makeRequest(url, login);
}

function do_drawSidebar()
{
	if (!structure.isUpdated()) {
		setTimeout("do_drawSidebar()", 10);
		return;
	} else {
		
		var taskbar_main = new taskbarItem(taskbar);
		taskbar_main.setLabel(STR['taskbar_views']);
		taskbar_main.setIcon("portal");
		setStyle (taskbar_main.dom, 'display', 'block');
		
		// safari fix for portal taskbar button width
		if (browser.safari)
			taskbar_main.button_m.style.width = '80px';

		// create a handler for taskbar clicking
		taskbar_main.dom.onclick = function() {
			if (aSidebar)
				if (aSidebar.state == 'visible')
					aSidebar.hide();
				else
					aSidebar.show();
		};

		
		var hl = new TableHList();
	
		//var tabs = new Tabs();
		
		aSidebar = new Sidebar();

		aButton = aSidebar.addButton ('logout_button');
		aButton.tooltip = STR['sidebar_logout'];
		
		aButton.onclick = function () {
		
			var aConfirm = confirm(STR['logoutconfirm']);
			
			if (aConfirm)
				dax_bridge.logout();
		
		}
		
		if (connection.admin) {
			// hl2
			
			/*
			var taskbar_admin = new taskbarItem(taskbar);
			taskbar_admin.setLabel(STR['taskbar_admin_label']);
			taskbar_admin.setIcon("admin");
			setStyle (taskbar_admin.dom, 'display', 'block');
			*/

			aButton = aSidebar.addButton ('console_button');
			aButton.tooltip = STR['sidebar_console'];
			
			// create a handler for taskbar clicking
			aButton.onclick = function() {
				showDebugger();
			};			
			
			aButton = aSidebar.addButton ('admin_button');
			aButton.tooltip = STR['sidebar_settings'];
						
			// create a handler for taskbar clicking
			aButton.onclick = function() {
				// scroll window to 0,0 to avoid grayout bugs
				parent.window.scrollTo(0,0);
			
				do_showDashboard($('adminSettings'), '1');
				if (tablelistinitialized) {
					admintablegridobject.viewport.refresh();

					admintablegridobject.grid.dom.style.maxHeight = "150px";
					admintablegridobject.viewport.vscrollbar.dom.style.top = admintablegridobject.viewport.content.offsetTop+"px";
					admintablegridobject.viewport.vscrollbar.dom.style.left = admintablegridobject.viewport.content.offsetLeft + admintablegridobject.viewport.content.offsetWidth+"px";	
				}
				//do_showDashboard($('adminGeneralPrefs'), '2');
			};

			/*
			
			var taskbar_debugger = new taskbarItem(taskbar);
			taskbar_debugger.setLabel(STR['taskbar_debug']);
			taskbar_debugger.setIcon("debug");
			setStyle (taskbar_debugger.dom, 'display', 'block');

			*/
			


			LoadAdmin();
		}

	
		// Tables tab
		//var container = $("table_list");
		//container.style.display = "block";
		//container.appendChild(hl.dom);
		aSidebar.contents.appendChild (hl.dom);
		aSidebar.contents.hList = hl;

		// safari fix
		if (!browser.safari2)
			setStyle (hl.dom, 'width', '500px');
		else {
			setStyle (hl.dom, 'width', '130px');
		}
		
		aSidebar.dom.style.opacity = '0.8';
		
		// ie6 fix
		if (browser.ie6) {
			hl.dom.style.position = 'absolute';
			aSidebar.contents.style.height = hl.dom.offsetHeight;
		}		
		
		
		//aSidebar.setTitle ('tables');
		
		//tabs.insert("Tables", 0, container);
		
		//var sidebar = $('sidebar');
		//sidebar.appendChild(tabs.dom);
		//sidebar.style.display = "block";
		//tabs.dom.style.opacity = "0.8";		

		aSidebar.show();
		aSidebar.hList = hl;
		
	}
}

function do_redrawSidebar() 
{
	var	dax_sidebar = $('dax_sidebar0');
	dax_sidebar.parentNode.removeChild(dax_sidebar);
	structure.cached = false;
	structure.tables.length = 0;
	dax_bridge.tables.length = 0;

	// close all preloaded windows
	var preloadedWindows = new Array();
	for (var pr = 0; pr < WindowManager.windows.length; pr++) {
		//if (WindowManager.windows[pr].preloaded)
			preloadedWindows.push(WindowManager.windows[pr]);
	}

	if (preloadedWindows.length > 0) {
		for (var pr = 0; pr < preloadedWindows.length; pr++) {
			var thisWindow = preloadedWindows[pr];
			WindowManager.destroyWindow(thisWindow);
			setTimeout(function() {thisWindow = null;}, 1);
		}
	}
	
	preloadedWindows = null;
	
	
	dax_bridge.updateTables();			
	do_redrawSidebar2();
}

function do_redrawSidebar2()
{
	if (!structure.isUpdated() | dax_bridge.updating) {
		setTimeout("do_redrawSidebar2()", 10);
		return;
	} else {
				
		var hl = new TableHList();
	
		//var tabs = new Tabs();
		
		aSidebar = new Sidebar();
		
		// Tables tab
		aSidebar.contents.appendChild (hl.dom);
		aSidebar.contents.hList = hl;
		
		// safari fix
//		if (!browser.safari)
			setStyle (hl.dom, 'width', '500px');
//		else {
//			setStyle (hl.dom, 'width', '130px');
//		}
			
		aSidebar.dom.style.opacity = '0.8';
		
		// ie6 fix
		if (browser.ie6) {
			hl.dom.style.position = 'absolute';
			aSidebar.contents.style.height = hl.dom.offsetHeight;
		
		}

		aSidebar.show();
		aSidebar.hList = hl;
		
		aButton = aSidebar.addButton ('logout_button');
		aButton.tooltip = STR['sidebar_logout'];

		aButton.onclick = function () {
		
			var aConfirm = confirm(STR['logoutconfirm']);
			
			if (aConfirm)
				dax_bridge.logout();
		
		}
		
		if (connection.admin) {
			// hl2
			
			/*
			var taskbar_admin = new taskbarItem(taskbar);
			taskbar_admin.setLabel(STR['taskbar_admin_label']);
			taskbar_admin.setIcon("admin");
			setStyle (taskbar_admin.dom, 'display', 'block');
			*/
			aButton = aSidebar.addButton ('console_button');
			aButton.tooltip = STR['sidebar_console'];
			
			// create a handler for taskbar clicking
			aButton.onclick = function() {
				showDebugger();
			};
			
			aButton = aSidebar.addButton ('admin_button');
			aButton.tooltip = STR['sidebar_settings'];
						
			// create a handler for taskbar clicking
			aButton.onclick = function() {
				// scroll window to 0,0 to avoid grayout bugs
				parent.window.scrollTo(0,0);
			
				do_showDashboard($('adminSettings'), '1');
				if (tablelistinitialized) {
					admintablegridobject.viewport.refresh();

					admintablegridobject.grid.dom.style.maxHeight = "150px";
					admintablegridobject.viewport.vscrollbar.dom.style.top = admintablegridobject.viewport.content.offsetTop+"px";
					admintablegridobject.viewport.vscrollbar.dom.style.left = admintablegridobject.viewport.content.offsetLeft + admintablegridobject.viewport.content.offsetWidth+"px";	
				}
				//do_showDashboard($('adminGeneralPrefs'), '2');
			};

			/*
			
			var taskbar_debugger = new taskbarItem(taskbar);
			taskbar_debugger.setLabel(STR['taskbar_debug']);
			taskbar_debugger.setIcon("debug");
			setStyle (taskbar_debugger.dom, 'display', 'block');

			*/
			

		
		}

		//aSidebar.setTitle ('tables');
		
		//tabs.insert("Tables", 0, container);
		
		//var sidebar = $('sidebar');
		//sidebar.appendChild(tabs.dom);
		//sidebar.style.display = "block";
		//tabs.dom.style.opacity = "0.8";		

	}
}

/*
// Append reports to the sidebar portal
//
// Rudolf Psenicnik
*/

function appendReportsToSidebar()
{
	if (!aSidebar)
		return false;

	// get list of reports for the table
	for (var tableCount = 0; tableCount < aSidebar.hList.items.length; tableCount++) {
		var hTable = getTable(aSidebar.hList.items[tableCount].tableid);
		if (hTable.reports.length > 0) {
			var reportList = new HList();
			for (var reportCount = 0; reportCount < hTable.reports.length; reportCount++) {
				var reportListItem = reportList.insert(hTable.reports[reportCount].name);
				reportListItem.reportName = hTable.reports[reportCount].name;
				reportListItem.label.onclick = function() {
					dax_bridge.dashboardView = new dashboardViewer(this.parent.reportName);
					//dax_bridge.reportView.getReport(this.parent.reportName);
				}
			}
			aSidebar.hList.items[tableCount].attach(reportList);			
		}
	}
	
	
}

/**
 * TableHList
 *
 * @author Jonathan Le
 * @author Rudolf Psenicnik
 */
function TableHList()
{
	var hl = new HList();
		
	for (var i = 0; i < structure.tables.length; i++) {
		var table = structure.tables[i];
		//var fields = table.fieldsList;
		
		var li = hl.insert(table.tablename);
		li.tableid = table.tableid;
		li.cached = table.cached;		

		// set icon based on the type
		var hTable = getTable (table.tableid);

		if (hTable.ddw) {
			li.icon.className += ' icon_ddw';
		} else {					
			if (hTable.tablecalendarview == "True") {
				li.icon.className += ' icon_calendarview';
			} else if (hTable.tabledatatreeview == "True") {
				li.icon.className += ' icon_datatree';
			} else if (hTable.tableimagematrixview == "True"){
				li.icon.className += ' icon_imagebrowser';
			} else if (hTable.tabledatamatrixview == "True"){
				li.icon.className += ' icon_datamatrix';
			} else {
				li.icon.className += ' icon_datawindow';
			}
		}
		
		li.label.onclick =
			function()
			{
				if (!labeledit) {
				
					hTable = getTable (this.parent.tableid);

					if (hTable.ddw) {
						if (hTable.ddwtype.indexOf ('Static') != -1)
							new DDW (hTable.ddw, 'static_url', hTable.tablealias);
						else if (hTable.ddwtype.indexOf ('Dynamic') != -1)
							new DDW (hTable.ddw, 'dynamic_url', hTable.tablealias);
						// else if (hTable.ddwtype.indexOf ('Message') != -1)
							// new DDW (hTable.ddw, 'message_window', hTable.tablealias);
					} else {					
						// check if this window already exists
						var windowRef = findWindowByTableId (this.parent.tableid);
						// if window exists, show it
						if (windowRef) {
							windowRef.activate();
							windowRef.resize(1,1);
							windowRef.tbitem.dom.style.display = 'block';
							
							// finish preloading
							if (windowRef.preloaded) {
								// if loaded for first time, finish the init
								if (hTable.tablecalendarview == "True") {
									// display calendar view
									windowRef.boundTo.refresh();
									windowRef.resize(1,1);
								
								} else if (hTable.tabledatatreeview == "True") {
									// display hgrid view
									windowRef.boundTo.initialize();
									windowRef.resize(1,1);
								} else if (hTable.tableimagematrixview == "True"){
									// display grid view
									//windowRef.grid.populate({tableId : windowRef.aTableId, comparison : windowRef.aComparison });									
									
								} else if (hTable.tabledatamatrixview == "True"){
									// display grid view
									windowRef.boundTo.wakeUp();								
									
								} else {
									// display grid view
									windowRef.boundTo.wakeUp();									
									
								}		
								windowRef.preloaded = null;
								windowRef.dom.style.left = '250px';
							}
							
							windowRef = null;
							
							return;
						}
						
						// cache field info if needed
						if (this.parent.cached == false) {
							//buildFieldList(this.parent.tableid);
							this.parent.cached = true;
						}
						dax_bridge.cacheFields(hTable);
						// check which view is used
						if (hTable.tablecalendarview == "True") {
							// display calendar view
							new calendarView(null, this.parent.tableid, null, null);
						} else if (hTable.tabledatatreeview == "True") {
							// display hgrid view
							new HGrid (null, this.parent.tableid);
						} else if (hTable.tabledatamatrixview == "True") {
							// display data matrix
							var dataMatrixObject = new dataMatrix (null, this.parent.tableid, 'auto', 'auto', null, null, 'left', null, null, null, null, null);
							dataMatrixObject.window.tableid = this.parent.tableid;
							dataMatrixObject.window.closeBox.onmouseup = function (aEvent) {
								this.parent.boundTo.hibernate();
								if (taskbar)
									this.parent.tbitem.dom.style.display = 'none';
								return false;
							}							
							dataMatrixObject = null;
						} else if (hTable.tableimagematrixview == "True") {
							// display image matrix
							var dataMatrixObject = new dataMatrix (null, this.parent.tableid, 'auto', 'auto', null, null, 'top', null, null, null, null, null);
							// modify the icon
							dataMatrixObject.window.logo.className = 'window_logo_imagebrowser';
							dataMatrixObject.window.tbitem.setIcon("imagebrowser");
							dataMatrixObject.window.tableid = this.parent.tableid;
							dataMatrixObject.window.closeBox.onmouseup = function (aEvent) {
								this.parent.boundTo.hibernate();
								if (taskbar)
									this.parent.tbitem.dom.style.display = 'none';
								return false;
							}		
							dataMatrixObject = null;
						} else {
							// display grid view
							do_allRecords(this.parent.tableid);
						}
					}
				}
			};
		
		/*
		
		if (fields) {
			var fieldlist = new HList();
			for (var k = 0; k < fields.length; k++) {
				fieldlist.insert(fields[k].fieldname,
					"js/templates/images/" + fields[k].fieldtype + ".png");
			}
						
			li.attach(fieldlist);
		}
		*/
	}
	
	hl.refresh();
	
	return hl;
}