/**
 * DataWindow
 *
 * @author	Jonathan Le
 *
 **/
 
 function DataWindow_empty() {};
 
 // function DataWindow_
 
function DataWindow(aTableId, aLocation, aField, aValue, qQueryId, aSync, selectOneRow)
{
	
	this.loaded = false;
	
	// for future reference
	this.aTableId = aTableId;
	this.aLocation = aLocation;
	this.aField = aField;
	this.aValue = aValue;
	this.qQueryId = qQueryId;
	this.initialized = false;
	
	// load data window asyncronosuly?
	
	if (aSync)
		this.aSync = aSync;
	else
		this.aSync = false;
	
	
//	this.table = structure.getTable(this.aTableId);
	this.table = getTable(this.aTableId);

	if (!this.table) {
		this.table = getTable (this.aTableId);
		if (!this.table) {
			return null;
		} else {
			this.aTableId = this.table.tableid;
		}
	} else {
		this.aTableId = this.table.tableid;
	}

	// this.bridgeTable = getTable (this.aTableId);
	
	this.selectOneRow = false;
	this.updatingTabsFieldId = null;
	
	if (selectOneRow)
		if (selectOneRow == true)
			this.selectOneRow = true;

		
	// inherit from Window
	Window.apply(this);

	if (connection.admin)
		this.savePrefsBox.style.display = 'block';
	
	this.tableId = this.aTableId;
	
	var aThis = this;
	
	this.onLoadSuccess = DataWindow_empty
	this.initializing = true;

	this.loaded = true;
	
	// will call the rest of the data window to create illusion of loading
	if (this.aSync)
		setTimeout(function() { DataWindowPartTwo(aThis); }, 1);
	else
		DataWindowPartTwo(aThis);		

}

function DataWindowPartTwo_createBtn_onclick() { create_record(this.prv.mDOM); };

function DataWindowPartTwo_deleteBtn_onclick() { delete_records(this.prv.mDOM); };

function DataWindowPartTwo_aThis_fetchData (fieldId, queryValue, queryId) {

	this.aComparison = null;
	if ((fieldId) && (queryValue)) {
		queryField = getField (this.aTableId, fieldId);
		if (queryField) {
			this.aComparison = "&fieldid=" + queryField.fieldid + "&comp=equal&value=" + encodeURIComponent(queryValue);
		}
	} else if (queryId) {
		this.aComparison = "&queryid=" + queryId;
	}

	// check if data window was loaded completely first 
	if (this.qQueryId == 'noload') {
		this.qQueryId = null;
		this.grid.populate({tableId : this.aTableId, comparison : this.aComparison });
	}
	
	this.grid.recreateSelection = true;
	this.grid.populate({tableId : this.aTableId, comparison : this.aComparison });

		
}

// function DataWindowPartTwo_

function DataWindowPartTwo (aThis) {
	
	// construct
	{
	
		// instead of closing the window, hide it on close
	//	if (aThis.hideOnClose) {
	
		// update window on close box method
		
		function DataWindow_toString()
			{
				return "[object DataGrid]";
			};	
			
		aThis.toString = DataWindow_toString;
		
		dax_bridge.cacheFields (getTable(aThis.aTableId));
		
		aThis.enableTabs = true;
		
		aThis.closeBox.onmouseup = function (aEvent) {
			clearTimeout(this.parent.grid.prv.mTimeoutId);
			WindowManager.hideWindow(this.parent);
			if (taskbar)
				this.parent.tbitem.dom.style.display = 'none';
			return false;
		}
		
	//	}
	
		// target location
		aThis.target = aThis.aLocation;
	
		// set the title
		var tablename = aThis.table.tablename;
		var tableRef = getTable(aThis.table.tableid);
		aThis.titleBar.innerHTML = tableRef.tablealias;		
		
		var toolbar = new Toolbar();
		aThis.mainToolbar = toolbar;
		
		// create the buttons we need
		var createBtn = toolbar.addButton(STR['button_create']);
		createBtn.onclick = DataWindowPartTwo_createBtn_onclick;
		
		// var refreshBtn = toolbar.addButton(STR['button_refresh']);
		// refreshBtn.onclick = function() { refresh_table(this.prv.mDOM); };
		
		var deleteBtn = toolbar.addButton(STR['button_delete']);
		deleteBtn.onclick = DataWindowPartTwo_deleteBtn_onclick;
		
		// add the toolbar to the window
		aThis.addToolbar(toolbar.prv.mDOM);
		
		// add the spinner
		var spinner = getTemplate("spinner").cloneNode(true);
		toolbar.addContent(spinner);
		setStyle(spinner, "display", "block");
		
		aThis.spinner = spinner;
		
		var search = getTemplate("searchwidget").cloneNode(true);
		generateUniqueId (search);
		search.inputBox = getElementByClassName (search, 'queryname');
		
		// Search		
		search.inputBox.fieldSelect = getElementByClassName (search, 'fieldSelect');

		function DataWindowPartTwo_inputBox_fieldSelect_onchange(e) {
			this.fieldid=this.options[this.selectedIndex].fieldid;	
			this.field = getField(this.tableId, this.fieldid);
		};

		function DataWindowPartTwo_search_inputBox_onkeyup(e) {
			
			if ((this.fieldSelect.field.fieldtype == 'date') && (this.value)) {
				var newValue = doFormat(this.value, this.fieldSelect.field.fieldformat, 'YYYY-MM-DD');
				if (newValue)
					inline_query_delay(this, true, this.fieldSelect.fieldid, newValue, this.queryId, null, null, true);
					//inline_query(this, this.fieldSelect.fieldid, newValue, this.queryId, null, null, true);
			} else {
				inline_query_delay(this, true, this.fieldSelect.fieldid, this.value, this.queryId, null, null, true);
				//inline_query(this, this.fieldSelect.fieldid, this.value, this.queryId, null, null, true);
			}
		};

		// function DataWindowPartTwo_
		
		search.inputBox.fieldSelect.onchange = DataWindowPartTwo_inputBox_fieldSelect_onchange;

		search.inputBox.onkeyup = DataWindowPartTwo_search_inputBox_onkeyup;
		
		aThis.search = search;
		search.owner = aThis;
		
		toolbar.addContent(search);
		setStyle(search, "display", "block");
		//setStyle(report, "display", "block");
		
		getElementByClassName (search, 'label').innerHTML = STR['search'];
		getElementByClassName (search, 'searchOptGroup').label = STR['fields'];
		
		var select = getElementByClassName(search, "fieldSelect");
		var queryname = getElementByClassName(search, "queryname");
		
		if (select) {
			var option = getElementByClassName(select, "fieldOption");
			var optgroup = option.parentNode;

			select.tableId = aThis.table.tableid;
			
			// build the select list in the toolbar
			for (var k in aThis.table.fields) {
				if ((aThis.table.fields[k].fieldtype != 'picture') && (aThis.table.fields[k].fieldinlist.toLowerCase() == 'true')){
					if (k > 0)
						option = option.cloneNode(true);
					else
						select.fieldid = aThis.table.fields[k].fieldid;

					option.parent = select;
					option.innerHTML = aThis.table.fields[k].fieldalias;
					//option.value = table.fields[k].fieldid;
					option.fieldid = aThis.table.fields[k].fieldid;
					option.onclick =
						function() { select.fieldid = this.fieldid;};
					optgroup.appendChild(option);
				}
			}
		}
		
		var saveBtn = toolbar.addButton(STR['button_save']);
		saveBtn.owner = aThis;
		aThis.search.saveButton = saveBtn;

		/*
		
		var report = getTemplate("reportwidget").cloneNode(true);
		generateUniqueId (report);

		report.style.display = 'block';
		aThis.report = report;
		aThis.report.select = getElementByClassName (report, 'reportSelect');
		aThis.report.select.owner = aThis;
		
		selection = aThis.report.select;
		selection.noReports = false;
		reportElements = aThis.table.reports;		

		toolbar.addContent(report);
		aThis.report.goButton = toolbar.addButton('Go');
		aThis.report.goButton.owner = aThis;

		
		if (reportElements.length > 0) {
			for (var reportCount = 0; reportCount < reportElements.length; reportCount++) {
				var reportName = reportElements[reportCount].name;
				selection.options[selection.options.length] = new Option(reportName,reportName);					
			}			
		} else {
			selection.options[selection.options.length] = new Option('None found','None found');
			selection.noReports = true;
			selection.owner.report.goButton.disable();
		}

		function DataWindowPartTwo_goReport_onclick() {
		
			var queryId = this.owner.contentArea.grid.receivedQueryId;
			var reportName = this.owner.report.select.options[this.owner.report.select.selectedIndex].value;
			var selection = this.owner.table;
			
			dax_bridge.reportView = new reportViewer();
			dax_bridge.reportView.getReport(reportName, queryId);
			
		}
		aThis.report.goButton.onclick = DataWindowPartTwo_goReport_onclick;
		
		*/
		
		getElementByClassName(search, 'queryname').boundTo = aThis;
		
		function DataWindowPartTwo_saveBtn_onclick() { 
			save_query(search, select.tableId, select.fieldid, queryname.value, this.owner.contentArea.grid.receivedQueryId); 
			getElementByClassName (this.owner.dom, 'queryname').queryId = this.owner.contentArea.grid.receivedQueryId;
			search.inputBox.value = '';
		};
		
		// function DataWindowPartTwo_
		saveBtn.onclick = DataWindowPartTwo_saveBtn_onclick;

		getElementByClassName (search, 'form').enterButton = saveBtn;		
		
		// add ddw button to the toolbar
		var eTable = getTable (aThis.aTableId);
		if ((eTable) && (eTable.ddwOptions) && (eTable.ddwOptions.length > 0)) {
			// add a ddw button
			var ddwOption = eTable.ddwOptions[0];
			
			var ddwButton = toolbar.addButton (ddwOption.title);
			ddwButton.url = ddwOption.url;
			ddwButton.title = ddwOption.title;
			ddwButton.owner = aThis;
			if (ddwOption.type.indexOf("Static") != -1) {

				function DataWindowPartTwo_ddwButton_onclick() {
					if (this.owner.search.inputBox.value)
						var queryId = this.owner.currentQueryId;
					else if ((this.owner.currentTab) && (this.owner.currentTab.queryId)) 
						var queryId = this.owner.currentTab.queryId;
					else
						var queryId = this.owner.contentArea.grid.selection.queryId;
					var tableId = this.owner.contentArea.grid.selection.tableId;
					var selectedRecords = new Array();
					if (this.owner.grid.selection.selected) {
						for (z in this.owner.grid.selection.selected) {
							if (this.owner.grid.selection.selected[z]) {
								selectedRecords.push(z);
							}
						}
					}
					new DDW(this.url, 'static_url', this.title, '&queryid=' + queryId + "&tableid=" + tableId, selectedRecords);
				};
				
				// function DataWindowPartTwo_
				
				ddwButton.onclick = DataWindowPartTwo_ddwButton_onclick;
				
			} else if (ddwOption.type.indexOf("Dynamic") != -1) {
				ddwButton.onclick = function () {
					if (this.owner.search.inputBox.value)
						var queryId = this.owner.currentQueryId;
					else if ((this.owner.currentTab) && (this.owner.currentTab.queryId)) 
						var queryId = this.owner.currentTab.queryId;
					else
						var queryId = this.owner.contentArea.grid.selection.queryId;
					var tableId = this.owner.contentArea.grid.selection.tableId;
					var selectedRecords = new Array();
					if (this.owner.grid.selection.selected) {
						for (z in this.owner.grid.selection.selected) {
							if (this.owner.grid.selection.selected[z]) {
								selectedRecords.push(z);
							}
						}
					}
					new DDW(this.url, 'dynamic_url', this.title, '&queryid=' + queryId + "&tableid=" + tableId, selectedRecords);	
				};
			} else if (ddwOption.type.indexOf("Message") != -1) {
				ddwButton.onclick = function () {
					if (this.owner.search.inputBox.value)
						var queryId = this.owner.currentQueryId;
					else if ((this.owner.currentTab) && (this.owner.currentTab.queryId)) 
						var queryId = this.owner.currentTab.queryId;
					else
						var queryId = this.owner.contentArea.grid.selection.queryId;
					var tableId = this.owner.contentArea.grid.selection.tableId;
					var selectedRecords = new Array();
					if (this.owner.grid.selection.selected) {
						for (z in this.owner.grid.selection.selected) {
							if (this.owner.grid.selection.selected[z]) {
								selectedRecords.push(z);
							}
						}
					}
					new DDW(this.url, 'message_window', this.owner, '&queryid=' + queryId + "&tableid=" + tableId, selectedRecords);	
				};
			}
		}
		
		// add the status bar
		var status = getTemplate("statusbar", "dax").cloneNode(true); 
		probe(status);
		
		status.id = "statusbar"+WindowManager.windows.length + 1;
		//status.style.display = 'none';
		//setStyle(status, "display", "block");
		// hide status section for now
		setStyle(status, "display", "none");
		setStyle(aThis.status, "height", "19px");
		

		status.parent = aThis;
		aThis.status.appendChild(status);

		aThis.open();
	
		// fix toolbar overflow
		setStyle (toolbar.prv.mDOM, 'overflow', 'hidden');
		aThis.resizeToolbar(false);
		// set toolbar size
		if (toolbar)
			if (aThis.offsetWidth < 800)
				setStyle (toolbar.prv.mDOM, 'width', '600px');
			else
				setStyle (toolbar.prv.mDOM, 'width', aThis.offsetWidth + 'px');

		if (browser.safari)
			setStyle (toolbar.prv.mDOM, 'width', '1000px');
		
				
		// reference ourselves
		var winObj = aThis;
		aThis.winObj = winObj;

		// overwrite the window object's events

		function DataWindowPartTwo_aThis_winObj_onopen() {
			try {
				// add an item to the taskbar
				if (taskbar) {
					var ti = new taskbarItem(taskbar);
					ti.setLabel(this.titleBar.innerHTML);
					ti.setIcon("datawindow");
					setStyle (ti.dom, 'display', 'block');
					// create a handler for clicking
					var winRef = this;
					ti.dom.onclick = function() { 
						this.parent.setSelected (true, true);
						winRef.activate(); 
					};

					ti.setSelected (true, true);
					ti.parent.refresh();
					
					// handler for close button
					// ticlose = getElementByClassName (ti.dom, 'dax_taskbar_close', true);
					// ticlose.onclick = function () {WindowManager.destroyWindow(winRef); };
					
					this.tbitem = ti;
				}
			} catch(e) {
			}
		};

		function DataWindowPartTwo_tab_onswitch()
		{
			if (this.owner.grid.selection)
				this.owner.grid.selection.selected = new Array();
			this.owner.currentTab = this;
			inline_query(search, -1, '*', this.queryId);
			this.owner.search.inputBox.value = '';
			getElementByClassName (this.owner.dom, 'queryname').queryId = this.queryId;
		};
		
		// function DataWindowPartTwo_

		aThis.fetchData = DataWindowPartTwo_aThis_fetchData;
		
		aThis.winObj.onopen = DataWindowPartTwo_aThis_winObj_onopen;
		
		aThis.winObj.onopen();
		
		// the first Tab is all records
		var tabs = new Tabs();
		
		// show first tab if there are no custom queries
		if ((aThis.table.showallrecordstab.toLowerCase() == 'true') || ((aThis.table.preselectQueries.length == 0) && (aThis.table.preselectedDynamicQueries.length == 0))) {
		
			var tab = tabs.insert(STR['all']+ " " +winObj.titleBar.innerHTML);
			tab.owner = aThis;
			tabs.dom.className = "tabs_tb";
			tab.firstTab = true;
			tab.queryId = null;
			tab.queryName = null;

			tab.onswitch = DataWindowPartTwo_tab_onswitch;
			
			tab.tooltip = '';

			// query properties
			// tab keeps 'permanent' query id 
			aThis.currentTab = tab;
		
		}

		// this is current unsaved query id
		aThis.currentQueryId = null;
		
		
		// add preselect query tabs
		for (var tCount = 0; tCount < aThis.table.preselectQueries.length; tCount++) {
			var tab = tabs.insert(aThis.table.preselectQueries[tCount].name);
			tab.owner = aThis;
			tabs.dom.className = "tabs_tb";
			tab.firstTab = false;
			tab.queryId = null;
			tab.queryName = aThis.table.preselectQueries[tCount].name;

			tab.onswitch = function()
			{
				// do an inline query
				if (this.owner.grid.selection)				
					this.owner.grid.selection.selected = new Array();
				this.owner.currentTab = this;
				if ((!this.queryId) && (this.queryName)) {
					inline_query(select, null, '*', null, this.queryName);
				} else {
					inline_query(select, null, '*', this.queryId, null);
					getElementByClassName (this.owner.dom, 'queryname').queryId = this.queryId;
				}
				this.owner.search.inputBox.value = '';
			}
			
			tab.tooltip = '';	

			if (!aThis.currentTab) {
				aThis.currentTab = tab;
			}
		}


		
		// set first tab active
		tabs.activateById(0);
		
		/*
		
		tab.userMouseOver = function (aEvent) {
			//this.className = 'dax_sidebar_button ' + this.defaultClass + '_o';
			if (this.tooltip) {
				objectPos = getObjectPosition (this.r);
				showTooltip(this.tooltip, objectPos.x, objectPos.y + this.r.offsetHeight);
			}
		}
		
		
		tab.userMouseOut = function (aEvent) {
			//this.className = 'dax_sidebar_button ' + this.defaultClass;
			if (this.tooltip)
				hideTooltip();
		}

		*/		
		
		// set close tab button visible
		// getElementByClassName (tabs.dom, 'tab_close', true).style.display = 'block';
		
		winObj.addToolbar(tabs.dom);
		if (browser.safari) {
			//tabs.dom.style.width = '100%';
			tabs.dom.parentNode.style.width = '100%';
		}
		
		//winObj.resize();
		
		aThis.tabsbar = tabs;
		
		// custom query on load
		aThis.aComparison = null;
		if ((aThis.aField) && (aThis.aValue)) {
			queryField = getField (aThis.aTableId, aThis.aField);
			if (queryField) {
				aThis.aComparison = "&fieldid=" + queryField.fieldid + "&comp=equal&value=" + aThis.aValue;
			}
		} else if (aThis.qQueryId) {
			aThis.aComparison = "&queryid=" + aThis.qQueryId;
		}

		// fixed drawing bug
		aThis.resize(null, null, true);

		/*
		// add spinner in the content area
		var newSpinner = getTemplate('window_preload').cloneNode(true);
		newSpinner.style.display = 'block';
		aThis.winObj.contentArea.appendChild (newSpinner);		
		newSpinner = null;
		*/
		
		search.inputBox.fieldSelect.onchange();
		
		// will call the rest of the data window to create illusion of loading
		if (aThis.aSync)
			setTimeout(function() { DataWindowPartThree(aThis); }, 1);
		else
			DataWindowPartThree(aThis);			
	}
}
	
function DataWindowPartThree(aThis)
{
	{		
		// load the grid and queue the first autoreload
		//var grid = do_AR(aThis.winObj.contentArea, aThis.aTableId, aThis.aComparison);
		// update tabs with dynamic values
		function DataWindowPartThree_updateDynamicQueryTabs()
		{
			if (this.table) {
				if (this.table.preselectedDynamicQueries) {
					if (this.table.preselectedDynamicQueries.length > 0) {
						for (var qCount = 0; qCount < this.table.preselectedDynamicQueries.length; qCount++) {
							// check for valid string
							if (this.table.preselectedDynamicQueries[qCount].fieldId.indexOf('][') != -1) {
								// generate a call to backend to get the list of unique values
								var url = dax_bridge.url + "GetUniqueQueries?sessionId=" + dax_bridge.sessionId + "&tableid=" + this.table.tableid +
									"&fieldid=" + this.table.preselectedDynamicQueries[qCount].fieldId;
								makeCall (url, this.updateDynamicQueryTabs_handler, this);
							}
						}
					}
				}
			}
		}
		
		function DataWindowPartThree_updateDynamicQueryTabs_handler(http_result, aRef)
		{
		
			if (http_result.readyState != 4)
				return;

			var responseError = checkResponse (http_result);
				
			if (responseError)	
				return;
			
			var queryNode = http_result.responseXML.getElementsByTagName("queries").item(0);
			var queryNames = queryNode ? queryNode.getElementsByTagName("query") : null;		
			var fieldId = queryNode.getAttribute("fieldid");

			if (!queryNames)
				return;
			
			if (queryNames.length == 0)
				return;

			if (aRef.updatingTabsFieldId) {
				if (aRef.updatingTabsFieldId == fieldId) {
					return;
				} else {
					setTimeout(function() {DataWindowPartThree_updateDynamicQueryTabs_handler(http_result, aRef) }, 1000);
					return;
				}
			} else {
				aRef.updatingTabsFieldId = fieldId;
			}				
				
			for (var tabCount = 0; tabCount < aRef.tabsbar.tabs.length; tabCount++) {
				// mark all tabs as removable until proven otherwise later
				aRef.tabsbar.tabs[tabCount].keepTab = false;
			}
				
			for (qnCount = 0; qnCount < queryNames.length; qnCount++) {	
				var queryName = queryNames.item(qnCount).getAttribute('name');
				if (queryName) {
					if (queryName != '4daf_unique_') {
						var tabExists = false;
						// check if the tab exists before adding it
						for (var tabCount = 0; tabCount < aRef.tabsbar.tabs.length; tabCount++) {
							if (aRef.tabsbar.tabs[tabCount].queryName == queryName) {
								var tabExists = true;
								// so we won't erase it later when purging the non-existent tabs
								aRef.tabsbar.tabs[tabCount].keepTab = true;
							}						
						}

						if (!tabExists) {
							// add tab
							var tabs = aRef.tabsbar;
							var tab = tabs.insert(queryName.substr(12));
							tab.owner = aThis;
							tabs.dom.className = "tabs_tb";
							tab.firstTab = false;
							tab.queryId = null;
							tab.queryName = queryName;
							tab.keepTab = true;
							// so we won't mess with the tabs that deal with other id's
							tab.fieldId = fieldId;

							tab.onswitch = function()
							{
								if (this.owner.grid.selection)								
									this.owner.grid.selection.selected = new Array();
								// do an inline query
								this.owner.currentTab = this;
								if ((!this.queryId) && (this.queryName)) {
									inline_query(null, null, '*', null, this.queryName, this.owner);
								} else {
									inline_query(null, null, '*', this.queryId, null, this.owner);
									getElementByClassName (this.owner.dom, 'queryname').queryId = this.queryId;
								}
								this.owner.search.inputBox.value = '';
							}
							
							tab.tooltip = '';
						}
					}
				}
			}
			// erase tabs
			var eraseTabsArray = new Array();
			for (var tabCount = 0; tabCount < aRef.tabsbar.tabs.length; tabCount++) {
				if (!aRef.tabsbar.tabs[tabCount].firstTab) {
					if ((!aRef.tabsbar.tabs[tabCount].keepTab) && (aRef.tabsbar.tabs[tabCount].queryName)) {
						if ((aRef.tabsbar.tabs[tabCount].queryName.indexOf('4daf_unique_') != -1) && (aRef.tabsbar.tabs[tabCount].fieldId == fieldId))
							eraseTabsArray.push(aRef.tabsbar.tabs[tabCount]);
					}
				}
			}
			if (eraseTabsArray) {
				if (eraseTabsArray.length > 0) {
					for (var tabCount = 0; tabCount < eraseTabsArray.length; tabCount++) {
						var clearCurrentTab = false;
						// remove current tab manually from data window
						if (aRef.currentTab = eraseTabsArray[tabCount])
							clearCurrentTab = true;
						// remove tab
						aRef.tabsbar.remove(eraseTabsArray[tabCount].index);
						if (clearCurrentTab)
							aRef.currentTab = null;
					}
				}			
			}

			// if object is in init state, open first dynamic tab
			if (aRef.initialize == true) {
				aRef.initialize = false;
				if (aRef.tabsbar.tab[0])
					aRef.tabsbar.tab[0].dom.onclick();
			}
			
			// current tab still exists, reselect it
			if (aRef.currentTab) {
				aRef.tabsbar.activate(aRef.currentTab);
			} else {
				aRef.currentTab = aRef.tabsbar.tabs[0];
				aRef.currentTab.dom.onclick();
			}

			
			// release lock
			aRef.updatingTabsFieldId = null;
			aRef.tabsbar.refresh();
			if (!aRef.initialized) {
				aRef.winObj.resize(1,1);
				aRef.winObj.initialized = true;
			
			}
		}
		
		function DataWindowPartThree_refreshDynamicTabs()
		{
			if (this.dynamicTabId) {
				clearTimeout(this.dynamicTabId);
			}

			this.updateDynamicQueryTabs();
			
			var thisWindow = this;
						
			this.dynamicTabId = setTimeout(function() { thisWindow.refreshDynamicTabs(); }, 60 * 3 * 1000);

		}

		aThis.updateDynamicQueryTabs = DataWindowPartThree_updateDynamicQueryTabs;
		
		aThis.updateDynamicQueryTabs_handler = DataWindowPartThree_updateDynamicQueryTabs_handler;
		
		aThis.refreshDynamicTabs = DataWindowPartThree_refreshDynamicTabs;

		if (aThis.qQueryId == 'noload'){
			aThis.winObj.preloaded = true;
			var grid = new GridObject(aThis.winObj.contentArea);
			
			aThis.winObj.contentArea.grid = grid;
		
			aThis.grid = grid;
			grid.owner = aThis;
		} else {
			var grid = do_AR(aThis.winObj.contentArea, aThis.aTableId, aThis.aComparison, aThis);
			aThis.grid = grid;
			grid.owner = aThis;	
			var auto = grid.prv.mAutoReload;
			if (auto > 0) {
				grid.prv.mTimeoutId = setTimeout(function() { grid.reload(); }, auto * 3000);
			}
		}
		
		function DataWindowPartThree_aThis_grid_onAfterRefresh() {

			if (this.grid.header.offsetWidth)
				this.grid.dom.style.width = this.grid.header.offsetWidth + 'px';
		
		};
		
		function DataWindowPartThree_grid_onbeforeload()
		{
			//setStyle(this.spinner, "visibility", "visible");
		};

		function DataWindowPartThree_grid_onafterload()
		{
			//setStyle(this.spinner, "visibility", "hidden");
			var g_ref = this;
			
			// calculate the pagecount
			this.prv.mPageCount = Math.ceil(this.selection.total /this.selection.range.length);
			
			this.refresh();
		
			// do it again if it is a first load
			if (this.firstLaunch) {
				this.refresh();
				this.firstLaunch = false;
			}
		
			/*
		
			// set the page total
			if(this.prv.mPageCount > 0){
				status.pagecont.inputcont.inputs.pagetotal.value = this.prv.mPageCount;
				status.pagecont.inputcont.inputs.pagenum.value = this.prv.mCurrentPage;	
			}
			else{
				status.pagecont.inputcont.inputs.pagetotal.value = 0;
				status.pagecont.inputcont.inputs.pagetotal.disabled = true;
				status.pagecont.inputcont.inputs.pagenum.value = 0;	
				status.pagecont.inputcont.inputs.pagenum.disabled = true;
			}
			
			// define the status bar actions
			status.buttons.statusButtonFirst.onclick = function(aEvent)
			{
				g_ref.goToPage(1);
			};
			status.buttons.statusButtonLast.onclick = function(aEvent)
			{
				g_ref.goToPage(g_ref.prv.mPageCount);
			};
			status.buttons.statusButtonPrev.onclick = function(aEvent)
			{
				g_ref.previousPage();
			};
			status.buttons.statusButtonNext.onclick = function(aEvent)
			{
				g_ref.nextPage();
			};
			status.pagecont.statusButtonGo.onclick = function(aEvent)
			{
				var status = getParentByClassName(this, "statusbar");
				g_ref.goToPage(parseInt(status.pagecont.inputcont.inputs.pagenum.value));
			};
			
			*/
			
			// assign new query id to the window
			if (this.owner.enableTabs) {
				if (this.owner.currentTab)
					if (!this.owner.currentTab.firstTab) {
						if (this.owner.currentTab.queryId)
							this.selection.queryId = this.owner.currentTab.queryId;
					} else {
						if (!this.owner.currentTab.queryId) {
							this.owner.currentTab.queryId = this.selection.queryId;
						} else {
							this.selection.queryId = this.owner.currentTab.queryId;
						}
					}
			}
			this.owner.currentQueryId = this.currentQueryId;	

			// place editor, ie7 bug fix
			if (browser.ie7)
				if ((this.owner) && (this.owner.editor) && (this.owner.editor.prv.mTearAway) ) {
					//setStyle(this.owner.editor.prv.mTearAway.dom, "display", "block");
					setStyle(this.owner.editor.prv.mTearAway.dom, "top", "29px");
					setStyle(this.owner.editor.prv.mTearAway.dom, "position", "absolute");
					//debugAlert ('top position:' + this.owner.editor.prv.mTearAway.dom.style.top);
				}
				
				if ((browser.safari) && (this.owner.target)) {
					
						this.owner.contentArea.style.width = aThis.target.offsetWidth + 'px';
						this.owner.contentArea.style.height = aThis.target.offsetHeight + 'px';				

				}		
				
		};

		function DataWindowPartThree_grid_grid_onrowdblclick(aRow)
		{

			if (this.owner.owner.table.fieldsDetail.length == 0)
				return false;
		
			var go = this.owner;
	
			if( aRow.recordId != -1 ){ //make sure to edit a valid record on the grid
				// for a grid with a selection
				if (go && go.selection) {
					// was already opened once
					var winObj = aThis.winObj;
					if (isDefined(winObj.editor) && isDefined(winObj.editor.record)) {
						winObj.editor.edit();
					} else {
						winObj.getEditor();
						setStyle(winObj.editor.getDOM(), "display", "block");
						var editor = winObj.editor;
						var auto = editor.prv.mAutoReload;
						if (auto > 0) {
							this.prv.mTimeoutId = setTimeout(function() { editor.reload(); }, auto * 3000);
						}
					}
					winObj.editor.pull(go.selection.tableId, aRow.recordId);
				}
			}
		};

		function DataWindowPartThree_aThis_winObj_onclose() {
			if (this.tbitem)
				this.tbitem.remove();

			// remove query	
			if (this.contentArea.grid.selection)
				if (this.contentArea.grid.selection.queryId)
					clearQuery (this.contentArea.grid.selection.queryId, false);

			// get rid of the grid
			if (this.contentArea.grid) {
				this.contentArea.grid.destroy();
				if (this.contentArea.grid) {
					this.contentArea.grid = null;
				}
			}
			
			if (this.editor)
				this.editor.destroy();			
			
			this.destroy();
				
			// delete this;			
		};

		function DataWindowPartThree_aThis_winObj_onsize() {
			this.contentArea.grid.refresh();
			if (this.mainToolbar)
				if (this.contentArea.offsetWidth < 800)
					setStyle (this.mainToolbar.prv.mDOM, 'width', '800px');
				else
					setStyle (this.mainToolbar.prv.mDOM, 'width', this.contentArea.offsetWidth + 'px');	
			};

		function DataWindowPartThree_aThis_winObj_onsizestop() {
			var sb = this.contentArea.grid.viewport.vscrollbar;
			//if (sb.visible) {
				this.contentArea.grid.viewport.onvscrollstop(sb.last);
				this.grid.refresh();
				this.tabsbar.refresh();
			//}
		};

		function DataWindowPartThree_aThis_winObj_getEditor()
		{
			if (this.editor)
				return this.editor;
		
			this.editor = new Editor();
			var dom = this.editor.getDOM();
			this.dom.style.zIndex = ++WindowManager.maxZIndex;
		//	alert('Editor = ' + this.dom.style.zIndex);
			this.dom.m.insertBefore(dom, this.toolbar);
		
			var w_off =  (this.dom.offsetWidth / 2) -
				(dom.offsetWidth / 2);
		
			setStyle(dom, "position", "absolute");
			setStyle(dom, "left", w_off + "px");
			
			this.editor.owner = this;
			
			var w_ref = this; // use this for when editor is detatched

			function DataWindowPartThree_aThis_winObj_getEditor_editor_onaftersave()
			{
				if (w_ref.contentArea.grid)
					w_ref.contentArea.grid.reload();
			};

			function DataWindowPartThree_aThis_winObj_getEditor_editor_onafterrefresh()
			{
				//setStyle(this.owner.editor.prv.mTearAway.dom, "display", "block");
				if ((this.owner) && (this.owner.editor)) {
					setStyle(this.prv.mTearAway.dom, "top", "29px");
					setStyle(this.prv.mTearAway.dom, "position", "absolute");
				}
			};			

			function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop(aEvent)
			{
				this.className = "tearaway_torn";
				var editor = this.owner;
				
				if (editor.owner) {
					var winObj = editor.owner;
					if (!winObj.editor)
						return;
					var dom = winObj.editor.prv.mDOM;
					var pos = getObjectPosition(this); // global coordinates

					var ti = new taskbarItem(taskbar);

					// make unique label based on table name
					i = 1;
					while ($('dax_taskbar_button' + winObj.titleBar.innerHTML + i) != null) {
						i++;
					}
					
					if (ti.dom) {
						ti.dom.id = 'dax_taskbar_button' + winObj.titleBar.innerHTML + i;

						ti.setLabel(STR['taskbar_edit'] + " " + winObj.titleBar.innerHTML + " " + i);
						ti.setIcon("editor");
						
						editor.tbitem = ti;
				
					}
				
					// create a handler for clicking
					var ref = this;
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_ti_dom_onclick() { 
						this.parent.setSelected (true, true);
						ref.onclick();
					};
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_dom_cancelBtn_onclick(aEvent) {
						if (ti.dom)
							ti.remove(); // remove taskbar item
						document.body.removeChild(this.parent.getDOM());
						this.parent.tbitem = null;	
						this.parent.destroy();
						if (!browser.ie)
							delete this.parent;
					};
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_onclick(aEvent) {
						if (WindowManager.active)
							WindowManager.active.deactivate();
							setStyle(this, "zIndex", ++WindowManager.maxZIndex);
							if ((ti) && (ti.dom)) {
								ti.setSelected(true,true);
							}
					};
	
					// function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_
					
					if (ti.dom) {
					
						ti.dom.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_ti_dom_onclick;
						
						setStyle (ti.dom, 'display', 'block');
						ti.setSelected (true, true);
						
						ti.parent.refresh();
						
					}
					
					// handler for closing
					// ticlose = getElementByClassName (ti.dom, 'dax_taskbar_close', true);
					// ticlose.cancelBtnRef = dom.cancelBtn;
					// ticlose.onclick = function () {this.cancelBtnRef.onclick(null); };
					
					
					// override cancel button
					dom.cancelBtn.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_dom_cancelBtn_onclick;
					
					// override the focusing
					this.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_onclick;
	
					// release
					winObj.deactivate();
					winObj.editor = null;
					this.parent.owner = null;

					// image uploader losses reference since upload.html gets reloaded
					editor.saveImageUploadState();
					
					// reposition
					document.body.insertBefore(this, null);

					// restore previous state
					editor.restoreImageUploadState();
					
					setStyle(this, "left", pos.x + "px");
					setStyle(this, "top", pos.y + "px");
				}
			};
			
			// function DataWindowPartThree_aThis_winObj_getEditor_
			
			this.editor.onaftersave = DataWindowPartThree_aThis_winObj_getEditor_editor_onaftersave;

			// place editor, ie7 bug fix
			if (browser.ie7) {
				this.editor.onafterrefresh = DataWindowPartThree_aThis_winObj_getEditor_editor_onafterrefresh;
			}
			
			// customize

			dom.ondragstop = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop;
			return this.editor;
		};

		function DataWindowPartThree_aThis_winObj_getCustomEditor()
		{
			if (this.editor)
				return this.editor;
		
			this.editor = new CustomEditor();
			var dom = this.editor.dom;
			this.dom.style.zIndex = ++WindowManager.maxZIndex;
		//	alert('Editor = ' + this.dom.style.zIndex);
			this.dom.m.insertBefore(dom, this.toolbar);
		
			var w_off =  (this.dom.offsetWidth / 2) -
				(dom.offsetWidth / 2);
		
			setStyle(dom, "position", "absolute");
			setStyle(dom, "left", w_off + "px");
			
			this.editor.owner = this;
			
			var w_ref = this; // use this for when editor is detatched
			
			this.editor.tearaway.expand();
			this.editor.construct();

			function DataWindowPartThree_aThis_winObj_getEditor_editor_onaftersave()
			{
				w_ref.contentArea.grid.reload();
			};

			function DataWindowPartThree_aThis_winObj_getEditor_editor_onafterrefresh()
			{
				//setStyle(this.owner.editor.prv.mTearAway.dom, "display", "block");
				if ((this.owner) && (this.owner.editor)) {
					setStyle(this.prv.mTearAway.dom, "top", "29px");
					setStyle(this.prv.mTearAway.dom, "position", "absolute");
				}
			};			

			function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop(aEvent)
			{
				this.className = "tearaway_torn";
				var editor = this.owner;
				
				if (editor.owner) {
					var winObj = editor.owner;
					if (!winObj.editor)
						return;
					var dom = winObj.editor.getDOM();
					var pos = getObjectPosition(this); // global coordinates

					var ti = new taskbarItem(taskbar);

					// make unique label based on table name
					i = 1;
					while ($('dax_taskbar_button' + winObj.titleBar.innerHTML + i) != null) {
						i++;
					}
					
					ti.dom.id = 'dax_taskbar_button' + winObj.titleBar.innerHTML + i;

					ti.setLabel(STR['taskbar_edit'] + " " + winObj.titleBar.innerHTML + " " + i);
					ti.setIcon("editor");
					
					editor.tbitem = ti;
				
					// create a handler for clicking
					var ref = this;
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_ti_dom_onclick() { 
						this.parent.setSelected (true, true);
						ref.onclick();
					};
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_dom_cancelBtn_onclick(aEvent) {
						ti.remove(); // remove taskbar item
						document.body.removeChild(this.parent.getDOM());
						this.parent.tbitem = null;	
						this.parent.destroy();
						if (!browser.ie)
							delete this.parent;
					};
					
					function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_onclick(aEvent) {
						if (WindowManager.active)
							WindowManager.active.deactivate();
							setStyle(this, "zIndex", ++WindowManager.maxZIndex);
							if (ti) {
								ti.setSelected(true,true);
							}
					};
	
					// function DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_
					
					ti.dom.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_ti_dom_onclick;
					
					setStyle (ti.dom, 'display', 'block');
					ti.setSelected (true, true);
					
					ti.parent.refresh();
					
					// handler for closing
					// ticlose = getElementByClassName (ti.dom, 'dax_taskbar_close', true);
					// ticlose.cancelBtnRef = dom.cancelBtn;
					// ticlose.onclick = function () {this.cancelBtnRef.onclick(null); };
					
					
					// override cancel button
					dom.cancelBtn.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_dom_cancelBtn_onclick;
					
					// override the focusing
					this.onclick = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop_onclick;
	
					// release
					winObj.deactivate();
					winObj.editor = null;
					this.parent.owner = null;
					
					// reposition
					document.body.insertBefore(this, null);
					setStyle(this, "left", pos.x + "px");
					setStyle(this, "top", pos.y + "px");
				}
			};
			
			// function DataWindowPartThree_aThis_winObj_getEditor_
			
			this.editor.onaftersave = DataWindowPartThree_aThis_winObj_getEditor_editor_onaftersave;

			// place editor, ie7 bug fix
			if (browser.ie7) {
				this.editor.onafterrefresh = DataWindowPartThree_aThis_winObj_getEditor_editor_onafterrefresh;
			}
			
			// customize

			dom.ondragstop = DataWindowPartThree_aThis_winObj_getEditor_dom_ondragstop;
			return this.editor;
		};

		
		function DataWindowPartThree_aThis_customize(aToolbar, aTaskbar, aStatusbar, aEditor) {
			if (!aToolbar)
				this.toolbar.style.display = 'none';
			else
				this.toolbar.style.display = 'block';

			if (!aTaskbar) {
				this.tabsbar.dom.parentNode.style.display = 'none';
				this.enableTabs = false;
			} else {
				this.tabsbar.dom.parentNode.style.display = 'block';
				this.enableTabs = true;
			}
			
			if (!aStatusbar)
				this.status.style.display = 'none';
			else
				this.status.style.display = 'block';

				
			function DataWindowPartThree_aThis_customize_empty(){};
			
			function DataWindowPartThree_aThis_customize_grid_grid_onrowdblclick(aRow)
			{
				
				var go = this.owner;
				
				if( aRow.recordId != -1 ){ //make sure to edit a valid record on the grid
					// for a grid with a selection
					if (go && go.selection) {
					
						winObj = this.owner.owner;
					
						// was already opened once
						if (isDefined(winObj.editor) && isDefined(winObj.editor.record)) {
							winObj.editor.edit();
						} else {
							winObj.getEditor();
							setStyle(winObj.editor.getDOM(), "display", "block");
							var editor = winObj.editor;
							var auto = editor.prv.mAutoReload;
							if (auto > 0) {
								this.prv.mTimeoutId = setTimeout(function() { editor.reload(); }, auto * 3000);
							}
						}
						winObj.editor.pull(go.selection.tableId, aRow.recordId);
					}
				}
			};			

			// function DataWindowPartThree_aThis_customize_
				
			if (!aEditor) {
				this.grid.grid.onrowdblclick = DataWindowPartThree_aThis_customize_empty;
			} else {
					// override the grid's double click
				this.grid.grid.onrowdblclick = DataWindowPartThree_aThis_customize_grid_grid_onrowdblclick;
			}			
				
			this.resize(null, null, true);
		};
		
		function DataWindowPartThree_hideColumns(colArray)
		{
			this.grid.hideColumnsArray = colArray.slice();
		
		}

		function DataWindowPartThree_showColumns(colArray)
		{
			this.grid.showColumnsArray = colArray.slice();
		
		}
		
		// function DataWindowPartThree_
		
		aThis.hideColumns = DataWindowPartThree_hideColumns;
		aThis.showColumns = DataWindowPartThree_showColumns;
		
		aThis.grid.onAfterRefresh = DataWindowPartThree_aThis_grid_onAfterRefresh;
	
		// override any GridObject events we need
		grid.onbeforeload = DataWindowPartThree_grid_onbeforeload;
		
		grid.onafterload = DataWindowPartThree_grid_onafterload;
		
		// override the grid's double click
		grid.grid.onrowdblclick = DataWindowPartThree_grid_grid_onrowdblclick;
		
	
		/*
	
		// override grid sort
		this.sort = function(aFieldId, aIsAscending)
		{
			var direction = aIsAscending ? "asc" : "desc";
			var url = connection.command(DB.SORT) + "&tableid="+this.selection.tableId+
				"&fieldid="+aFieldId+"&direction="+direction+"&queryid="+
				this.selection.queryId;

			
			var http_request = getXMLHttpRequest();
			if (http_request) {
				var this_ref = this;
				
				debugAlert('<b>Grid:</b>'+'<a href="'+url+'" target="_blank">'+url+'</a>');
				
				http_request.onreadystatechange = function() {this_ref.onsort(http_request);};
				http_request.open("GET", url, true);
		  	  	http_request.send(null);
		  	  				
		  	  	this.onbeforeload();
			}
			
		};		
	
		*/
		
		aThis.winObj.onclose = DataWindowPartThree_aThis_winObj_onclose;
		
		// propagate the window event
		aThis.winObj.onsize = DataWindowPartThree_aThis_winObj_onsize;
		
		aThis.winObj.onsizestop = DataWindowPartThree_aThis_winObj_onsizestop;

		// set minimum sizes
		//winObj.size (425, 175);
		aThis.winObj.minimumWidth = 425;
		aThis.winObj.minimumHeight = 175;
		
		// let's write a function dynamically
		aThis.winObj.getEditor = DataWindowPartThree_aThis_winObj_getEditor;
		aThis.winObj.getCustomEditor = DataWindowPartThree_aThis_winObj_getCustomEditor;

		// if location exists, insert the data window into the target element
		if (aThis.target) {
			var targetPosition = getObjectPosition (aThis.target);
			// position the window where target element is
			aThis.winObj.dom.style.top = targetPosition.y + 'px';
			aThis.winObj.dom.style.left = targetPosition.x + 'px';
			aThis.winObj.size (aThis.target.offsetWidth, aThis.target.offsetHeight, true);
			// hide window based doms
			aThis.winObj.dom.top.style.display = 'none';
			aThis.winObj.dom.btm.style.display = 'none';
			aThis.winObj.dom.l.style.display = 'none';
			aThis.winObj.dom.r.style.display = 'none';
		}
		
		// IE7 modification
		if (browser.ie7) {
			// so that viewport contents won't overspill
			grid.viewport.dom.style.position = 'absolute';
		}

		// customize appearance of the window by hiding or showing the elements
		aThis.customize = DataWindowPartThree_aThis_customize;
		
		aThis.tabsbar.refresh();
		aThis.onLoadSuccess();
		
	}
};
// DataWindow.prototype = new Window(); // 12/12 JF. Causing problems in DDW on IE
