var reportgroupnb = 0;
var currentreportpresetquerieslist = [];

function reporteditor (targetNode, reportName, mastertable, description, DashBoardFlag, XMLStruct, Platform) {
	this.reportName = reportName;
	this.targetNode = targetNode;
	this.description = description;
	
	// get template nodes
	this.nodes = {
		objects				: getTemplate('dax_report_objects'),
		presetqueries		: getTemplate('dax_report_presetqueries'),
		groups				: getTemplate('dax_report_groups'),
		container			: getTemplate('dax_report_container'),
		desktopstyles		: getTemplate('dax_report_desktopstyles'),
		iphonestyles		: getTemplate('dax_report_iphonestyles')
	}
	
	if (XMLStruct == null) {
		if (Platform == "Desktop") {
			this.platform = "Desktop";
			$('adminPropertiesStyles_DesktopPic').style.display = "block";
			$('adminPropertiesStyles_iphonePic').style.display = "none";
		}
		else {
			this.platform = "iPhone";
			$('adminPropertiesStyles_DesktopPic').style.display = "none";
			$('adminPropertiesStyles_iphonePic').style.display = "block";
		}
	}
		
	defaultstyle = {
		font				: "Times",
		size				: 11,
		color				: "#000000",
		align				: "center",
		backcolor			: "#FFFFFF"
	}
	
	this.structure = {
		mastertable			: mastertable,
		crosstab			: false,
		vmargin				: 50,
		hmargin				: 1,
		bordercolor			: "#333333",
		usechart			: false,
		
		reportHeader		: null,
		detailHeader		: null,
		groupHeader			: null,
		detail				: null,
		groupFooter			: null,
		detailFooter		: null,
		pageFooter			: null	
	}
	
	this.structure.reportHeader = {
		visible				: true,
		style				: defaultstyle,
		height				: 4,
		content				: new Array()
	}
	
	this.structure.pageHeader = {
		visible				: true,
		style				: defaultstyle,
		height				: 1,
		content				: new Array()
	}
	
	this.structure.detailHeader = {
		visible				: true,
		style				: defaultstyle,
		height				: 1,
		content				: new Array()
	}
	
	this.structure.groups = new Array();

	this.structure.detail = {
		visible				: true,
		style				: defaultstyle,
		altbackcolor		: "#FFFFFF",
		height				: 1,
		content				: new Array()
	}
	
	this.structure.detailFooter = {
		visible				: false,
		style				: defaultstyle,
		height				: 1,
		content				: new Array()
	}
	
	this.structure.pageFooter = {
		visible				: true,
		style				: defaultstyle,
		height				: 1,
		content				: new Array()
	}
	
	this.structure.reportFooter = {
		visible				: true,
		style				: defaultstyle,
		height				: 1,
		content				: new Array()
	}

	this.alternate_structure = {
		mastertable			: mastertable,
		crosstab			: false,
		vmargin				: 50,
		hmargin				: 1,
		bordercolor			: "#333333",
		
		reportHeader		: null,
		detailHeader		: null,
		groupHeader			: null,
		detail				: null,
		groupFooter			: null,
		detailFooter		: null,
		pageFooter			: null	
	}
	
	this.alternate_structure.reportHeader = {
		visible				: true,
		style				: defaultstyle,
		height				: 4,
		content				: new Array()
	}
	
	this.alternate_structure.pageHeader = {
		visible				: true,
		style				: defaultstyle,
		height				: 1,
		content				: new Array()
	}
	
	this.alternate_structure.detailHeader = {
		visible				: true,
		style				: defaultstyle,
		height				: 1,
		content				: new Array()
	}
	
	this.alternate_structure.groups = new Array();

	this.alternate_structure.detail = {
		visible				: true,
		style				: defaultstyle,
		altbackcolor		: "#FFFFFF",
		height				: 1,
		content				: new Array()
	}
	
	this.alternate_structure.detailFooter = {
		visible				: false,
		style				: defaultstyle,
		height				: 1,
		content				: new Array()
	}
	
	this.alternate_structure.pageFooter = {
		visible				: true,
		style				: defaultstyle,
		height				: 1,
		content				: new Array()
	}
	
	this.alternate_structure.reportFooter = {
		visible				: true,
		style				: defaultstyle,
		height				: 1,
		content				: new Array()
	}
	
	function dax_reporteditor_initialize() {
	
		if (DashBoardFlag) {
			this.nodes.report.size(3,2);
			this.nodes.alternatereport.size(3,2);

			this.zones = {
				reportHeader	: null,
				detailHeader	: 0,
				detail			: 1,
				detailFooter	: 2,
				pageFooter		: null,
				reportFooter	: null,
				groupHeader		: null,
				groupFooter		: null
			}

			this.structure.reportHeader.visible = false;
			this.structure.pageHeader.visible = false;
			this.structure.pageFooter.visible = false;
			this.structure.reportFooter.visible = false;

			this.alternate_structure.reportHeader.visible = false;
			this.alternate_structure.pageHeader.visible = false;
			this.alternate_structure.pageFooter.visible = false;
			this.alternate_structure.reportFooter.visible = false;
			
			$('dax_report_reportcontainer').style.width = "480px"
			$('dax_report_reportcontainer').style.height = "75px"
			$('dax_report_alternatereportcontainer').style.width = "480px"
			$('dax_report_alternatereportcontainer').style.height = "75px"
		}
		else {
			this.nodes.report.size(6,2);	

			this.zones = {
				reportHeader	: 0,
				detailHeader	: 1,
				detail			: 2,
				detailFooter	: 3,
				pageFooter		: 4,
				reportFooter	: 5,
				groupHeader		: null,
				groupFooter		: null
			}
		}

		this.setDefaultCursors = function(setting) {

			var thisgrid = "";
			var theothergrid = "";
		
			if (this.nodes.report.viewing_alternate_structure) {
				thisgrid = this.nodes.alternatereport;
				theothergrid = this.nodes.report;
			}
			else {
				thisgrid = this.nodes.report;
				theothergrid = this.nodes.alternatereport;
			}

			switch(setting) {
				case "default":

					thisgrid.getCell(0,0).style.cursor = "default"; // DH
					thisgrid.getCell(1+reportgroupnb,0).style.cursor = "pointer"; // D
					thisgrid.getCell(2+(2*reportgroupnb),0).style.cursor = "default"; // DF
				
					if (reportgroupnb>0) {
						thisgrid.getCell(0+reportgroupnb,0).style.cursor = "pointer"; //GH
						thisgrid.getCell(1+(2*reportgroupnb),0).style.cursor = "default"; //GF
					}
					
					for (var j = 1; j <= this.structure.detailHeader.content.length; j++) {
						thisgrid.getCell(0,j).style.cursor = "context-menu"; // DH
						thisgrid.getCell(1+reportgroupnb,j).style.cursor = "context-menu"; // D
						if (thisgrid.getCellValue(2 + (2 * reportgroupnb), j) == "") {
							thisgrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "default"; // DF
						}
						else {
							thisgrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "context-menu"; // DF
						}
								
						if (reportgroupnb>0) {
							thisgrid.getCell(0+reportgroupnb,j).style.cursor = "context-menu"; //GH
							if (thisgrid.getCellValue(1 + (2 * reportgroupnb), j) == "") {
								thisgrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "default"; //GF
							}
							else {
								thisgrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "context-menu"; //GF
							}
						}
						
					}
					
					// Now the empty column
					var j = this.structure.detailHeader.content.length+1;
					
					thisgrid.getCell(0,j).style.cursor = "default"; // DH
					thisgrid.getCell(1+reportgroupnb,j).style.cursor = "default"; // D
					if (thisgrid.getCellValue(2 + (2 * reportgroupnb), j) == "") {
						thisgrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "default"; // DF
					}
					else {
						thisgrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "default"; // DF
					}
							
					if (reportgroupnb>0) {
						thisgrid.getCell(0+reportgroupnb,j).style.cursor = "context-menu"; //GH
						if (thisgrid.getCellValue(1 + (2 * reportgroupnb), j) == "") {
							thisgrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "default"; //GF
						}
						else {
							thisgrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "default"; //GF
						}
					}
					
					// Same for alternate grid
					
					theothergrid.getCell(0,0).style.cursor = "default"; // DH
					theothergrid.getCell(1+reportgroupnb,0).style.cursor = "pointer"; // D
					theothergrid.getCell(2+(2*reportgroupnb),0).style.cursor = "default"; // DF
				
					if (reportgroupnb>0) {
						theothergrid.getCell(0+reportgroupnb,0).style.cursor = "pointer"; //GH
						theothergrid.getCell(1+(2*reportgroupnb),0).style.cursor = "default"; //GF
					}
					
					for (var j = 1; j <= this.structure.detailHeader.content.length; j++) {
						theothergrid.getCell(0,j).style.cursor = "context-menu"; // DH
						theothergrid.getCell(1+reportgroupnb,j).style.cursor = "context-menu"; // D
						if (theothergrid.getCellValue(2 + (2 * reportgroupnb), j) == "") {
							theothergrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "default"; // DF
						}
						else {
							theothergrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "context-menu"; // DF
						}
								
						if (reportgroupnb>0) {
							theothergrid.getCell(0+reportgroupnb,j).style.cursor = "context-menu"; //GH
							if (theothergrid.getCellValue(1 + (2 * reportgroupnb), j) == "") {
								theothergrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "default"; //GF
							}
							else {
								theothergrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "context-menu"; //GF
							}
						}
						
					}
					
					// Now the empty column
					var j = this.structure.detailHeader.content.length+1;
					
					theothergrid.getCell(0,j).style.cursor = "default"; // DH
					theothergrid.getCell(1+reportgroupnb,j).style.cursor = "default"; // D
					if (theothergrid.getCellValue(2 + (2 * reportgroupnb), j) == "") {
						theothergrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "default"; // DF
					}
					else {
						theothergrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "default"; // DF
					}
							
					if (reportgroupnb>0) {
						theothergrid.getCell(0+reportgroupnb,j).style.cursor = "context-menu"; //GH
						if (theothergrid.getCellValue(1 + (2 * reportgroupnb), j) == "") {
							theothergrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "default"; //GF
						}
						else {
							theothergrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "default"; //GF
						}
					}
					
					
					break;
				case "droppingField":
				
					// Left row titles first:
					thisgrid.getCell(0,0).style.cursor = "no-drop"; // DH
					thisgrid.getCell(1+reportgroupnb,0).style.cursor = "no-drop"; // D
					thisgrid.getCell(2+(2*reportgroupnb),0).style.cursor = "no-drop"; // DF
					
					// Left row titles for groups
					if (reportgroupnb>0) {
						thisgrid.getCell(0+reportgroupnb,0).style.cursor = "no-drop"; //GH
						thisgrid.getCell(1+(2*reportgroupnb),0).style.cursor = "no-drop"; //GF
					}
					
					// Now rest of the grid
					for (var j = 1; j <= this.structure.detailHeader.content.length+1; j++) {
						
						thisgrid.getCell(0,j).style.cursor = "copy"; // DH
						thisgrid.getCell(1+reportgroupnb,j).style.cursor = "copy"; // D
						// Special pointer if formula is empty
						thisgrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "no-drop"; // DF
						
						// Now group header and footer		
						if (reportgroupnb>0) {
							thisgrid.getCell(0+reportgroupnb,j).style.cursor = "no-drop"; //GH
							thisgrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "no-drop"; //GF
						}
						
					}
					break;

				case "droppingFormula":
				
					// Left row titles first:
					thisgrid.getCell(0,0).style.cursor = "no-drop"; // DH
					thisgrid.getCell(1+reportgroupnb,0).style.cursor = "no-drop"; // D
					thisgrid.getCell(2+(2*reportgroupnb),0).style.cursor = "no-drop"; // DF
					
					// Left row titles for groups
					if (reportgroupnb>0) {
						thisgrid.getCell(0+reportgroupnb,0).style.cursor = "no-drop"; //GH
						thisgrid.getCell(1+(2*reportgroupnb),0).style.cursor = "no-drop"; //GF
					}
					
					// Now rest of the grid
					for (var j = 1; j <= this.structure.detailHeader.content.length+1; j++) {
						
						thisgrid.getCell(0,j).style.cursor = "no-drop"; // DH
						thisgrid.getCell(1+reportgroupnb,j).style.cursor = "no-drop"; // D
						// Special pointer if formula is empty
						thisgrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "copy"; // DF
						
						// Now group header and footer		
						if (reportgroupnb>0) {
							thisgrid.getCell(0+reportgroupnb,j).style.cursor = "no-drop"; //GH
							thisgrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "copy"; //GF
						}
						
					}

					// Now the empty column
					var j = this.structure.detailHeader.content.length+1;
					
					thisgrid.getCell(0,j).style.cursor = "no-drop"; // DH
					thisgrid.getCell(1+reportgroupnb,j).style.cursor = "no-drop"; // D
					if (thisgrid.getCellValue(2 + (2 * reportgroupnb), j) == "") {
						thisgrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "no-drop"; // DF
					}
					else {
						thisgrid.getCell(2 + (2 * reportgroupnb), j).style.cursor = "no-drop"; // DF
					}
							
					if (reportgroupnb>0) {
						thisgrid.getCell(0+reportgroupnb,j).style.cursor = "no-drop"; //GH
						if (thisgrid.getCellValue(1 + (2 * reportgroupnb), j) == "") {
							thisgrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "no-drop"; //GF
						}
						else {
							thisgrid.getCell(1 + (2 * reportgroupnb), j).style.cursor = "no-drop"; //GF
						}
					}
					break;



			}
			
		}
		
		
		this.nodes.report.zones = this.zones;
		this.nodes.report.structure = this.structure;
		this.nodes.report.alternate_structure = this.alternate_structure;
		
		// Set Zone Title Column to 120
		this.nodes.report.setColumnWidth(0, 120);
		this.nodes.alternatereport.setColumnWidth(0, 120);
		
		// Set Blank Field Column to 300
		this.nodes.report.setColumnWidth( 1 , this.nodes.report.viewport.dom.container.offsetWidth);
		this.nodes.alternatereport.setColumnWidth( 1 , this.nodes.report.viewport.dom.container.offsetWidth);
								
		if (!DashBoardFlag) {
			this.nodes.report.setCellValue(this.zones.reportHeader,0,"Report Header");
			this.nodes.alternatereport.setCellValue(this.zones.reportHeader,0,"Report Header");
		}
		this.nodes.report.setCellValue(this.zones.detailHeader,0,STR['dash_de_zone_dh']);
		this.nodes.alternatereport.setCellValue(this.zones.detailHeader,0,STR['dash_de_zone_dh']);
		this.nodes.report.setCellValue(this.zones.detail,0,STR['dash_de_zone_d']);
		this.nodes.alternatereport.setCellValue(this.zones.detail,0,STR['dash_de_zone_d']);
		this.nodes.report.setCellValue(this.zones.detailFooter,0,STR['dash_de_zone_df']);
		this.nodes.alternatereport.setCellValue(this.zones.detailFooter,0,STR['dash_de_zone_df']);
		if (!DashBoardFlag) {
			this.nodes.report.setCellValue(this.zones.pageFooter,0,"Page Footer");
			this.nodes.alternatereport.setCellValue(this.zones.pageFooter,0,"Page Footer");
		}
		if (!DashBoardFlag) {
			this.nodes.report.setCellValue(this.zones.reportFooter,0,"Report Footer");
			this.nodes.alternatereport.setCellValue(this.zones.reportFooter,0,"Report Footer");
		}
			

		if (!DashBoardFlag) {
			this.nodes.report.setBlockRow(this.zones.reportHeader, true, 4);
			this.nodes.report.setBlockRow(this.zones.pageFooter, true, 1);
			this.nodes.report.setBlockRow(this.zones.reportFooter, true, 4);
			this.nodes.alternatereport.setBlockRow(this.zones.reportHeader, true, 4);
			this.nodes.alternatereport.setBlockRow(this.zones.pageFooter, true, 1);
			this.nodes.alternatereport.setBlockRow(this.zones.reportFooter, true, 4);
		}
								
		this.nodes.report.setHeaderRows(0, 0, false);
		this.nodes.report.setHeaderRows(this.zones.detailHeader, this.zones.detailHeader, true);
		this.nodes.report.setAltRowStyle(0, null, false, true);
		this.nodes.report.allowMultipleSelection(false);
		this.nodes.report.allowResize(false, true);
		this.nodes.alternatereport.setHeaderRows(0, 0, false);
		this.nodes.alternatereport.setHeaderRows(this.zones.detailHeader, this.zones.detailHeader, true);
		this.nodes.alternatereport.setAltRowStyle(0, null, false, true);
		this.nodes.alternatereport.allowMultipleSelection(false);
		this.nodes.alternatereport.allowResize(false, true);

		// Apply the style
		if (DashBoardFlag) {
		
			$('dax_report_reportcontainer').className += ' dax_dashboard'
			$('dax_report_reportcontainer').style.fontSize = '10pt';
			this.nodes.report.setStyleClass(this.zones.detailHeader, null , "detailheader", "detailheader");
			this.nodes.report.setStyleClass(this.zones.detail, null , "detailalt", "detailalt");
			this.nodes.report.setStyleClass(this.zones.detailFooter, null , "detailfooter", "detailfooter");
			this.nodes.report.setStyleClass(null, 0 , "header", "header");

			this.nodes.report.setSelectedStyleClass(this.zones.detailHeader, null , "detailheader_highlight", "detailheader_highlight");
			this.nodes.report.setSelectedStyleClass(this.zones.detail, null , "detailalt_highlight", "detailalt_highlight");
			this.nodes.report.setSelectedStyleClass(this.zones.detailFooter, null , "detailfooter_highlight", "detailfooter_highlight");
			this.nodes.report.setSelectedStyleClass(null, 0 , "header", "header");
		
			//this.nodes.report.getCell(1, 0).style.borderRight = "1px solid #FFFFFF";
			
			$('dax_report_alternatereportcontainer').className += ' dax_dashboard'
			$('dax_report_alternatereportcontainer').style.fontSize = '10pt';
			this.nodes.alternatereport.setStyleClass(this.zones.detailHeader, null , "detailheader", "detailheader");
			this.nodes.alternatereport.setStyleClass(this.zones.detail, null , "detailalt", "detailalt");
			this.nodes.alternatereport.setStyleClass(this.zones.detailFooter, null , "detailfooter", "detailfooter");
			this.nodes.alternatereport.setStyleClass(null, 0 , "header", "header");

			this.nodes.alternatereport.setSelectedStyleClass(this.zones.detailHeader, null , "detailheader_highlight", "detailheader_highlight");
			this.nodes.alternatereport.setSelectedStyleClass(this.zones.detail, null , "detailalt_highlight", "detailalt_highlight");
			this.nodes.alternatereport.setSelectedStyleClass(this.zones.detailFooter, null , "detailfooter_highlight", "detailfooter_highlight");
			this.nodes.alternatereport.setSelectedStyleClass(null, 0 , "header", "header");
		
			//this.nodes.alternatereport.getCell(1, 0).style.borderRight = "1px solid #FFFFFF";
			
		}
				
		this.nodes.report.activate();
		this.nodes.alternatereport.activate();
		
		
		function report_onCellClick(row, column) {
			
			myReport.nodes.report.setSelected(null, null, false);
			myReport.nodes.alternatereport.setSelected(null, null, false);
						
			if ((row > myReport.zones.detailHeader) & (row <= myReport.zones.detailFooter)) {
				
				$('adminPropertiesIndicators_NotAvailable').style.display = "none";
				$('adminPropertiesIndicatorsNew').style.display = "block";
				$('adminPropertiesIndicatorFiltersList').style.display = "block";	

				$('AdminPropertiesIndicators_Filter_List').innerHTML = "";
				
				var reportstructure = "";
				var thisgrid = "";

				if (myReport.nodes.report.viewing_alternate_structure) {
					reportstructure = myReport.nodes.report.alternate_structure;
					thisgrid = myReport.nodes.alternatereport;
				}
				else {
					reportstructure = myReport.nodes.report.structure;
					thisgrid = myReport.nodes.report;
				}
				
				if  (thisgrid.getCellValue(row,column) == "") {
					$('adminPropertiesFormatting_NotAvailable').style.display = "block";
					$('adminPropertiesFormatting_Boolean').style.display = "none";
					$('adminPropertiesFormatting_Numeric').style.display = "none";
					$('adminPropertiesFormatting_Date').style.display = "none";
					$('adminPropertiesFormatting_Time').style.display = "none";				
					$('adminPropertiesIPhoneApps_NotAvailable').style.display = "block";				
					$('adminPropertiesIPhoneApps_Options').style.display = "none";	
					$('adminPropertiesDesktopApps_Options').style.display = "none";				
					$('adminPropertiesIndicators_NotAvailable').style.display = "block";
					$('adminPropertiesIndicatorsNew').style.display = "none";
					$('adminPropertiesIndicatorFiltersList').style.display = "none";	
					
					return false;			
				}

				if (row == myReport.zones.detail) {
					thiscellstructure = reportstructure.detail.content[column - 1];
					
					$('adminPropertiesStyles_Header').style.display = "none";
					$('adminPropertiesStyles_Detail').style.display = "block";
					$('adminPropertiesStyles_Formula').style.display = "none";
					$('adminPropertiesStyles_GroupHeader').style.display = "none";
					$('adminPropertiesStyles_NoHeader').style.display = "none";

					switch (thiscellstructure.align) {
						case "left":
							$('adminPropertiesStyles_DetailAlign').selectedIndex = 0;
							break;
						case "center":
							$('adminPropertiesStyles_DetailAlign').selectedIndex = 1;
							break;
						case "right":
							$('adminPropertiesStyles_DetailAlign').selectedIndex = 2;
							break;
							
					}
					
				}
				else {
					
					if (row < myReport.zones.detail) {

						$('adminPropertiesStyles_Header').style.display = "none";
						$('adminPropertiesStyles_Detail').style.display = "none";
						$('adminPropertiesStyles_Formula').style.display = "none";
						$('adminPropertiesStyles_GroupHeader').style.display = "block";
						$('adminPropertiesStyles_NoHeader').style.display = "none";
						$('adminPropertiesIPhoneApps_NotAvailable').style.display = "block";				
						$('adminPropertiesIPhoneApps_Options').style.display = "none";	
						$('adminPropertiesDesktopApps_Options').style.display = "none";				
						
						thiscellstructure = reportstructure.groups[reportgroupnb-1];
						$('adminPropertiesStyles_GroupHeaderText').value = thiscellstructure.headerformula;
						switch (thiscellstructure.align) {
							case "left":
								$('adminPropertiesStyles_GroupHeaderAlign').selectedIndex = 0;
								break;
							case "center":
								$('adminPropertiesStyles_GroupHeaderAlign').selectedIndex = 1;
								break;
							case "right":
								$('adminPropertiesStyles_GroupHeaderAlign').selectedIndex = 2;
								break;
								
						}
						
/*						
						if (row < myReport.zones.detailFooter) 
							thiscellstructure = reportstructure.groups[myReport.zones.detailFooter - row - 1].footer[column - 1];
						else 
							thiscellstructure = reportstructure.detailFooter.content[column - 1];
						
						$('adminPropertiesStyles_FormulaText').value = thiscellstructure.formula;
						
						switch (thiscellstructure.align) {
							case "left":
								$('adminPropertiesStyles_FormulaAlign').selectedIndex = 0;
								break;
							case "center":
								$('adminPropertiesStyles_FormulaAlign').selectedIndex = 1;
								break;
							case "right":
								$('adminPropertiesStyles_FormulaAlign').selectedIndex = 2;
								break;
								
						}
*/						
					}
					else {
					
						$('adminPropertiesStyles_Header').style.display = "none";
						$('adminPropertiesStyles_Detail').style.display = "none";
						$('adminPropertiesStyles_Formula').style.display = "block";
						$('adminPropertiesStyles_GroupHeader').style.display = "none";
						$('adminPropertiesStyles_NoHeader').style.display = "none";
						
						if (row < myReport.zones.detailFooter) 
							thiscellstructure = reportstructure.groups[myReport.zones.detailFooter - row - 1].footer[column - 1];
						else 
							thiscellstructure = reportstructure.detailFooter.content[column - 1];
						
						$('adminPropertiesStyles_FormulaText').value = thiscellstructure.formula;
						
						switch (thiscellstructure.align) {
							case "left":
								$('adminPropertiesStyles_FormulaAlign').selectedIndex = 0;
								break;
							case "center":
								$('adminPropertiesStyles_FormulaAlign').selectedIndex = 1;
								break;
							case "right":
								$('adminPropertiesStyles_FormulaAlign').selectedIndex = 2;
								break;
								
						}
					}
				}						
				
				var fieldtype = "longint";
				
				if (row >= myReport.zones.detail) {
					// Update Property Inspector	
					if (thiscellstructure.indicators.length > 0) 
						$('AdminPropertiesIndicators_Filter_None').style.display = 'none';
					else 
						$('AdminPropertiesIndicators_Filter_None').style.display = 'block';
					
					for (var i = 0; i < thiscellstructure.indicators.length; i++) 
						$('AdminPropertiesIndicators_Filter_List').innerHTML += "<center><br><div style='display: inline; position: relative; top: -2px;' class='tab_close tab_close_on' onmousedown='deleteIndicator(" + i + "," + row + "," + column + ");return false;'></div><b>" + thiscellstructure.indicators[i].criteriatext + "</b> " + thiscellstructure.indicators[i].value + " <b>" + thiscellstructure.indicators[i].colortext + "</b></center>";
					
					$('adminPropertiesIPhoneApps_NotAvailable').style.display = "none";
					if (myReport.platform == "iPhone") {
						$('adminPropertiesIPhoneApps_Options').style.display = "block";
						$('adminPropertiesDesktopApps_Options').style.display = "none";
					}
					else {
						$('adminPropertiesIPhoneApps_Options').style.display = "none";
						$('adminPropertiesDesktopApps_Options').style.display = "block";
					}
					if (thiscellstructure.iPhoneApp == "") {
						if (myReport.platform == "iPhone") 
							$('adminPropertiesIPhoneApps_Options_Popup').options.selectedIndex = 0;
						else 
							$('adminPropertiesDesktopApps_Options_Popup').options.selectedIndex = 0;
					}
					else {
						if (myReport.platform == "iPhone") {
							for (var t = 0; t < $('adminPropertiesIPhoneApps_Options_Popup').options.length; t++) {
								if ($('adminPropertiesIPhoneApps_Options_Popup').options[t].value == thiscellstructure.iPhoneApp) 
									$('adminPropertiesIPhoneApps_Options_Popup').options.selectedIndex = t;
							}
						}
						else {
							for (var t = 0; t < $('adminPropertiesDesktopApps_Options_Popup').options.length; t++) {
								if ($('adminPropertiesDesktopApps_Options_Popup').options[t].value == thiscellstructure.iPhoneApp) 
									$('adminPropertiesDesktopApps_Options_Popup').options.selectedIndex = t;
							}
						}
					}

					dax_bridge.tables[mastertable].cacheFields();
					if (row == myReport.zones.detail)
						for (var i = 0; i < dax_bridge.tables[mastertable].fields.length; i++)
							if (dax_bridge.tables[mastertable].fields[i].fieldid == reportstructure.detail.content[column-1].fieldid)
								fieldtype = dax_bridge.tables[mastertable].fields[i].fieldtype;

				}
				else {
					$('adminPropertiesIndicators_NotAvailable').style.display = "block";
					$('adminPropertiesIndicatorsNew').style.display = "none";
					$('adminPropertiesIndicatorFiltersList').style.display = "none";	
				
					dax_bridge.tables[mastertable].cacheFields();
					for (var i = 0; i < dax_bridge.tables[mastertable].fields.length; i++)
						if (dax_bridge.tables[mastertable].fields[i].fieldid == reportstructure.groups[reportgroupnb-1].fieldid)
							fieldtype = dax_bridge.tables[mastertable].fields[i].fieldtype;

				}	
				
				
						
				switch(fieldtype) {
					
					case ("integer"):
					case ("longint"):
					case ("real"):
						$('adminPropertiesFormatting_NotAvailable').style.display = "none";
						$('adminPropertiesFormatting_Boolean').style.display = "none";
						$('adminPropertiesFormatting_Numeric').style.display = "block";
						$('adminPropertiesFormatting_Date').style.display = "none";
						$('adminPropertiesFormatting_Time').style.display = "none";
						
						if (thiscellstructure.format != "")
							$('adminPropertiesFormatting_Numeric_Format').options.selectedIndex = thiscellstructure.format;
						else
							$('adminPropertiesFormatting_Numeric_Format').options.selectedIndex = 0;
							
						break;
						
					case ("date"):
						$('adminPropertiesFormatting_NotAvailable').style.display = "none";
						$('adminPropertiesFormatting_Boolean').style.display = "none";
						$('adminPropertiesFormatting_Numeric').style.display = "none";
						$('adminPropertiesFormatting_Date').style.display = "block";
						$('adminPropertiesFormatting_Time').style.display = "none";

						if (thiscellstructure.format != "")
							$('adminPropertiesFormatting_Date_Format').options.selectedIndex = thiscellstructure.format;
						else
							$('adminPropertiesFormatting_Date_Format').options.selectedIndex = 0;
	
						break;
						
					case ("time"):
						$('adminPropertiesFormatting_NotAvailable').style.display = "none";
						$('adminPropertiesFormatting_Boolean').style.display = "none";
						$('adminPropertiesFormatting_Numeric').style.display = "none";
						$('adminPropertiesFormatting_Date').style.display = "none";
						$('adminPropertiesFormatting_Time').style.display = "block";

						if (thiscellstructure.format != "")
							$('adminPropertiesFormatting_Time_Format').options.selectedIndex = thiscellstructure.format;
						else
							$('adminPropertiesFormatting_Time_Format').options.selectedIndex = 0;
	
						break;
						
					case("boolean"):	
						$('adminPropertiesFormatting_NotAvailable').style.display = "none";
						$('adminPropertiesFormatting_Boolean').style.display = "block";
						$('adminPropertiesFormatting_Numeric').style.display = "none";
						$('adminPropertiesFormatting_Date').style.display = "none";
						$('adminPropertiesFormatting_Time').style.display = "none";

						if (thiscellstructure.format != "")
							$('adminPropertiesFormatting_Boolean_Format').options.selectedIndex = thiscellstructure.format;
						else
							$('adminPropertiesFormatting_Boolean_Format').options.selectedIndex = 0;
	
						break;
					
					default:
						$('adminPropertiesFormatting_NotAvailable').style.display = "block";
						$('adminPropertiesFormatting_Boolean').style.display = "none";
						$('adminPropertiesFormatting_Numeric').style.display = "none";
						$('adminPropertiesFormatting_Date').style.display = "none";
						$('adminPropertiesFormatting_Time').style.display = "none";
					
				}
				
				do_showDashboard($('adminPropertyInspector'), '2');
				
				return true;

			}
			else {
				$('adminPropertiesStyles_Header').style.display = "none";
				$('adminPropertiesStyles_Detail').style.display = "none";
				$('adminPropertiesStyles_Formula').style.display = "none";
				$('adminPropertiesStyles_GroupHeader').style.display = "none";
				$('adminPropertiesStyles_NoHeader').style.display = "block";

				$('adminPropertiesFormatting_NotAvailable').style.display = "block";
				$('adminPropertiesFormatting_Boolean').style.display = "none";
				$('adminPropertiesFormatting_Numeric').style.display = "none";
				$('adminPropertiesFormatting_Date').style.display = "none";
				$('adminPropertiesFormatting_Time').style.display = "none";				
				$('adminPropertiesIPhoneApps_NotAvailable').style.display = "block";				
				$('adminPropertiesIPhoneApps_Options').style.display = "none";	
				$('adminPropertiesDesktopApps_Options').style.display = "none";				
				$('adminPropertiesIndicators_NotAvailable').style.display = "block";
				$('adminPropertiesIndicatorsNew').style.display = "none";
				$('adminPropertiesIndicatorFiltersList').style.display = "none";	
				
				return false;			
			}
			
		}		

		function report_onColumnClick(column) {
			myReport.nodes.report.setSelected(null, null, false);
			myReport.nodes.alternatereport.setSelected(null, null, false);
			
			$('adminPropertiesFormatting_NotAvailable').style.display = "block";
			$('adminPropertiesFormatting_Boolean').style.display = "none";
			$('adminPropertiesFormatting_Numeric').style.display = "none";
			$('adminPropertiesFormatting_Date').style.display = "none";
			$('adminPropertiesFormatting_Time').style.display = "none";
			$('adminPropertiesIPhoneApps_NotAvailable').style.display = "block";				
			$('adminPropertiesIPhoneApps_Options').style.display = "none";				
			$('adminPropertiesDesktopApps_Options').style.display = "none";				
			$('adminPropertiesIndicators_NotAvailable').style.display = "block";
			$('adminPropertiesIndicatorsNew').style.display = "none";
			$('adminPropertiesIndicatorFiltersList').style.display = "none";	
			
			if ((column > 0) & (column < myReport.nodes.report.cols.length-1)) {
				$('adminPropertiesStyles_Header').style.display = "block";
				$('adminPropertiesStyles_Detail').style.display = "none";
				$('adminPropertiesStyles_Formula').style.display = "none";
				$('adminPropertiesStyles_GroupHeader').style.display = "none";
				$('adminPropertiesStyles_NoHeader').style.display = "none";
				$('adminPropertiesStyles_ColumnWidth').value = this.getColumnWidth(column);
				
				var reportstructure = "";
				var thisgrid = "";
				
				if (myReport.nodes.report.viewing_alternate_structure) {
					reportstructure = myReport.nodes.report.alternate_structure;
					thisgrid = myReport.nodes.alternatereport;
				}
				else {
					reportstructure = myReport.nodes.report.structure;
					thisgrid = myReport.nodes.report;
				}
				
				$('adminPropertiesStyles_HeaderText').value = reportstructure.detailHeader.content[column - 1].value;
				
				switch (reportstructure.detailHeader.content[column - 1].align) {
					case "left":
						$('adminPropertiesStyles_HeaderAlign').selectedIndex = 0;
						break;
					case "center":
						$('adminPropertiesStyles_HeaderAlign').selectedIndex = 1;
						break;
					case "right":
						$('adminPropertiesStyles_HeaderAlign').selectedIndex = 2;
						break;
						
				}
				
				do_showDashboard($('adminPropertyInspector'), '2');
				
				return true;
			}
			else {
				$('adminPropertiesStyles_Header').style.display = "none";
				$('adminPropertiesStyles_Detail').style.display = "none";
				$('adminPropertiesStyles_Formula').style.display = "none";
				$('adminPropertiesStyles_GroupHeader').style.display = "none";
				$('adminPropertiesStyles_NoHeader').style.display = "block";
				return false;
			}
		}
		this.nodes.report.onColumnClick = report_onColumnClick;
		this.nodes.alternatereport.onColumnClick = report_onColumnClick;

		function report_onColumnResizeStop(column, width) { 
			var reportstructure = "";
			var thisgrid = "";
		
			if (myReport.nodes.report.viewing_alternate_structure) {
				selectedCells = myReport.nodes.alternatereport.getSelected();
			}
			else {
				selectedCells = myReport.nodes.report.getSelected();
			}
			
			if (selectedCells.length > 0) {
				if (selectedCells[0].column == column) {
					$('adminPropertiesStyles_ColumnWidth').value = width;
				}
			}		
		}
		
		this.nodes.report.onMouseColumnResizeStop = report_onColumnResizeStop;
		this.nodes.alternatereport.onMouseColumnResizeStop = report_onColumnResizeStop;

		function report_onRowClick(row) {
			myReport.nodes.report.setSelected(null, null, false);
			myReport.nodes.alternatereport.setSelected(null, null, false);

			$('adminPropertiesStyles_Header').style.display = "none";
			$('adminPropertiesStyles_Detail').style.display = "none";
			$('adminPropertiesStyles_Formula').style.display = "none";
			$('adminPropertiesStyles_GroupHeader').style.display = "none";
			$('adminPropertiesStyles_NoHeader').style.display = "block";

			$('adminPropertiesFormatting_NotAvailable').style.display = "block";
			$('adminPropertiesFormatting_Boolean').style.display = "none";
			$('adminPropertiesFormatting_Numeric').style.display = "none";
			$('adminPropertiesFormatting_Date').style.display = "none";
			$('adminPropertiesFormatting_Time').style.display = "none";
			$('AdminPropertiesIndicators_Filter_None').style.display = "block";
			$('AdminPropertiesIndicators_Filter_List').innerHTML = "";
			$('adminPropertiesIndicators_NotAvailable').style.display = "block";
			$('adminPropertiesIndicatorsNew').style.display = "none";
			$('adminPropertiesIndicatorFiltersList').style.display = "none";	
			
			if (row == myReport.zones.detail ) {
				if (myReport.nodes.report.structure.detail.visible) {
					myReport.nodes.report.structure.detail.visible = false;
					myReport.nodes.report.setCellValue(myReport.zones.detail,0,"("+STR['dash_de_zone_d']+")");
					myReport.nodes.alternatereport.setCellValue(myReport.zones.detail,0,"("+STR['dash_de_zone_d']+")");
				}
				else {
					myReport.nodes.report.structure.detail.visible = true;
					myReport.nodes.report.setCellValue(myReport.zones.detail,0,STR['dash_de_zone_d']);
					myReport.nodes.alternatereport.setCellValue(myReport.zones.detail,0,STR['dash_de_zone_d']);
				}
			}
			
			if (row < myReport.zones.detail) {
				if (myReport.nodes.report.structure.groups[row - 1].headervisible) {
					myReport.nodes.report.structure.groups[row - 1].headervisible = false;
					myReport.nodes.report.setCellValue(row,0,"(" + myReport.nodes.report.getCellValue(row,0) + ")");
					myReport.nodes.alternatereport.setCellValue(row,0,myReport.nodes.report.getCellValue(row,0));
				}
				else {
					myReport.nodes.report.structure.groups[row - 1].headervisible = true;
					myReport.nodes.report.setCellValue(row,0,myReport.nodes.report.getCellValue(row,0).substring(1,myReport.nodes.report.getCellValue(row,0).length-1));
					myReport.nodes.alternatereport.setCellValue(row,0,myReport.nodes.report.getCellValue(row,0));
				}				
			}				
			
			return false;			
		}
		this.nodes.report.onRowClick = report_onRowClick;
		this.nodes.alternatereport.onRowClick = report_onRowClick;

		function report_ondragout(cellRef) {
			if (this.cols[cellRef.column].temporary)
				this.removeColumn(cellRef.column.temporary);
		}
		
		function report_ondragover(cellRef,event) {
			switch (dax_bridge.hoverDragging.dragObjectSource.ObjectType) {
				case "Field":
					if (((cellRef.row == myReport.zones.detailHeader) | (cellRef.row == myReport.zones.detail)) & (cellRef.column > 0))
					{	
						if (cellRef.row == myReport.zones.detailHeader)
							return "detailheader_highlight";
						else
							return "detailalt_highlight"
					}
					else
						return null;
					break;
				case "Image":
					if (((cellRef.row == myReport.zones.reportHeader) | (cellRef.row == myReport.zones.reportFooter)) & (cellRef.column > 0))
						return true;
					else
						return null;
					break;
				case "Formula":

					if (((cellRef.row > myReport.zones.detail) & ((cellRef.row < myReport.zones.pageFooter) | (myReport.zones.pageFooter == null))) & (cellRef.column > 0) & (cellRef.column <= myReport.nodes.report.structure.detail.content.length)) 
					{
						var reportstructure = "";
						var thisgrid = "";
		
						if (myReport.nodes.report.viewing_alternate_structure) {
							reportstructure = myReport.nodes.report.alternate_structure;
							thisgrid = myReport.nodes.alternatereport;
						}
						else {
							reportstructure = myReport.nodes.report.structure;
							thisgrid = myReport.nodes.report;
						}
						
						var fieldtype = "";
	
						for (var i = 0; i < dax_bridge.tables[mastertable].fields.length; i++)
							if (dax_bridge.tables[mastertable].fields[i].fieldid == reportstructure.detail.content[cellRef.column-1].fieldid)
								fieldtype = dax_bridge.tables[mastertable].fields[i].fieldtype;
						
						if ((findInArray(["Count", "Method"], dax_bridge.hoverDragging.dragObjectSource.ObjectName, 0, false, false) != -1) | (findInArray(["integer", "longint", "real"], fieldtype, 0, false, false) != -1)) {
							if (cellRef.row < myReport.zones.detailFooter) 
								return "groupfootereditor_highlight"
							else 
								return "detailfooter_highlight"
						}
						else {
							cellRef.style.cursor = "no-drop";
							return null;
						}
					}
					else
						return null;
					break;
				default: return null;
					break;
			}
		}
		this.nodes.report.ondragover = report_ondragover;
		this.nodes.alternatereport.ondragover = report_ondragover;
		
		function report_ondragrelease(cellRef) {
			switch (dax_bridge.hoverDragging.dragObjectSource.ObjectType) {
				case "Field":
					if (((cellRef.row == myReport.zones.detailHeader) | (cellRef.row == myReport.zones.detail)) & (cellRef.column > 0))
						{
							var NbOfColumns = this.cols.length;
										
							var current_structure = "";
							var other_structure = "";
							
							if (myReport.nodes.report.viewing_alternate_structure) {
								current_structure = myReport.nodes.report.alternate_structure;
								other_structure = myReport.nodes.report.structure;
							}
							else {
								current_structure = myReport.nodes.report.structure;
								other_structure = myReport.nodes.report.alternate_structure;
							}

							if (cellRef.column == NbOfColumns - 1) {								
								// It s a new column
								
								if (myReport.nodes.report.viewing_alternate_structure) {
									// Dropping in an empty default col so reject
									
									$('dax_report_infocontainer').style.display = "block";
									$('dax_report_infocontainer').style.backgroundColor = "#FAD163";
									$('dax_report_infocontainer').style.color = "#000000";
									$('dax_report_infomessage').innerHTML = STR['dash_error14'];
									
									return;

								}
								
								this.setColumnWidth( NbOfColumns - 1 , 90); // set the current column to 90
								this.addColumn(NbOfColumns + 1); 
								if (this.platform == "iPhone")
									this.viewport.showHorScrollbar(false);
								
								this.otherview.setColumnWidth( NbOfColumns - 1 , 90); // set the current column to 90
								this.otherview.addColumn(NbOfColumns + 1); 
								if (this.platform == "iPhone")
									this.otherview.viewport.showHorScrollbar(false);
								
								if (this.viewport.dom.contents.offsetWidth < this.viewport.dom.main.offsetWidth)
									this.setColumnWidth( NbOfColumns , this.getColumnWidth( NbOfColumns) + this.viewport.dom.main.offsetWidth - this.viewport.dom.contents.offsetWidth - 1);
								else
									this.setColumnWidth( NbOfColumns , 90 );
									
								this.otherview.setColumnWidth( NbOfColumns , this.getColumnWidth(NbOfColumns));

								// Adds the field to the other structure's detail header
								if (cellRef.column > other_structure.detail.content.length) {
									other_structure.detailHeader.content[cellRef.column-1] = {
										value		: "",
										size		: this.getColumnWidth(cellRef.column),
										align		: "center"
									} 
								}
								// Adds the field to the other structure's detail
								if (cellRef.column > other_structure.detail.content.length) {
									other_structure.detail.content[cellRef.column-1] = {
										fieldid		: "",
										sort		: "",
										sortid		: "",
										format		: "",
										iPhoneApp	: "",
										indicators	: new Array(),
										align		: "center" 
									}
								}							
								// Adds the field to the groupfooters
								for (var i = 0; i < reportgroupnb; i++)
									current_structure.groups[i].footer[cellRef.column-1] = {
										formula		: "",
										indicators	: new Array (),
										format		: "",
										iPhoneApp	: "",
										align		: "right"
									};
								for (var i = 0; i < reportgroupnb; i++)
									other_structure.groups[i].footer[cellRef.column-1] = {
										formula		: "",
										indicators	: new Array (),
										format		: "",
										iPhoneApp	: "",
										align		: "right"
									};
								
								// Adds the field to the detailFooter rows
								current_structure.detailFooter.content[cellRef.column-1] = {
									formula		: "",
									indicators	: new Array (),
									format		: "",
									iPhoneApp	: "",
									align		: "right"
								};
								other_structure.detailFooter.content[cellRef.column-1] = {
									formula		: "",
									indicators	: new Array (),
									format		: "",
									iPhoneApp	: "",
									align		: "right"
								};
							}

														
							// ACI0054926
							//cellRef.grid.setCellValue (myReport.zones.detailHeader, cellRef.column, "<div style='display: inline; position: relative; top: 0px;' class='tab_close tab_close_on' onmousedown='removeColumn(this);return false;'></div><span style='vertical-align: middle;position:relative;top:3px;'> " + dax_bridge.hoverDragging.dragObjectSource.ObjectName + "</span>");
							cellRef.grid.setCellValue (myReport.zones.detailHeader, cellRef.column, "<div style='height: 20px; top:0px; left:0px; width: 200px; float: left; text-align: left; position: relative; overflow: hidden;'><span style='vertical-align: middle; position:relative; top: 6px;'>"+ dax_bridge.hoverDragging.dragObjectSource.ObjectName+"</span></div><div style='top: -18px;' class='tab_close tab_close_on' onmousedown='removeColumn(this);return false;'></div>");
							cellRef.grid.setCellValue (myReport.zones.detail, cellRef.column, '<div style="backgrwidth: 100px; height: 20px; width: 200px; float: left; position:relative; top: 0px; left: 0px;"><img src="dax/themes/basic/images/datatree.png" /><span style="vertical-align: middle;"> ' + dax_bridge.hoverDragging.dragObjectSource.ObjectName + '</span></div>');
														
							// Adds the field to the detailHeader
							current_structure.detailHeader.content[cellRef.column-1] = {
								value		: dax_bridge.hoverDragging.dragObjectSource.ObjectName,
								size		: this.getColumnWidth(cellRef.column),
								align		: "center"
							} 
												
							// Adds the field to the detail
							current_structure.detail.content[cellRef.column-1] = {
								fieldid		: dax_bridge.hoverDragging.dragObjectSource.ObjectFieldID,
								sort		: "",
								sortid		: "",
								format		: "",
								iPhoneApp	: "",
								indicators	: new Array(),
								align		: "center" 
							}

							myReport.nodes.report.setSelected(myReport.zones.detail, cellRef.column, true);
							myReport.nodes.alternatereport.setSelected(myReport.zones.detail, cellRef.column, true);
							report_onCellClick(myReport.zones.detail, cellRef.column);
							
							var fieldtype = "";
		
							for (var i = 0; i < dax_bridge.tables[mastertable].fields.length; i++)
								if (dax_bridge.tables[mastertable].fields[i].fieldid == dax_bridge.hoverDragging.dragObjectSource.ObjectFieldID)
									fieldtype = dax_bridge.tables[mastertable].fields[i].fieldtype;
							
							if (findInArray(["integer", "longint", "real"], fieldtype, 0, false, false) == -1) {
								// Delete the Formulas if it s not a numeric field
							
								// Reset the groupfooters
								for (var i = 0; i < reportgroupnb; i++) {
									current_structure.groups[i].footer[cellRef.column-1] = {
										formula		: "",
										indicators	: new Array (),
										format		: "",
										iPhoneApp	: "",
										align		: "right"
									};
									cellRef.grid.setCellValue (myReport.zones.detail + 1 + i, cellRef.column, "");
								}

								// Reset the detailFooter rows
								current_structure.detailFooter.content[cellRef.column-1] = {
									formula		: "",
									indicators	: new Array (),
									format		: "",
									iPhoneApp	: "",
									align		: "right"
								};								
								cellRef.grid.setCellValue (myReport.zones.detailFooter, cellRef.column, "");
								
							}
							else {
								// Set the default align to right if numeric
								current_structure.detail.content[cellRef.column-1].align = "right";
							}

							report_onCellClick(null,null);

						}
					break;
				case "Image":
					if (((cellRef.row == myReport.zones.reportHeader) | (cellRef.row == myReport.zones.reportFooter)) & (cellRef.column > 0)) {
						cellRef.grid.setCellValue (cellRef.row, cellRef.column, '<center><img src="' + dax_bridge.hoverDragging.dragObjectSource.ObjectURL + '"<center>');
					}
					break;
				case "Formula":
					if (((cellRef.row > myReport.zones.detail) & ((cellRef.row < myReport.zones.pageFooter) | (myReport.zones.pageFooter == null))) & (cellRef.column > 0) & (cellRef.column <= myReport.nodes.report.structure.detail.content.length)) 
					{
						var reportstructure = "";
						var thisgrid = "";
		
						if (myReport.nodes.report.viewing_alternate_structure) {
							reportstructure = myReport.nodes.report.alternate_structure;
							thisgrid = myReport.nodes.alternatereport;
						}
						else {
							reportstructure = myReport.nodes.report.structure;
							thisgrid = myReport.nodes.report;
						}
						
						var fieldtype = "";
	
						for (var i = 0; i < dax_bridge.tables[mastertable].fields.length; i++)
							if (dax_bridge.tables[mastertable].fields[i].fieldid == reportstructure.detail.content[cellRef.column-1].fieldid)
								fieldtype = dax_bridge.tables[mastertable].fields[i].fieldtype;
						
						if ((findInArray(["Count", "Method"], dax_bridge.hoverDragging.dragObjectSource.ObjectName, 0, false, false) != -1) | (findInArray(["integer", "longint", "real"], fieldtype, 0, false, false) != -1))
						{
							cellRef.grid.setCellValue (cellRef.row, cellRef.column, '<div style="backgrwidth: 100px; height: 20px; width: 200px; float: left; position:relative; top: 0px; left: 0px;"><img src="dax/themes/basic/images/console.png" /><span style="vertical-align: middle;"> ' + dax_bridge.hoverDragging.dragObjectSource.ObjectName + '</span></div><div style="display: inline; position: relative; top: -18px;" class="tab_close tab_close_on" onmousedown="removeFormula(this);return false;"></div>');
												
							var formulaCode = "";
							
							switch (dax_bridge.hoverDragging.dragObjectSource.ObjectName) {
								case "Average":
									formulaCode = "##A";
									break;
								case "Count":
									formulaCode = "##C";
									break;
								case "Sum":
									formulaCode = "##S";
									break;
								case "Min":
									formulaCode = "##N";
									break;
								case "Max":
									formulaCode = "##X";
									break;
								case "Standard Deviation":
									formulaCode = "##D";
									break;
								case "Method":
									formulaCode = "##M";
									break;						
							}
							
							var current_structure = "";
							var other_structure = "";
							
							if (myReport.nodes.report.viewing_alternate_structure) {
								current_structure = myReport.nodes.report.alternate_structure;
								other_structure = myReport.nodes.report.structure;
							}
							else {
								current_structure = myReport.nodes.report.structure;
								other_structure = myReport.nodes.report.alternate_structure;
							}
							
							// Adds the formula to the group footer
							if (cellRef.row < myReport.zones.detailFooter) {
								current_structure.groups[myReport.structure.groups.length - cellRef.row + myReport.zones.detail].footer[cellRef.column-1] = {
									formula		: formulaCode,
									indicators	: new Array (),
									format		: "",
									iPhoneApp	: "",
									align		: "right"
								};
								current_structure.groups[myReport.structure.groups.length - cellRef.row + myReport.zones.detail].footervisible = true;
								other_structure.groups[myReport.structure.groups.length - cellRef.row + myReport.zones.detail].footervisible = true;
							}
							
							// Adds the formula to the detail footer
							if (cellRef.row == myReport.zones.detailFooter) {
								current_structure.detailFooter.content[cellRef.column-1] = {
									formula		: formulaCode,
									indicators	: new Array (),
									format		: "",
									iPhoneApp	: "",
									align		: "right"
								};
								current_structure.detailFooter.visible = true;
								other_structure.detailFooter.visible = true;
							}
	
						}
					}
					break;
				default:
					break;
			}						
		}

		this.nodes.report.onCellClick = report_onCellClick;
		this.nodes.alternatereport.onCellClick = report_onCellClick;
		
		this.nodes.report.ondragrelease = report_ondragrelease;
		this.nodes.alternatereport.ondragrelease = report_ondragrelease;
		
		// Set Up examples
		if (!DashBoardFlag) {
			$('myDraggableImage1').ObjectType = "Image";		
			$('myDraggableImage1').ObjectURL = "http://www.4d.com/images/develop_home.gif";		
			dax_setDraggable($('myDraggableImage1'));
			
			$('myDraggableImage2').ObjectType = "Image";		
			$('myDraggableImage2').ObjectURL = "http://www.4d.com/images/block_ool.jpg";		
			dax_setDraggable($('myDraggableImage2'));
		}
		else {
			$('dax_report_image_div').style.display = 'none';
		}
				
		$('myDraggableFormula1').ObjectType = "Formula";		
		$('myDraggableFormula1').ObjectName = "Sum";		
		dax_setDraggable($('myDraggableFormula1'));
		
		$('myDraggableFormula1').startHoverDragging = dax_startHoverDragging;
		$('myDraggableFormula1').onmousedown = function(event) {
			var innerHTML = this.innerHTML;
			this.innerHTML = '<img src="dax/themes/basic/images/console.png" style="position: relative; top: 3px;"/>';
			
			myReport.setDefaultCursors("droppingFormula");

			var returnvalue = this.startHoverDragging(event);
			
			this.innerHTML = innerHTML;
			
			return returnvalue;
		}

		$('myDraggableFormula1').ondragrelease = function(event) {
			
			myReport.setDefaultCursors("default");
			
		}
				
		$('myDraggableFormula2').ObjectType = "Formula";		
		$('myDraggableFormula2').ObjectName = "Average";		
		dax_setDraggable($('myDraggableFormula2'));
		
		$('myDraggableFormula2').startHoverDragging = dax_startHoverDragging;
		$('myDraggableFormula2').onmousedown = function(event) {
			var innerHTML = this.innerHTML;
			this.innerHTML = '<img src="dax/themes/basic/images/console.png" style="position: relative; top: 3px;"/>';
			
			myReport.setDefaultCursors("droppingFormula");

			var returnvalue = this.startHoverDragging(event);
			
			this.innerHTML = innerHTML;
			
			return returnvalue;
		}

		$('myDraggableFormula2').ondragrelease = function(event) {
			
			myReport.setDefaultCursors("default");
			
		}
		
		$('myDraggableFormula3').ObjectType = "Formula";		
		$('myDraggableFormula3').ObjectName = "Min";		
		dax_setDraggable($('myDraggableFormula3'));
		
		$('myDraggableFormula3').startHoverDragging = dax_startHoverDragging;
		$('myDraggableFormula3').onmousedown = function(event) {
			var innerHTML = this.innerHTML;
			this.innerHTML = '<img src="dax/themes/basic/images/console.png" style="position: relative; top: 3px;"/>';
			
			myReport.setDefaultCursors("droppingFormula");

			var returnvalue = this.startHoverDragging(event);
			
			this.innerHTML = innerHTML;
			
			return returnvalue;
		}

		$('myDraggableFormula3').ondragrelease = function(event) {
			
			myReport.setDefaultCursors("default");
			
		}
	
		$('myDraggableFormula4').ObjectType = "Formula";		
		$('myDraggableFormula4').ObjectName = "Max";		
		dax_setDraggable($('myDraggableFormula4'));
		
		$('myDraggableFormula4').startHoverDragging = dax_startHoverDragging;
		$('myDraggableFormula4').onmousedown = function(event) {
			var innerHTML = this.innerHTML;
			this.innerHTML = '<img src="dax/themes/basic/images/console.png" style="position: relative; top: 3px;"/>';
			
			myReport.setDefaultCursors("droppingFormula");

			var returnvalue = this.startHoverDragging(event);
			
			this.innerHTML = innerHTML;
			
			return returnvalue;
		}

		$('myDraggableFormula4').ondragrelease = function(event) {
			
			myReport.setDefaultCursors("default");
			
		}
		
		$('myDraggableFormula5').ObjectType = "Formula";		
		$('myDraggableFormula5').ObjectName = "Count";		
		dax_setDraggable($('myDraggableFormula5'));
		
		$('myDraggableFormula5').startHoverDragging = dax_startHoverDragging;
		$('myDraggableFormula5').onmousedown = function(event) {
			var innerHTML = this.innerHTML;
			this.innerHTML = '<img src="dax/themes/basic/images/console.png" style="position: relative; top: 3px;"/>';
			
			myReport.setDefaultCursors("droppingFormula");

			var returnvalue = this.startHoverDragging(event);
			
			this.innerHTML = innerHTML;
			
			return returnvalue;
		}

		$('myDraggableFormula5').ondragrelease = function(event) {
			
			myReport.setDefaultCursors("default");
			
		}
		
		$('myDraggableFormula6').ObjectType = "Formula";		
		$('myDraggableFormula6').ObjectName = "Standard Deviation";		
		dax_setDraggable($('myDraggableFormula6'));
		
		$('myDraggableFormula6').startHoverDragging = dax_startHoverDragging;
		$('myDraggableFormula6').onmousedown = function(event) {
			var innerHTML = this.innerHTML;
			this.innerHTML = '<img src="dax/themes/basic/images/console.png" style="position: relative; top: 3px;"/>';
			
			myReport.setDefaultCursors("droppingFormula");

			var returnvalue = this.startHoverDragging(event);
			
			this.innerHTML = innerHTML;
			
			return returnvalue;
		}

		$('myDraggableFormula6').ondragrelease = function(event) {
			
			myReport.setDefaultCursors("default");
			
		}
		
		$('myDraggableFormula7').ObjectType = "Formula";		
		$('myDraggableFormula7').ObjectName = "Method";		
		dax_setDraggable($('myDraggableFormula7'));
		
		$('myDraggableFormula7').startHoverDragging = dax_startHoverDragging;
		$('myDraggableFormula7').onmousedown = function(event) {
			var innerHTML = this.innerHTML;
			this.innerHTML = '<img src="dax/themes/basic/images/console.png" style="position: relative; top: 3px;"/>';

			myReport.setDefaultCursors("droppingFormula");
			
			var returnvalue = this.startHoverDragging(event);
			
			this.innerHTML = innerHTML;
			
			return returnvalue;
		}

		$('myDraggableFormula7').ondragrelease = function(event) {
			
			myReport.setDefaultCursors("default");
			
		}
		
		$('dax_report_objects_expanded').onclick = function() {this.style.display = 'none'; $('dax_report_objects_collapsed').style.display = 'inline'; $('dax_report_objects_list').style.display = 'none';};
		$('dax_report_objects_collapsed').onclick = function() {this.style.display = 'none'; $('dax_report_objects_expanded').style.display = 'inline'; $('dax_report_objects_list').style.display = 'block'; $('dax_report_formulas_expanded').style.display = 'none'; $('dax_report_formulas_collapsed').style.display = 'inline'; $('dax_report_formulas_list').style.display = 'none';};

		$('dax_report_formulas_expanded').onclick = function() {this.style.display = 'none'; $('dax_report_formulas_collapsed').style.display = 'inline'; $('dax_report_formulas_list').style.display = 'none';};
		$('dax_report_formulas_collapsed').onclick = function() {this.style.display = 'none'; $('dax_report_formulas_expanded').style.display = 'inline'; $('dax_report_formulas_list').style.display = 'block'; $('dax_report_objects_expanded').style.display = 'none'; $('dax_report_objects_collapsed').style.display = 'inline'; $('dax_report_objects_list').style.display = 'none';};
		
		$('dax_report_groups_expanded').onclick = function() {this.style.display = 'none'; $('dax_report_groups_collapsed').style.display = 'inline'; $('dax_report_groups_list').style.display = 'none';};
		$('dax_report_groups_collapsed').onclick = function() {this.style.display = 'none'; $('dax_report_groups_expanded').style.display = 'inline'; $('dax_report_groups_list').style.display = 'block';};
		
		$('dax_report_showalternatecolumns').onclick = function() {report_switchToAlternateColumns();};
		$('dax_report_showregularcolumns').onclick = function() {report_switchToDefaultColumns();};
	
		$('dax_report_showinspector').onclick = function() {do_showDashboard($('adminPropertyInspector'), '2');};
		
		$('dax_report_cancelreport').onclick = function() {do_CloseCreateReport();};
		$('dax_report_savereport').onclick = function() {myReport.save();};
		
		if (Platform == "Desktop") {
			this.platform = "Desktop";
			$('adminPropertiesStyles_DesktopPic').style.display = "block";
			$('adminPropertiesStyles_iphonePic').style.display = "none";
			$('dax_report_desktopstyles').style.display = 'inline';
			$('dax_report_iphonestyles').style.display = 'none';
			$('dax_report_desktopstyles_style').selectedIndex = 0;
		}
		else {
			this.platform = "iPhone";
			$('adminPropertiesStyles_DesktopPic').style.display = "none";
			$('adminPropertiesStyles_iphonePic').style.display = "block";
			$('dax_report_desktopstyles').style.display = 'none';
			$('dax_report_iphonestyles').style.display = 'inline';
			$('dax_report_iphonestyles_style').selectedIndex = 0;
		}
		
		$('dax_report_objects').firstChild.nodeValue = STR['dash_de_info1'];
		$('dax_report_groups').firstChild.nodeValue = STR['dash_de_info2'];
		$('dax_report_desktopstyles').firstChild.nodeValue = STR['dash_de_info3'];
		$('dax_report_showalternatecolumns_text').innerHTML = STR['dash_de_info4'];
		$('dax_report_showregularcolumns_text').innerHTML = STR['dash_de_info5'];
		$('dax_report_showinspector_text').innerHTML = STR['dash_de_info6'];
		$('dax_report_objects_collapsed_text').innerHTML = STR['dash_de_dbobjs'];
		$('dax_report_formulas_collapsed_text').innerHTML = STR['dash_de_Formulas'];
		$('dax_report_groups_collapsed_text').innerHTML = STR['dash_de_groups'];
		$('dax_report_usechart').previousSibling.nodeValue = STR['dash_de_chart']+":";
		$('myDraggableFormula1_text').innerHTML = STR['dash_de_Formula1'];
		$('myDraggableFormula2_text').innerHTML = STR['dash_de_Formula2'];
		$('myDraggableFormula3_text').innerHTML = STR['dash_de_Formula3'];
		$('myDraggableFormula4_text').innerHTML = STR['dash_de_Formula4'];
		$('myDraggableFormula5_text').innerHTML = STR['dash_de_Formula5'];
		$('myDraggableFormula6_text').innerHTML = STR['dash_de_Formula6'];
		$('myDraggableFormula7_text').innerHTML = STR['dash_de_Formula7'];
		$('dax_report_iphonestyles_style').options[0].text = STR['dash_de_ip_style1'];
		$('dax_report_iphonestyles_style').options[1].text = STR['dash_de_ip_style2'];	
		$('dax_report_desktopstyles_style').options[0].text = STR['dash_de_dt_style1'];
		$('dax_report_desktopstyles_style').options[1].text = STR['dash_de_dt_style2'];
		$('dax_report_desktopstyles_style').options[2].text = STR['dash_de_dt_style3'];
		$('dax_report_desktopstyles_style').options[3].text = STR['dash_de_dt_style4'];
		$('dax_report_desktopstyles_style').options[4].text = STR['dash_de_dt_style5'];
		$('dax_report_desktopstyles_style').options[5].text = STR['dash_de_dt_style6'];
		$('dax_report_desktopstyles_style').options[6].text = STR['dash_de_dt_style7'];
		$('dax_report_cancelreport').value = STR['dash_de_cancel'];
		$('dax_report_savereport').value = STR['dash_de_save'];
		$('adminPropertiesCloseBtn_text').innerHTML = STR['dash_pi_close'];
		$('adminPropertiesStyles_DesktopPic_text').nodeValue = STR['dash_pi_style_info1'];
		$('adminPropertiesStyles_iphonePic_text').nodeValue = STR['dash_pi_style_info2'];
		$('adminPropertiesStyles_Header1_text').innerHTML = STR['dash_pi_style_width'];
		$('adminPropertiesStyles_ColumnWidth').nextSibling.nodeValue = STR['dash_pi_style_px'];
		$('adminPropertiesStyles_Header2_text').innerHTML = STR['dash_pi_halign'];
		$('adminPropertiesStyles_Header3_text').innerHTML = STR['dash_pi_htext'];
		$('adminPropertiesStyles_Detail_text').innerHTML = STR['dash_pi_dalign'];
		$('adminPropertiesStyles_Formula1_text').innerHTML = STR['dash_pi_falign'];
		$('adminPropertiesStyles_Formula2_text').innerHTML = STR['dash_pi_customformula'];
		$('adminPropertiesStyles_GroupHeader1_text').innerHTML = STR['dash_pi_ghalign'];
		$('adminPropertiesStyles_GroupHeader2_text').innerHTML = STR['dash_pi_customgh'];
		
		$('adminPropertiesStyles_HeaderAlign').options[0].text = STR['dash_pi_align_option1'];
		$('adminPropertiesStyles_HeaderAlign').options[1].text = STR['dash_pi_align_option2'];
		$('adminPropertiesStyles_HeaderAlign').options[2].text = STR['dash_pi_align_option3'];
		$('adminPropertiesStyles_DetailAlign').options[0].text = STR['dash_pi_align_option1'];
		$('adminPropertiesStyles_DetailAlign').options[1].text = STR['dash_pi_align_option2'];
		$('adminPropertiesStyles_DetailAlign').options[2].text = STR['dash_pi_align_option3'];
		$('adminPropertiesStyles_FormulaAlign').options[0].text = STR['dash_pi_align_option1'];
		$('adminPropertiesStyles_FormulaAlign').options[1].text = STR['dash_pi_align_option2'];
		$('adminPropertiesStyles_FormulaAlign').options[2].text = STR['dash_pi_align_option3'];
		$('adminPropertiesStyles_GroupHeaderAlign').options[0].text = STR['dash_pi_align_option1'];
		$('adminPropertiesStyles_GroupHeaderAlign').options[1].text = STR['dash_pi_align_option2'];
		$('adminPropertiesStyles_GroupHeaderAlign').options[2].text = STR['dash_pi_align_option3'];
		$('adminPropertiesIndicatorsNew_text').innerHTML = STR['dash_pi_ind_info1'];
		
		$('adminPropertiesIndicatorFiltersList_text').innerHTML = STR['dash_pi_ind_info2'];
		$('AdminPropertiesIndicators_Filter_None_text').nodeValue = STR['dash_pi_ind_info3'];		
		$('AdminPropertiesIndicators_Filter_Criteria').options[0].text = STR['dash_pi_ind_op1'];
		$('AdminPropertiesIndicators_Filter_Criteria').options[1].text = STR['dash_pi_ind_op2'];
		$('AdminPropertiesIndicators_Filter_Criteria').options[2].text = STR['dash_pi_ind_op3'];
		$('AdminPropertiesIndicators_Filter_Class').options[0].text = STR['dash_pi_ind_style1'];
		$('AdminPropertiesIndicators_Filter_Class').options[1].text = STR['dash_pi_ind_style2'];
		$('AdminPropertiesIndicators_Filter_Class').options[2].text = STR['dash_pi_ind_style3'];
		$('AdminPropertiesIndicators_Filter_Class').options[3].text = STR['dash_pi_ind_style4'];
		$('AdminPropertiesIndicators_Filter_Class').options[4].text = STR['dash_pi_ind_style5'];
		$('AdminPropertiesIndicators_Filter_Class').options[5].text = STR['dash_pi_ind_style6'];
		
		$('adminPropertiesIndicatorsNewAdd_text').value = STR['dash_pi_ind_addbutton'];

		$('adminPropertiesIPhoneApps_Options_text').nodeValue = STR['dash_pi_apps_info1'];
		$('adminPropertiesIPhoneApps_Options_Popup').options[0].text = STR['dash_pi_app1'];
		$('adminPropertiesIPhoneApps_Options_Popup').options[1].text = STR['dash_pi_app2'];
		$('adminPropertiesIPhoneApps_Options_Popup').options[2].text = STR['dash_pi_app3'];
		$('adminPropertiesIPhoneApps_Options_Popup').options[3].text = STR['dash_pi_app4'];
		$('adminPropertiesIPhoneApps_Options_Popup').options[4].text = STR['dash_pi_app5'];

		$('adminPropertiesDesktopApps_Options_text').nodeValue = STR['dash_pi_apps_info1'];
		$('adminPropertiesDesktopApps_Options_Popup').options[0].text = STR['dash_pi_app1'];
		$('adminPropertiesDesktopApps_Options_Popup').options[1].text = STR['dash_pi_app2'];
		$('adminPropertiesDesktopApps_Options_Popup').options[2].text = STR['dash_pi_app3'];
		$('adminPropertiesDesktopApps_Options_Popup').options[3].text = STR['dash_pi_app4'];
		
		$('adminPropertiesStyles_NoHeader').innerHTML = STR['dash_error9'];
		$('adminPropertiesIndicators_NotAvailable').childNodes[0].nodeValue = " " + STR['dash_error6'];
		$('adminPropertiesFormatting_NotAvailable').childNodes[0].nodeValue = " " + STR['dash_error7'];
		$('adminPropertiesIPhoneApps_NotAvailable').childNodes[0].nodeValue = " " + STR['dash_error8'];

		$('dax_report_infocontainer_closebutton').onclick = function(event){
			$('dax_report_infocontainer').style.display = 'none'; 
			return false;
		};
		
		if (this.platform == "Desktop")		
			$('dax_report_showalternatecolumns').style.display = 'none';
					
	};
	
	function dax_reporteditor_save() {

	 	var sessionId = connection.sessionId;
	 	
		if (myReport.nodes.report.viewing_alternate_structure) {
			$('dax_report_showregularcolumns').style.display = 'none';
			$('dax_report_showalternatecolumns').style.display = 'block';
			$('dax_report_reportcontainer').style.display = 'block';
			$('dax_report_alternatereportcontainer').style.display = 'none';
			myReport.nodes.report.viewing_alternate_structure = false;
		}	
		myReport.nodes.report.redraw(true,true);

	 	if (sessionId == "")
	 		return;
	 	
		if (this.structure.detail.content.length == 0) {
			$('dax_report_infocontainer').style.display = "block";
			$('dax_report_infocontainer').style.backgroundColor = "#FAD163";
			$('dax_report_infocontainer').style.color = "#000000";
			$('dax_report_infomessage').innerHTML = STR['dash_error3'];
			return;
		}
		if (this.structure.detail.content[0].fieldid == "") {
			$('dax_report_infocontainer').style.display = "block";
			$('dax_report_infocontainer').style.backgroundColor = "#FAD163";
			$('dax_report_infocontainer').style.color = "#000000";
			$('dax_report_infomessage').innerHTML = STR['dash_error3'];
			return;
		}
			
	 	var http_request = getXMLHttpRequest();
			
		if (http_request) {
			var url = "/DAX/SaveReport";
			
			var prebody = "sessionid="+connection.sessionId+"&reportname="+dax_bridge.encode(this.reportName)+"&tableid="+dax_bridge.tables[mastertable].tableid+"&type=public&description="+dax_bridge.encode(this.description)+"&reportinfo=";
			
			prebody +='<report mastertable="'+dax_bridge.tables[mastertable].tableid+'" platform="' + this.platform + '"';
			if (this.platform == "Desktop")
				prebody += ' csstheme="' + $('dax_report_desktopstyles_style').options[$('dax_report_desktopstyles_style').selectedIndex].value + '"';
			else
				prebody += ' csstheme="' + $('dax_report_iphonestyles_style').options[$('dax_report_iphonestyles_style').selectedIndex].value + '"';
			
			var querieslistpopup = $('dax_report_presetqueries_popup');
			
			if (querieslistpopup.options[querieslistpopup.selectedIndex].value == 'none')
				prebody += ' queryname=""';
			else
				prebody += ' queryname="'+querieslistpopup.options[querieslistpopup.selectedIndex].value+'"'
			
			prebody += ' usechart="' + this.structure.usechart + '" crosstab="false" vmargin="50" hmargin="80" border="1" bordercolor="#333333">';
			
			var indicator_count = 0;
			
			var rbody ='<reportheader visible="'+this.structure.reportHeader.visible+'" font="Times" size="11" color="#000000" align="center" height="3">';
			rbody +='</reportheader>';	
			rbody +='<pageheader visible="'+this.structure.pageHeader.visible+'" font="Times" size="11" color="#000000" align="center" height="1">';
			rbody +='</pageheader>';
			rbody +='<detailheader visible="'+this.structure.detailHeader.visible+'" font="Arial" size="18" color="#000000" border="1" bordercolor="#333333" height="1">';
			
			for (var i = 0; i < this.structure.groups.length; i++)
				rbody +='<field width="0" visible="false" value="" align="left"></field>';
			for (var j = 0; j < this.structure.detailHeader.content.length; j++)
				rbody +='<field width="'+this.nodes.report.cols[parseInt(j)+1].colWidth+'" value="' + dax_bridge.encode(this.structure.detailHeader.content[j].value) + '" align="' + this.structure.detailHeader.content[j].align + '"/>';
			for (var j = 0; j < this.alternate_structure.detailHeader.content.length; j++) {
				if (this.alternate_structure.detailHeader.content[j].value != "")
					rbody +='<field width="'+this.nodes.report.cols[parseInt(j)+1].colWidth+'" value="' +dax_bridge.encode(this.alternate_structure.detailHeader.content[j].value) + '" altcol="'+(parseInt(j)+1+this.structure.groups.length)+'" align="' + this.alternate_structure.detailHeader.content[j].align + '"/>';
			}
			
			rbody +='</detailheader>';

			for (var i = 0; i < this.structure.groups.length; i++) {
				var groupid = parseInt(i) + 1;
				rbody += '<groupheader visible="'+this.structure.groups[i].headervisible+'" id="'+groupid+'" fieldid="'+this.structure.groups[i].fieldid+'" sort="asc" font="Times" size="11" color="#000000" align="center" border="1" bordercolor="#333333" height="1">'			
				for (var j = 0; j < this.structure.groups.length; j++)
					rbody +='<field format="" formula="" label="" visible="false"/>';
				for (var j = 0; j < this.structure.detail.content.length; j++) {
					rbody +='<field format="';
					if (j == 0) {
						rbody += this.structure.groups[j].format;
					}
					rbody +='" formula="';
					if (j == 0) {
						rbody += this.structure.groups[j].headerformula;
						rbody += '" align="';
						rbody += this.structure.groups[j].align;
					}
					rbody +='" label=""/>';
				}
				for (var j = 0; j < this.alternate_structure.detail.content.length; j++)
					if (this.alternate_structure.detailHeader.content[j].value != "")
						rbody +='<field format="" formula="" label=""/>';
				rbody += '</groupheader>';
			}
						
			rbody +='<detail visible="'+this.structure.detail.visible+'" font="Times" size="11" color="#000000" backcolor="#FFFFFF" altbackcolor="#444444" align="center" border="1" bordercolor="#333333" height="1">';
			
			for (var i = 0; i < this.structure.groups.length; i++)
				rbody +='<field format="" fieldid="'+this.structure.groups[i].fieldid+'" sort="" sortid="" repeat="false" visible="false"/>';
			for (var i = 0; i < this.structure.detail.content.length; i++) {
				rbody +='<field format="'+this.structure.detail.content[i].format+'" fieldid="'+this.structure.detail.content[i].fieldid+'" sort="" sortid="" iphonetype="'+this.structure.detail.content[i].iPhoneApp+'"';
				if (this.structure.detail.content[i].indicators.length>0) {
					indicator_count++;
					
					prebody += '<indicators id="'+indicator_count+'">';
					for (var k = 0; k < this.structure.detail.content[i].indicators.length; k++)
						prebody += '<indicator criteria="' + this.structure.detail.content[i].indicators[k].criteria + '" value="' + this.structure.detail.content[i].indicators[k].value + '" class="' + this.structure.detail.content[i].indicators[k].color + '"/>';
					prebody += '</indicators>';
					
					rbody +=' indicator="'+indicator_count+'"';
				}

				var fieldtype = "";

				for (var v = 0; v < dax_bridge.tables[mastertable].fields.length; v++)
					if (dax_bridge.tables[mastertable].fields[v].fieldid == this.structure.detail.content[i].fieldid)
						fieldtype = dax_bridge.tables[mastertable].fields[v].fieldtype;
				
				rbody += ' align="' + this.structure.detail.content[i].align + '"';
				//if ((fieldtype == 'integer') | (fieldtype == 'longint') | (fieldtype == 'real'))
				//	rbody += ' align="right"';
				
				rbody += '/>';
			}
			for (var k = 0; k < this.alternate_structure.detail.content.length; k++)
				if (this.alternate_structure.detailHeader.content[k].value != "") {
					rbody +='<field format="'+this.alternate_structure.detail.content[k].format+'" fieldid="'+this.alternate_structure.detail.content[k].fieldid+'" iphonetype="'+this.alternate_structure.detail.content[k].iPhoneApp+'" sort="" sortid=""';
					if (this.alternate_structure.detail.content[k].indicators.length>0) {
						indicator_count++;
						
						prebody += '<indicators id="'+indicator_count+'">';
						for (var h = 0; h < this.alternate_structure.detail.content[k].indicators.length; h++)
							prebody += '<indicator criteria="' + this.alternate_structure.detail.content[k].indicators[h].criteria + '" value="' + this.alternate_structure.detail.content[k].indicators[h].value + '" class="' + this.alternate_structure.detail.content[k].indicators[h].color + '"/>';
						prebody += '</indicators>';
						
						rbody +=' indicator="'+indicator_count+'"';
					}

					var fieldtype = "";
	
					for (var v = 0; v < dax_bridge.tables[mastertable].fields.length; v++)
						if (dax_bridge.tables[mastertable].fields[v].fieldid == this.alternate_structure.detail.content[k].fieldid)
							fieldtype = dax_bridge.tables[mastertable].fields[v].fieldtype;
					
					rbody += ' align="' + this.alternate_structure.detail.content[k].align + '"';	
					//if ((fieldtype == 'integer') | (fieldtype == 'longint') | (fieldtype == 'real'))
					//	rbody += ' align="right"';
					
					rbody += '/>';
				}
			
			rbody +='</detail>';

			for (var i = this.structure.groups.length - 1; i >= 0; i--) {
				var groupid = parseInt(i) + 1;
				rbody += '<groupfooter visible="'+this.structure.groups[i].footervisible+'" id="'+groupid+'" sort="asc" font="Times" size="11" color="#000000" align="center" border="1" bordercolor="#333333" height="1">'			
				for (var j = 0; j < this.structure.groups.length; j++)
					rbody +='<field format="" formula="" label="" visible="false"/>';
				for (var j = 0; j < this.structure.groups[i].footer.length; j++)
					if (this.structure.groups[i].footer[j].indicators.length>0) {
						indicator_count++;
						
						prebody += '<indicators id="'+indicator_count+'">';
						for (var k = 0; k < this.structure.groups[i].footer[j].indicators.length; k++)
							prebody += '<indicator criteria="' + this.structure.groups[i].footer[j].indicators[k].criteria + '" value="' + this.structure.groups[i].footer[j].indicators[k].value + '" class="' + this.structure.groups[i].footer[j].indicators[k].color + '"/>';
						prebody += '</indicators>';
						
						rbody +='<field format="'+this.structure.groups[i].footer[j].format+'" align="' + this.structure.groups[i].footer[j].align + '" formula="'+dax_bridge.encode(this.structure.groups[i].footer[j].formula)+'" iphonetype="'+this.structure.groups[i].footer[j].iPhoneApp+'" indicator="'+indicator_count+'"/>';
					}
					else {
						rbody +='<field format="'+this.structure.groups[i].footer[j].format+'" align="' + this.structure.groups[i].footer[j].align + '" formula="'+dax_bridge.encode(this.structure.groups[i].footer[j].formula)+'" iphonetype="'+this.structure.groups[i].footer[j].iPhoneApp+'"/>';
					}
				for (var j = 0; j < this.alternate_structure.groups[i].footer.length; j++)
					if (this.alternate_structure.detailHeader.content[j].value != "") {
						if (this.alternate_structure.groups[i].footer[j].indicators.length>0) {
							indicator_count++;
							
							prebody += '<indicators id="'+indicator_count+'">';
							for (var k = 0; k < this.alternate_structure.groups[i].footer[j].indicators.length; k++)
								prebody += '<indicator criteria="' + this.alternate_structure.groups[i].footer[j].indicators[k].criteria + '" value="' + this.alternate_structure.groups[i].footer[j].indicators[k].value + '" class="' + this.alternate_structure.groups[i].footer[j].indicators[k].color + '"/>';
							prebody += '</indicators>';
							
							rbody +='<field format="'+this.alternate_structure.groups[i].footer[j].format+'" align="'+this.alternate_structure.groups[i].footer[j].align+'" formula="'+dax_bridge.encode(this.alternate_structure.groups[i].footer[j].formula)+'" iphonetype="'+this.alternate_structure.groups[i].footer[j].iPhoneApp+'" indicator="'+indicator_count+'"/>';
						}
						else {
							rbody +='<field format="'+this.alternate_structure.groups[i].footer[j].format+'" align="'+this.alternate_structure.groups[i].footer[j].align+'" formula="'+dax_bridge.encode(this.alternate_structure.groups[i].footer[j].formula)+'" iphonetype="'+this.alternate_structure.groups[i].footer[j].iPhoneApp+'"/>';
						}
					}
				rbody += '</groupfooter>';
			}

			rbody +='<detailfooter visible="'+this.structure.detailFooter.visible+'" font="Times" size="11" color="#000000" align="center" height="1">';
		
			for (var i = 0; i < this.structure.groups.length; i++)
				rbody +='<field format="" formula="" label="" visible="false"/>';
			for (var j = 0; j < this.structure.detail.content.length; j++)		
				if (this.structure.detailFooter.content[j].indicators.length>0) {
					indicator_count++;
					
					prebody += '<indicators id="'+indicator_count+'">';
					for (var k = 0; k < this.structure.detailFooter.content[j].indicators.length; k++)
						prebody += '<indicator criteria="' + this.structure.detailFooter.content[j].indicators[k].criteria + '" value="' + this.structure.detailFooter.content[j].indicators[k].value + '" class="' + this.structure.detailFooter.content[j].indicators[k].color + '"/>';
					prebody += '</indicators>';
					
					rbody +='<field format="'+this.structure.detailFooter.content[j].format+'" align="'+this.structure.detailFooter.content[j].align+'" formula="'+dax_bridge.encode(this.structure.detailFooter.content[j].formula)+'" iphonetype="'+this.structure.detailFooter.content[j].iPhoneApp+'" indicator="'+indicator_count+'"/>';
				}
				else {
					rbody +='<field format="'+this.structure.detailFooter.content[j].format+'" align="'+this.structure.detailFooter.content[j].align+'" formula="'+dax_bridge.encode(this.structure.detailFooter.content[j].formula)+'" iphonetype="'+this.structure.detailFooter.content[j].iPhoneApp+'"/>';
				}
			for (var j = 0; j < this.alternate_structure.detail.content.length; j++)		
				if (this.alternate_structure.detailHeader.content[j].value != "") {
					if (this.alternate_structure.detailFooter.content[j].indicators.length>0) {
						indicator_count++;
						
						prebody += '<indicators id="'+indicator_count+'">';
						for (var k = 0; k < this.alternate_structure.detailFooter.content[j].indicators.length; k++)
							prebody += '<indicator criteria="' + this.alternate_structure.detailFooter.content[j].indicators[k].criteria + '" value="' + this.alternate_structure.detailFooter.content[j].indicators[k].value + '" class="' + this.alternate_structure.detailFooter.content[j].indicators[k].color + '"/>';
						prebody += '</indicators>';
						
						rbody +='<field format="'+this.alternate_structure.detailFooter.content[j].format+'" align="'+this.alternate_structure.detailFooter.content[j].format+'" formula="'+dax_bridge.encode(this.alternate_structure.detailFooter.content[j].formula)+'" iphonetype="'+this.alternate_structure.detailFooter.content[j].iPhoneApp+'" indicator="'+indicator_count+'"/>';
					}
					else {
						rbody +='<field format="'+this.alternate_structure.detailFooter.content[j].format+'" align="'+this.alternate_structure.detailFooter.content[j].format+'" formula="'+dax_bridge.encode(this.alternate_structure.detailFooter.content[j].formula)+'" iphonetype="'+this.alternate_structure.detailFooter.content[j].iPhoneApp+'"/>';
					}
				}
				
			rbody +='</detailfooter>'
			rbody +='<pagefooter visible="'+this.structure.pageFooter.visible+'" font="Times" size="11" color="#000000" align="center" height="1">';
			rbody +='</pagefooter>';
	
			rbody +='<reportfooter visible="'+this.structure.reportFooter.visible+'" font="Times" size="11" color="#000000" align="center" height="3">';
			rbody +='</reportfooter>';

			rbody +='</report>';
			
			rbody = prebody + rbody;
			
			http_request.onreadystatechange = 
				function() {
					if (http_request.readyState != 4)
						return;
	
					var result = http_request.responseXML.getElementsByTagName("reportSaved").item(0);
					if (result) {
						$('dax_report_infocontainer').style.display = "block";
						$('dax_report_infocontainer').style.backgroundColor = "#FAD163";
						$('dax_report_infocontainer').style.color = "#000000";
						$('dax_report_infomessage').innerHTML =  STR['dash_error2'];
					}
					else {
						$('dax_report_infocontainer').style.display = "block";
						$('dax_report_infocontainer').style.backgroundColor = "#FAD163";
						$('dax_report_infocontainer').style.color = "#FFFFFF";
						$('dax_report_infomessage').innerHTML = STR['dash_error5'];
					}
				};
				
			try {
				debugAlert('<b>Admin:</b>'+'<a href="'+url+'" target="_blank">'+url+'</a>');
			
				http_request.open("POST", url, true);
		  	  	http_request.send(rbody);
		   	} catch(e) {
		   		delete http_request;
			}
		}
		
	};
	
	function dax_reporteditor_parseXMLStruct(XMLStruct) {

		// parse through the XML
		var result = XMLStruct.responseXML.getElementsByTagName("report").item(0);
		var responseError = checkResponse (XMLStruct);
		
		if (!isDefined(result)) {
			return false;
		}
		
		if (result.getAttribute("usechart")=="true") {
			$('dax_report_usechart').checked = true;		
			this.nodes.report.structure.usechart = true;
		}
		else
			this.nodes.report.structure.usechart = false;
		
		var querieslistpopup = $('dax_report_presetqueries_popup');
		
		if (result.getAttribute("queryname")!="") {
			for (var i = 0; i < querieslistpopup.options.length; i++) {
				if (result.getAttribute("queryname") == querieslistpopup.options[i].value)
					querieslistpopup.selectedIndex = i;
			}
		}
		else	
			querieslistpopup.selectedIndex = 0;
		
		if (result.getAttribute("platform") == "Desktop") {
			this.platform = "Desktop";
			$('dax_report_showregularcolumns').style.display = 'none';
			$('dax_report_showalternatecolumns').style.display = 'none';
			$('adminPropertiesStyles_DesktopPic').style.display = "block";
			$('adminPropertiesStyles_iphonePic').style.display = "none";
			$('dax_report_desktopstyles').style.display = 'inline';
			$('dax_report_iphonestyles').style.display = 'none';
			switch (result.getAttribute("csstheme")) {
				case "default":
					$('dax_report_desktopstyles_style').selectedIndex = 0;
					break;
				case "Peach":
					$('dax_report_desktopstyles_style').selectedIndex = 1;
					break;
				case "Clay":
					$('dax_report_desktopstyles_style').selectedIndex = 2;
					break;
				case "Fog":
					$('dax_report_desktopstyles_style').selectedIndex = 3;
					break;
				case "Cocoa":
					$('dax_report_desktopstyles_style').selectedIndex = 4;
					break;
				case "Ocean":
					$('dax_report_desktopstyles_style').selectedIndex = 5;
					break;
				case "Mint":
					$('dax_report_desktopstyles_style').selectedIndex = 6;
					break;
				default:
					$('dax_report_desktopstyles_style').selectedIndex = 0;
					break;
			}
		}
		else {
			this.platform = "iPhone";
			$('adminPropertiesStyles_DesktopPic').style.display = "none";
			$('adminPropertiesStyles_iphonePic').style.display = "block";
			$('dax_report_desktopstyles').style.display = 'none';
			$('dax_report_iphonestyles').style.display = 'inline';
			switch (result.getAttribute("csstheme")) {
				case "Blue":
					$('dax_report_iphonestyles_style').selectedIndex = 0;
					break;
				case "Black":
					$('dax_report_iphonestyles_style').selectedIndex = 1;
					break;
				default:
					$('dax_report_iphonestyles_style').selectedIndex = 0;
					break;
			}
		}
												
		var detailZoneElem = result.getElementsByTagName("detail").item(0);
		var detailheaderZoneElem = result.getElementsByTagName("detailheader").item(0);
		var detailfooterZoneElem = result.getElementsByTagName("detailfooter").item(0);
		var groupheaderZoneElems = result.getElementsByTagName("groupheader");
		var groupfooterZoneElems = result.getElementsByTagName("groupfooter");
		
		if (detailZoneElem.getAttribute("visible") == "false") {
			this.nodes.report.structure.detail.visible = false;
			this.nodes.report.setCellValue(this.zones.detail,0,"("+STR['dash_de_zone_d']+")");
			this.nodes.alternatereport.setCellValue(this.zones.detail,0,"("+STR['dash_de_zone_d']+")");			
		}
		
		var detailfieldElems = detailZoneElem.getElementsByTagName("field");
		var detailheaderfieldElems = detailheaderZoneElem.getElementsByTagName("field");
		var detailfooterfieldElems = detailfooterZoneElem.getElementsByTagName("field");
		
		var NbOfInvisibleColumns = 0;
		
		for (var i = 0; i < detailfieldElems.length; i++) {
			var detailfieldElem = detailfieldElems.item(i);
			var detailheaderfieldElem = detailheaderfieldElems.item(i);
			var detailfooterfieldElem = detailfooterfieldElems.item(i);
			
			if (detailfieldElem) {
	
				if (detailheaderfieldElem.getAttribute("visible")!="false") {
					var ColNb;
					
					var current_structure = "";
					var other_structure = "";

					if (detailheaderfieldElem.getAttribute("altcol")!=undefined) {
						thisview = this.nodes.alternatereport;
						theotherview = this.nodes.report;
						ColNb = parseInt(detailheaderfieldElem.getAttribute("altcol")) + 1 - NbOfInvisibleColumns;

						current_structure = this.nodes.report.alternate_structure;
						other_structure = this.nodes.report.structure;
					}
					else {
						thisview = this.nodes.report;
						theotherview = this.nodes.alternatereport;
						ColNb = thisview.cols.length;
						
						// Add the column and set the width			
						thisview.setColumnWidth( ColNb - 1 , parseInt(detailheaderfieldElem.getAttribute("width")));
						thisview.addColumn(ColNb + 1); 
						
						// Add the alternate column
						theotherview.setColumnWidth( ColNb - 1 , parseInt(detailheaderfieldElem.getAttribute("width")));
						theotherview.addColumn(ColNb + 1); 
						
						// Set the width for the new blank column
						if (thisview.viewport.dom.contents.offsetWidth < thisview.viewport.dom.main.offsetWidth)
							thisview.setColumnWidth( ColNb , thisview.getColumnWidth( ColNb) + thisview.viewport.dom.main.offsetWidth - thisview.viewport.dom.contents.offsetWidth - 1);
						else
							thisview.setColumnWidth( ColNb , 90 );
						theotherview.setColumnWidth( ColNb , thisview.getColumnWidth(ColNb));

						current_structure = this.nodes.report.structure;
						other_structure = this.nodes.report.alternate_structure;
					}
										
					for (var j = 0; j < dax_bridge.tables[mastertable].fields.length; j++) {
						if (dax_bridge.tables[mastertable].fields[j].fieldid == detailfieldElem.getAttribute("fieldid"))
							ObjectName = dax_bridge.tables[mastertable].fields[j].fieldalias;
					}
					
					// Set the detail header and detail value
					
					// ACI0054926
					//thisview.setCellValue (this.zones.detailHeader, ColNb-1, "<div style='display: inline; position: relative; top: 0px;' class='tab_close tab_close_on' onmousedown='removeColumn(this);return false;'></div><span style='vertical-align: middle;position:relative;top:3px;'> " + detailheaderfieldElem.getAttribute("value") + "</span>");
					thisview.setCellValue (this.zones.detailHeader, ColNb-1, "<div style='height: 20px; top:0px; left:0px; width: 200px; float: left; text-align: left; position: relative; overflow: hidden;'><span style='vertical-align: middle; top: 6px; position:relative;'>"+ detailheaderfieldElem.getAttribute("value") +"</span></div><div style='top: -18px;' class='tab_close tab_close_on' onmousedown='removeColumn(this);return false;'>");
					thisview.setCellValue (this.zones.detail, ColNb-1, '<div style="backgrwidth: 100px; height: 20px; width: 200px; float: left; position:relative; top: 0px; left: 0px;"><img src="dax/themes/basic/images/datatree.png" /><span style="vertical-align: middle;"> ' + ObjectName + '</span></div>');

					// Update the structure					
					// Adds the field to the detailHeader
					var align = detailheaderfieldElem.getAttribute("align");
					
					if (align == undefined)
						align = "center";
						
					current_structure.detailHeader.content[ColNb-2] = {
						value		: detailheaderfieldElem.getAttribute("value"),
						size		: detailheaderfieldElem.getAttribute("width"),
						align		: align
					} 
					if (ColNb > other_structure.detail.content.length + 1) {
						other_structure.detailHeader.content[ColNb-2] = {
							value		: "",
							size		: detailheaderfieldElem.getAttribute("width"),
							align		: "center"
						} 
					}
					
					// Adds the field to the detail
					var align = detailfieldElem.getAttribute("align");
					if (align == "")
						align = "center";
						
					current_structure.detail.content[ColNb-2] = {
						fieldid		: detailfieldElem.getAttribute("fieldid"),
						sort		: "",
						sortid		: "",
						format		: detailfieldElem.getAttribute("format"),
						iPhoneApp	: detailfieldElem.getAttribute("iphonetype"),
						indicators	: new Array(),
						align		: align
					}
					if (ColNb > other_structure.detail.content.length + 1) {
						other_structure.detail.content[ColNb-2] = {
							fieldid		: "",
							sort		: "",
							sortid		: "",
							format		: "",
							iPhoneApp	: "",
							indicators	: new Array(),
							align		: "center"
						}
					}							
					
					if (detailfieldElem.getAttribute("indicator")!=undefined) {
						var indicatorsElems = result.getElementsByTagName("indicators");
						
						for (var k = 0; k < indicatorsElems.length; k++) {
							if (indicatorsElems.item(k).getAttribute("id") == detailfieldElem.getAttribute("indicator")) {
								var indicatorElems = indicatorsElems.item(k).getElementsByTagName("indicator");
			
								for (var h = 0; h < indicatorElems.length; h++) {
									var indicatorElem = indicatorElems.item(h);
									
									if (indicatorElem) {
										var criteriatext = "";
										
										switch (indicatorElem.getAttribute("criteria")) {
											case "equal":
												criteriatext = STR['dash_pi_ind_op1'];
												break;
											case "more":
												criteriatext = STR['dash_pi_ind_op2'];
												break;
											case "less":
												criteriatext = STR['dash_pi_ind_op3'];
												break;		
										}
										
										var colortext = "";
										
										switch (indicatorElem.getAttribute("class")) {
											case "green":
												colortext = STR['dash_pi_ind_style1'];
												break;
											case "yellow":
												colortext = STR['dash_pi_ind_style2'];
												break;
											case "red":
												colortext = STR['dash_pi_ind_style3'];
												break;		
											case "green_button":
												colortext = STR['dash_pi_ind_style4'];
												break;
											case "yellow_button":
												colortext = STR['dash_pi_ind_style5'];
												break;
											case "red_button":
												colortext = STR['dash_pi_ind_style6'];
												break;		
										}
										
										current_structure.detail.content[ColNb-2].indicators[parseInt(h)] = {
											criteria : indicatorElem.getAttribute("criteria"),
											criteriatext: criteriatext,
											value : indicatorElem.getAttribute("value"),
											color : indicatorElem.getAttribute("class"),
											colortext: colortext
										}
									}
								}	
							}
						}
					}
					
					var align = detailfooterfieldElem.getAttribute("align");
					if (align == "")
						align = "right"
										
					// Adds the field to the detailFooter rows
					current_structure.detailFooter.content[ColNb-2] = {
						formula		: "",
						indicators	: new Array (),
						format		: detailfooterfieldElem.getAttribute("format"),
						iPhoneApp	: detailfooterfieldElem.getAttribute("iphonetype"),
						align		: align
					};
					if (other_structure.detailFooter.content[ColNb-2] == undefined)
						other_structure.detailFooter.content[ColNb-2] = {
							formula		: "",
							indicators	: new Array (),
							format		: "",
							iPhoneApp	: "",
							align		: "right"
						};

					if (detailfooterfieldElem.getAttribute("indicator")!=undefined) {
						var indicatorsElems = result.getElementsByTagName("indicators");
						
						for (var k = 0; k < indicatorsElems.length; k++) {
							if (indicatorsElems.item(k).getAttribute("id") == detailfooterfieldElem.getAttribute("indicator")) {
								var indicatorElems = indicatorsElems.item(k).getElementsByTagName("indicator");
			
								for (var h = 0; h < indicatorElems.length; h++) {
									var indicatorElem = indicatorElems.item(h);
									
									if (indicatorElem) {
										var criteriatext = "";
										
										switch (indicatorElem.getAttribute("criteria")) {
											case "equal":
												criteriatext = STR['dash_pi_ind_op1'];
												break;
											case "more":
												criteriatext = STR['dash_pi_ind_op2'];
												break;
											case "less":
												criteriatext = STR['dash_pi_ind_op3'];
												break;		
										}
										
										switch (indicatorElem.getAttribute("class")) {
											case "green":
												colortext = STR['dash_pi_ind_style1'];
												break;
											case "yellow":
												colortext = STR['dash_pi_ind_style2'];
												break;
											case "red":
												colortext = STR['dash_pi_ind_style3'];
												break;		
											case "green_button":
												colortext = STR['dash_pi_ind_style4'];
												break;
											case "yellow_button":
												colortext = STR['dash_pi_ind_style5'];
												break;
											case "red_button":
												colortext = STR['dash_pi_ind_style6'];
												break;		
										}
										
										current_structure.detailFooter.content[ColNb-2].indicators[parseInt(h)] = {
											criteria : indicatorElem.getAttribute("criteria"),
											criteriatext: criteriatext,
											value : indicatorElem.getAttribute("value"),
											color : indicatorElem.getAttribute("class"),
											colortext: colortext
										}
									}
								}	
							}
						}
					}
						
					var formulaCode = "";
																									
					switch (detailfooterfieldElem.getAttribute("formula")) {
						case "##A":
							formulaCode = "Average";
							break;
						case "##C":
							formulaCode = "Count";
							break;
						case "##S":
							formulaCode = "Sum";
							break;
						case "##N":
							formulaCode = "Min";
							break;
						case "##X":
							formulaCode = "Max";
							break;
						case "##D":
							formulaCode = "Standard Deviation";
							break;
						case "##M":
							formulaCode = "Method";
							break;						
						default:
							formulaCode = detailfooterfieldElem.getAttribute("formula");
							break;
					}
					
					// Set the detail footer value
					if (formulaCode!="") {
						thisview.setCellValue (this.zones.detailFooter, ColNb-1, '<div style="backgrwidth: 100px; height: 20px; width: 200px; float: left; position:relative; top: 0px; left: 0px;"><img src="dax/themes/basic/images/console.png" /><span style="vertical-align: middle;"> ' + formulaCode + '</span></div><div style="display: inline; position: relative; top: -18px;" class="tab_close tab_close_on" onmousedown="removeFormula(this);return false;"></div>');

						// Adds the formula to the detail footer
						current_structure.detailFooter.content[ColNb-2].formula = detailfooterfieldElem.getAttribute("formula");
						current_structure.detailFooter.visible = true;
						other_structure.detailFooter.visible = true;
					
					}
								
				}
				else
					NbOfInvisibleColumns++;
			}
		}
		
		for (var i = 0; i < groupheaderZoneElems.length; i++) {
			var groupheaderElem = groupheaderZoneElems.item(i);
			
			if (groupheaderElem) {
				for (var j = 0; j < dax_bridge.tables[mastertable].fields.length; j++) {
					if (dax_bridge.tables[mastertable].fields[j].fieldid == groupheaderElem.getAttribute("fieldid"))
						ObjectName = dax_bridge.tables[mastertable].fields[j].fieldalias;
				}
				
				myReport = this;
				this.addgroup(groupheaderElem.getAttribute("fieldid"), ObjectName);	
				
				var grouphdrformula = groupheaderElem.getElementsByTagName("field").item(NbOfInvisibleColumns).getAttribute("formula");
				
				current_structure.groups[parseInt(groupheaderElem.getAttribute("id")) - 1].headerformula = grouphdrformula;
				other_structure.groups[parseInt(groupheaderElem.getAttribute("id")) - 1].headerformula = grouphdrformula;
				
				if (grouphdrformula != "##G") {
					myReport.nodes.report.setCellValue(myReport.zones.detailHeader + reportgroupnb, 1, '<div style="display: inline; position: relative; top: -2px; float: left;" class="tab_close tab_close_on" onmousedown="deleteGroup(' + reportgroupnb + ');return false;"></div><div style="backgrwidth: 100px; height: 20px; float: left; position:relative; top: 0px; left: 0px;"></div><img src="dax/themes/basic/images/datamatrix.png" /><span style="vertical-align: middle;"> ' + grouphdrformula + '</span>');
					myReport.nodes.alternatereport.setCellValue(myReport.zones.detailHeader + reportgroupnb, 1, '<div style="display: inline; position: relative; top: -2px; float: left;" class="tab_close tab_close_on" onmousedown="deleteGroup(' + reportgroupnb + ');return false;"></div><div style="backgrwidth: 100px; height: 20px; float: left; position:relative; top: 0px; left: 0px;"></div><img src="dax/themes/basic/images/datamatrix.png" /><span style="vertical-align: middle;"> ' + grouphdrformula + '</span>');
				}
								
				var grouphdralign = groupheaderElem.getElementsByTagName("field").item(NbOfInvisibleColumns).getAttribute("align");
				
				current_structure.groups[parseInt(groupheaderElem.getAttribute("id")) - 1].align = grouphdralign;
				other_structure.groups[parseInt(groupheaderElem.getAttribute("id")) - 1].align = grouphdralign;
				
				var grouphdrformat = groupheaderElem.getElementsByTagName("field").item(NbOfInvisibleColumns).getAttribute("format");
				
				current_structure.groups[parseInt(groupheaderElem.getAttribute("id")) - 1].format = grouphdrformat;
				other_structure.groups[parseInt(groupheaderElem.getAttribute("id")) - 1].format = grouphdrformat;
				
				if (groupheaderElem.getAttribute("visible") == "false") {
					current_structure.groups[parseInt(groupheaderElem.getAttribute("id")) - 1].headervisible = false;
					other_structure.groups[parseInt(groupheaderElem.getAttribute("id")) - 1].headervisible = false;
					myReport.nodes.report.setCellValue(parseInt(groupheaderElem.getAttribute("id")),0,"(" + myReport.nodes.report.getCellValue(parseInt(groupheaderElem.getAttribute("id")),0) + ")");
					myReport.nodes.alternatereport.setCellValue(parseInt(groupheaderElem.getAttribute("id")),0,myReport.nodes.report.getCellValue(parseInt(groupheaderElem.getAttribute("id")),0));
				}
				else {
					current_structure.groups[parseInt(groupheaderElem.getAttribute("id")) - 1].headervisible = true;
					other_structure.groups[parseInt(groupheaderElem.getAttribute("id")) - 1].headervisible = true;
				}
				
				for (var j = 0; j < groupfooterZoneElems.length; j++) {
					var groupfooterElem = groupfooterZoneElems.item(j);
					
					if (groupfooterElem) {
						if (groupfooterElem.getAttribute("id") == groupheaderElem.getAttribute("id")) {
							var groupfooterfieldElems = groupfooterElem.getElementsByTagName("field");
							
							for (var k = 0; k < groupfooterfieldElems.length; k++) {
								var groupfooterfieldElem = groupfooterfieldElems.item(k);
								
								if (groupfooterfieldElem.getAttribute("visible")!="false") {

									if (detailheaderfieldElems.item(k).getAttribute("altcol")!=undefined) {
										thisview = this.nodes.alternatereport;
										theotherview = this.nodes.report;
										ColNb = parseInt(detailheaderfieldElem.getAttribute("altcol")) + 1 - NbOfInvisibleColumns;
				
										current_structure = this.nodes.report.alternate_structure;
										other_structure = this.nodes.report.structure;
									}
									else {
										thisview = this.nodes.report;
										theotherview = this.nodes.alternatereport;
										ColNb = k - NbOfInvisibleColumns + 2;
														
										current_structure = this.nodes.report.structure;
										other_structure = this.nodes.report.alternate_structure;
									}
													
									var formulaCode = "";
																													
									switch (groupfooterfieldElem.getAttribute("formula")) {
										case "##A":
											formulaCode = "Average";
											break;
										case "##C":
											formulaCode = "Count";
											break;
										case "##S":
											formulaCode = "Sum";
											break;
										case "##N":
											formulaCode = "Min";
											break;
										case "##X":
											formulaCode = "Max";
											break;
										case "##D":
											formulaCode = "Standard Deviation";
											break;
										case "##M":
											formulaCode = "Method";
											break;						
										default:
											formulaCode = groupfooterfieldElem.getAttribute("formula");
											break;
									}

									// Set the group footer value
									if (formulaCode!="") {
										thisview.setCellValue (this.zones.detailFooter - j - 1, ColNb-1, '<div style="backgrwidth: 100px; height: 20px; width: 200px; float: left; position:relative; top: 0px; left: 0px;"><img src="dax/themes/basic/images/console.png" /><span style="vertical-align: middle;"> ' + formulaCode + '</span></div><div style="display: inline; position: relative; top: -18px;" class="tab_close tab_close_on" onmousedown="removeFormula(this);return false;"></div>');

										var align = groupfooterfieldElem.getAttribute("align");
										if (align == "")
											align = "right"

										// Adds the formula to the group footer
										current_structure.groups[parseInt(groupfooterElem.getAttribute("id")) - 1].footer[ColNb-2] = {
											formula		: groupfooterfieldElem.getAttribute("formula"),
											indicators	: new Array (),
											format		: groupfooterfieldElem.getAttribute("format"),
											iPhoneApp	: groupfooterfieldElem.getAttribute("iphonetype"),
											align		: align
										};
										current_structure.groups[parseInt(groupfooterElem.getAttribute("id")) - 1].footervisible = true;
										other_structure.groups[parseInt(groupfooterElem.getAttribute("id")) - 1].footervisible = true;

										if (groupfooterfieldElem.getAttribute("indicator")!=undefined) {
											var indicatorsElems = result.getElementsByTagName("indicators");
											
											for (var g = 0; g < indicatorsElems.length; g++) {
												if (indicatorsElems.item(g).getAttribute("id") == groupfooterfieldElem.getAttribute("indicator")) {
													var indicatorElems = indicatorsElems.item(g).getElementsByTagName("indicator");
								
													for (var h = 0; h < indicatorElems.length; h++) {
														var indicatorElem = indicatorElems.item(h);
														
														if (indicatorElem) {
															var criteriatext = "";
										
															switch (indicatorElem.getAttribute("criteria")) {
																case "equal":
																	criteriatext = STR['dash_pi_ind_op1'];
																	break;
																case "more":
																	criteriatext = STR['dash_pi_ind_op2'];
																	break;
																case "less":
																	criteriatext = STR['dash_pi_ind_op3'];
																	break;		
															}
															
															switch (indicatorElem.getAttribute("class")) {
																case "green":
																	colortext = STR['dash_pi_ind_style1'];
																	break;
																case "yellow":
																	colortext = STR['dash_pi_ind_style2'];
																	break;
																case "red":
																	colortext = STR['dash_pi_ind_style3'];
																	break;		
																case "green_button":
																	colortext = STR['dash_pi_ind_style4'];
																	break;
																case "yellow_button":
																	colortext = STR['dash_pi_ind_style5'];
																	break;
																case "red_button":
																	colortext = STR['dash_pi_ind_style6'];
																	break;		
															}
															
															current_structure.groups[parseInt(groupfooterElem.getAttribute("id")) - 1].footer[ColNb-2].indicators[parseInt(h)] = {
																criteria : indicatorElem.getAttribute("criteria"),
																criteriatext: criteriatext,
																value : indicatorElem.getAttribute("value"),
																color : indicatorElem.getAttribute("class"),
																colortext: colortext
															}
														}
													}	
												}
											}
										}
									
									}
								}
							}
						}
					}
				}

			}
		}
				
	}
	
	reportgroupnb = 0;
	
	function dax_reporteditor_addgroup (fieldid,fieldalias) {
		
		if (reportgroupnb == 0) {		
			myReport.structure.groups[reportgroupnb] = {
				fieldid			: fieldid, 
				header			: fieldalias,
				headerformula	: "##G",
				align			: "left",
				format			: "",
				headervisible	: true,
				footer			: new Array (),
				footervisible 	: false
			};
			myReport.alternate_structure.groups[reportgroupnb++] = {
				fieldid			: fieldid, 
				header			: fieldalias,
				headerformula	: "##G",
				align			: "left",
				format			: "",
				headervisible	: true,
				footer			: new Array (),
				footervisible 	: false
			};
			
			$('dax_report_reportcontainer').style.height = (3 + reportgroupnb * 2) * 25 + "px"
			$('dax_report_alternatereportcontainer').style.height = (3 + reportgroupnb * 2) * 25 + "px"
			
			for (var j = 0; j < this.structure.detail.content.length; j++) {
				myReport.structure.groups[reportgroupnb-1].footer[j] = {
					formula		: "",
					indicators	: new Array (),
					format		: "",
					iPhoneApp	: "",
					align		: "right"
				};
				myReport.alternate_structure.groups[reportgroupnb-1].footer[j] = {
					formula		: "",
					indicators	: new Array (),
					format		: "",
					iPhoneApp	: "",
					align		: "right"
				};
			}
			
			// Insert Group Header and Footer
			myReport.nodes.report.insertRow(myReport.zones.detailHeader+reportgroupnb);
			myReport.nodes.report.insertRow(myReport.zones.detail+2);
			myReport.nodes.alternatereport.insertRow(myReport.zones.detailHeader+reportgroupnb);
			myReport.nodes.alternatereport.insertRow(myReport.zones.detail+2);
						
			// Make Group Header a block
			this.nodes.report.setBlockRow(this.zones.detailHeader+reportgroupnb, true, 1);
			this.nodes.alternatereport.setBlockRow(this.zones.detailHeader+reportgroupnb, true, 1);
	
			// Set the row titles
			this.nodes.report.setCellValue(this.zones.detailHeader+reportgroupnb,0,STR['dash_de_zone_gh']+reportgroupnb);
			this.nodes.report.setCellValue(this.zones.detail+2,0,STR['dash_de_zone_gf']+reportgroupnb);
			this.nodes.alternatereport.setCellValue(this.zones.detailHeader+reportgroupnb,0,STR['dash_de_zone_gh']+reportgroupnb);
			this.nodes.alternatereport.setCellValue(this.zones.detail+2,0,STR['dash_de_zone_gf']+reportgroupnb);
	
			// Add the group Header value
			this.nodes.report.setCellValue(this.zones.detailHeader+reportgroupnb, 1, '<div style="display: inline; position: relative; top: -2px; float: left;" class="tab_close tab_close_on" onmousedown="deleteGroup('+reportgroupnb+');return false;"></div><div style="backgrwidth: 100px; height: 20px; float: left; position:relative; top: 0px; left: 0px;"></div><img src="dax/themes/basic/images/datamatrix.png" /><span style="vertical-align: middle;"> ' + fieldalias + '</span>');
			this.nodes.alternatereport.setCellValue(this.zones.detailHeader+reportgroupnb, 1, '<div style="backgrwidth: 100px; height: 20px; float: left; position:relative; top: 0px; left: 0px;"></div><img src="dax/themes/basic/images/datamatrix.png" /><span style="vertical-align: middle;"> ' + fieldalias + '</span>');
	
			// Set the styles
			this.nodes.report.setStyleClass(myReport.zones.detailHeader+reportgroupnb, null , "groupheadereditor", "groupheadereditor");
			this.nodes.report.setStyleClass(myReport.zones.detail+2, null , "groupfootereditor", "groupfootereditor");
			this.nodes.report.setStyleClass(null, 0 , "header", "header");
			this.nodes.report.setSelectedStyleClass(myReport.zones.detailHeader+reportgroupnb, null , "groupheadereditor", "groupheadereditor");
			this.nodes.report.setSelectedStyleClass(myReport.zones.detail+2, null , "groupfootereditor_highlight", "groupfootereditor_highlight");
			this.nodes.report.setSelectedStyleClass(null, 0 , "header", "header");
			this.nodes.alternatereport.setStyleClass(myReport.zones.detailHeader+reportgroupnb, null , "groupheadereditor", "groupheadereditor");
			this.nodes.alternatereport.setStyleClass(myReport.zones.detail+2, null , "groupfootereditor", "groupfootereditor");
			this.nodes.alternatereport.setStyleClass(null, 0 , "header", "header");
			this.nodes.alternatereport.setSelectedStyleClass(myReport.zones.detailHeader+reportgroupnb, null , "groupheadereditor", "groupheadereditor");
			this.nodes.alternatereport.setSelectedStyleClass(myReport.zones.detail+2, null , "groupfootereditor_highlight", "groupfootereditor_highlight");
			this.nodes.alternatereport.setSelectedStyleClass(null, 0 , "header", "header");
	
			if (!myReport.nodes.report.viewing_alternate_structure)
				this.nodes.report.redraw(false, true);
			else
				this.nodes.alternatereport.redraw(false, true);
	
			myReport.zones.detail++;
			myReport.zones.detailFooter+=2;
		}
		else {
			
			// Block
			$('dax_report_infocontainer').style.display = "block";
			$('dax_report_infocontainer').style.backgroundColor = "#FAD163";
			$('dax_report_infocontainer').style.color = "#000000";
			$('dax_report_infomessage').innerHTML = STR['dash_error12'];
			
		}

	}
	
	this.initialize = dax_reporteditor_initialize;
	this.save = dax_reporteditor_save;
	this.addgroup = dax_reporteditor_addgroup;
	this.parseXMLStruct = dax_reporteditor_parseXMLStruct;
	
	//this.nodes.container.reportcontainer = getElementByClassName(this.nodes.container, 'dax_report_reportcontainer');
	//this.nodes.container.alternatereportcontainer = getElementByClassName(this.nodes.container, 'dax_report_alternatereportcontainer');
	this.nodes.container.reportcontainer = $('dax_report_reportcontainer');
	this.nodes.container.alternatereportcontainer = $('dax_report_alternatereportcontainer');
	this.nodes.container.objectscontainer = getElementByClassName(this.nodes.container, 'dax_report_objectscontainer');
	this.nodes.container.presetqueriescontainer = getElementByClassName(this.nodes.container, 'dax_report_presetqueriescontainer');
	this.nodes.container.groupscontainer = getElementByClassName(this.nodes.container, 'dax_report_groupscontainer');
	
	this.nodes.report = new dax_superGrid(this.nodes.container.reportcontainer, 0, 1);
	this.nodes.alternatereport = new dax_superGrid(this.nodes.container.alternatereportcontainer, 0, 1);
	this.nodes.report.viewing_alternate_structure = false;

	this.nodes.report.otherview = this.nodes.alternatereport;
	this.nodes.alternatereport.otherview = this.nodes.report;
	
	this.nodes.container.objectscontainer.appendChild(this.nodes.objects);
	this.nodes.container.groupscontainer.appendChild(this.nodes.groups);

	// Populate the list of preset queries
	report_getpresetqueries(dax_bridge.tables[mastertable].tableid);

	var node = GetPopupTemplate("dax_report_presetqueries_popup",currentreportpresetquerieslist,currentreportpresetquerieslist);
	$('dax_report_presetqueries_popupcontainer').innerHTML = "";
	$('dax_report_presetqueries_popupcontainer').appendChild(node);
		
	this.nodes.container.presetqueriescontainer.appendChild(this.nodes.presetqueries)

	dax_bridge.tables[mastertable].cached = false;
	dax_bridge.tables[mastertable].cacheFields();
	for (var i = 0; i < dax_bridge.tables[mastertable].fields.length; i++) {
		
		if (dax_bridge.tables[mastertable].fields[i].fieldtype != "picture") {
			var listitem = getTemplate('dax_report_objects_list_item').cloneNode(true);
			
			listitem.id = 'dax_report_objects_list_item' + i;
			listitem.style.display = "block";
			listitem.childNodes[0].innerHTML = dax_bridge.tables[mastertable].fields[i].fieldalias;
	
			listitem.ObjectType = "Field";
			listitem.ObjectName = dax_bridge.tables[mastertable].fields[i].fieldalias;
			listitem.ObjectFieldID = dax_bridge.tables[mastertable].fields[i].fieldid;
			dax_setDraggable(listitem);		

			listitem.startHoverDragging = dax_startHoverDragging;
			listitem.onmousedown = function(event) {
				var innerHTML = this.innerHTML;
				this.innerHTML = '<img src="dax/themes/basic/images/datatree.png" style="position: relative; top: 3px;"/>';
				
				myReport.setDefaultCursors("droppingField");
				
				var returnvalue = this.startHoverDragging(event);
				
				this.innerHTML = innerHTML;
				
				return returnvalue;
			}
			
			listitem.ondragrelease = function(event) {
				
				myReport.setDefaultCursors("default");
				
			}
			
			$('dax_report_objects_list').appendChild(listitem);
			
			var groupitem = getTemplate('dax_report_groups_list_item').cloneNode(true);
			
			groupitem.id = 'dax_report_group_list_item' + i;
			groupitem.style.display = "block";
			groupitem.childNodes[0].innerHTML = dax_bridge.tables[mastertable].fields[i].fieldalias;
			groupitem.childNodes[0].fieldid = dax_bridge.tables[mastertable].fields[i].fieldid;
			groupitem.childNodes[0].fieldalias = dax_bridge.tables[mastertable].fields[i].fieldalias;
			groupitem.childNodes[0].onclick = function () {
				myReport.addgroup(this.fieldid,this.fieldalias);
			}
			
			$('dax_report_groups_list').appendChild(groupitem);
		}		
	}		
	
	if (this.targetNode)
		this.targetNode.appendChild(this.nodes.container);

/*
	if ($('dax_report_objects_list_item')!=undefined)
		$('dax_report_objects_list_item').style.display = 'none';
	if ($('dax_report_groups_list_item')!=undefined)
	$('dax_report_groups_list_item').style.display = 'none';
*/	
	this.initialize();
	
	$('dax_report_usechart').checked = false;
	if (XMLStruct != undefined)
		this.parseXMLStruct(XMLStruct);

	// setting the mouse over cursors
	this.setDefaultCursors("default");
		
	if (this.platform == "Desktop") {
		this.nodes.report.viewport.showHorScrollbar(true);
		this.nodes.report.otherview.viewport.showHorScrollbar(true);

		$('dax_report_desktopstyles').style.display = "inline";
		$('dax_report_iphonestyles').style.display = "none";
	}
	else {
		this.nodes.report.viewport.showHorScrollbar(false);
		this.nodes.report.otherview.viewport.showHorScrollbar(false);
								
		$('dax_report_desktopstyles').style.display = "none";
		$('dax_report_iphonestyles').style.display = "inline";
	}
		
}

function report_switchToAlternateColumns() {
	$('dax_report_showalternatecolumns').style.display = 'none';
	$('dax_report_showregularcolumns').style.display = 'block';
	$('dax_report_reportcontainer').style.display = 'none';
	$('dax_report_alternatereportcontainer').style.display = 'block';
	myReport.nodes.report.viewing_alternate_structure = true;
	
	myReport.nodes.alternatereport.redraw(true,true);

	for (var j = 0; j < myReport.structure.detail.content.length; j++)
		myReport.nodes.alternatereport.setColumnWidth(parseInt(j)+1, myReport.nodes.report.cols[parseInt(j)+1].colWidth);

	$('dax_report_infocontainer').style.display = "block";
	$('dax_report_infocontainer').style.backgroundColor = "#FAD163";
	$('dax_report_infocontainer').style.color = "#000000";
	$('dax_report_infomessage').innerHTML = STR['dash_error13'];

}

function report_switchToDefaultColumns() {
	$('dax_report_showregularcolumns').style.display = 'none';
	$('dax_report_showalternatecolumns').style.display = 'block';
	$('dax_report_reportcontainer').style.display = 'block';
	$('dax_report_alternatereportcontainer').style.display = 'none';
	myReport.nodes.report.viewing_alternate_structure = false;

	for (var j = 0; j < myReport.structure.detail.content.length; j++)
		myReport.nodes.report.setColumnWidth(parseInt(j)+1, myReport.nodes.alternatereport.cols[parseInt(j)+1].colWidth);

	myReport.nodes.report.redraw(true,true);

	$('dax_report_infocontainer').style.display = "none";

}

function deleteIndicator(indicator, row, column) {
	var reportstructure = "";

	if (myReport.nodes.report.viewing_alternate_structure)
		reportstructure = myReport.nodes.report.alternate_structure;
	else
		reportstructure = myReport.nodes.report.structure;

	if (row == myReport.zones.detail)
		thiscellstructure = reportstructure.detail.content[column-1];
	else
		if (row < myReport.zones.detailFooter)
			thiscellstructure = reportstructure.groups[myReport.zones.detailFooter - row - 1].footer[column-1];
		else
			thiscellstructure = reportstructure.detailFooter.content[column-1];

	thiscellstructure.indicators.splice(indicator,1);
	
	$('AdminPropertiesIndicators_Filter_List').innerHTML = "";

	// Update Property Inspector	
	if (thiscellstructure.indicators.length > 0)
		$('AdminPropertiesIndicators_Filter_None').style.display = 'none';
	else
		$('AdminPropertiesIndicators_Filter_None').style.display = 'block';
		
	for (var i = 0; i < thiscellstructure.indicators.length; i++)
		$('AdminPropertiesIndicators_Filter_List').innerHTML += "<center><br><div style='display: inline; position: relative; top: -2px;' class='tab_close tab_close_on' onmousedown='deleteIndicator("+i+","+row+","+column+");return false;'></div><b>" + thiscellstructure.indicators[i].criteriatext + "</b> " + thiscellstructure.indicators[i].value + " <b>" + thiscellstructure.indicators[i].colortext + "</b></center>";
}

function report_useChart(value) {
	
	myReport.structure.usechart = value;
	
}

function removeColumn(obj){

	var columnNb = obj.parentNode.column+1;

	myReport.nodes.report.setSelected(null, null, false);
	myReport.nodes.alternatereport.setSelected(null, null, false);

	myReport.nodes.report.onCellClick(null,null);	
	
	if (!myReport.nodes.report.viewing_alternate_structure) {
		// Delete Default Columns
		myReport.nodes.report.removeColumn(columnNb - 1);
		
		myReport.structure.detailHeader.content.splice(columnNb - 2, 1);
		myReport.structure.detail.content.splice(columnNb - 2, 1);
		for (var i = 0; i < myReport.structure.groups.length; i++) {
			myReport.structure.groups[i].footer.splice(columnNb - 2, 1);
		}
		myReport.structure.detailFooter.content.splice(columnNb - 2, 1);
		
		var NbOfColumns = myReport.nodes.report.cols.length;
		
		if (myReport.nodes.report.viewport.dom.contents.offsetWidth < myReport.nodes.report.viewport.dom.main.offsetWidth) 
			myReport.nodes.report.setColumnWidth(myReport.nodes.report.cols.length - 1, myReport.nodes.report.getColumnWidth(myReport.nodes.report.cols.length - 1) + myReport.nodes.report.viewport.dom.main.offsetWidth - myReport.nodes.report.viewport.dom.contents.offsetWidth);
		
		// Delete Alternate Columns
		myReport.nodes.alternatereport.removeColumn(columnNb - 1);
		
		myReport.alternate_structure.detailHeader.content.splice(columnNb - 2, 1);
		myReport.alternate_structure.detail.content.splice(columnNb - 2, 1);
		
		for (var i = 0; i < myReport.alternate_structure.groups.length; i++) {
			myReport.alternate_structure.groups[i].footer.splice(columnNb - 2, 1);
		}
		myReport.alternate_structure.detailFooter.content.splice(columnNb - 2, 1);
		
		myReport.nodes.report.otherview.setColumnWidth(myReport.nodes.report.cols.length - 1, myReport.nodes.report.getColumnWidth(myReport.nodes.report.cols.length - 1));
		
	}
	else {
	
		myReport.nodes.alternatereport.setCellValue(myReport.zones.detailHeader, columnNb - 1, "");
		myReport.nodes.alternatereport.setCellValue(myReport.zones.detail, columnNb - 1, "");
		
		myReport.alternate_structure.detailHeader.content[columnNb-2].value = "";
		myReport.alternate_structure.detail.content[columnNb-2].value = "";
				
		myReport.alternate_structure.detailFooter.content[columnNb-2].format = "";
		myReport.alternate_structure.detailFooter.content[columnNb-2].formula = "";
		myReport.alternate_structure.detailFooter.content[columnNb-2].iPhoneApp = "";
		myReport.alternate_structure.detailFooter.content[columnNb-2].indicator = [];
	}
		
}

function deleteGroup(groupNb) {
	
	myReport.nodes.report.removeRow(groupNb);
	myReport.nodes.report.removeRow(myReport.zones.detailFooter-groupNb-1);
	
	myReport.nodes.alternatereport.removeRow(groupNb);
	myReport.nodes.alternatereport.removeRow(myReport.zones.detailFooter-groupNb-1);
	
	myReport.zones.detail--;
	myReport.zones.detailFooter-=2;
	
	myReport.structure.groups.splice(groupNb,1);
	myReport.alternate_structure.groups.splice(groupNb,1);
	
	reportgroupnb--;
	
}

function removeFormula(obj) {
	
	var colNb = obj.parentNode.column;
	var rowNb = obj.parentNode.row;
	
	var reportstructure = "";
	var thisgrid = "";

	if (myReport.nodes.report.viewing_alternate_structure) {
		reportstructure = myReport.nodes.report.alternate_structure;
		other_structure = myReport.nodes.report.structure;
		thisgrid = myReport.nodes.alternatereport;
	}
	else {
		reportstructure = myReport.nodes.report.structure;
		other_structure = myReport.nodes.report.alternate_structure;
		thisgrid = myReport.nodes.report;
	}
	
	thisgrid.setCellValue(rowNb,colNb,"");

	// Adds the formula to the group footer
	if (rowNb < myReport.zones.detailFooter) {
		reportstructure.groups[myReport.structure.groups.length - rowNb + myReport.zones.detail].footer[colNb-1] = {
			formula		: "",
			indicators	: new Array (),
			format		: "",
			iPhoneApp	: "",
			align		: "right"
		};
		reportstructure.groups[myReport.structure.groups.length - rowNb + myReport.zones.detail].footervisible = false;
		other_structure.groups[myReport.structure.groups.length - rowNb + myReport.zones.detail].footervisible = false;
		for (var i = 0; i < reportstructure.groups[myReport.structure.groups.length - rowNb + myReport.zones.detail].footer.length; i++) {
			if (reportstructure.groups[myReport.structure.groups.length - rowNb + myReport.zones.detail].footer[i].formula!="") {
				reportstructure.groups[myReport.structure.groups.length - rowNb + myReport.zones.detail].footervisible = true;
				other_structure.groups[myReport.structure.groups.length - rowNb + myReport.zones.detail].footervisible = true;
			}
		}
	}
	
	// Adds the formula to the detail footer
	if (rowNb == myReport.zones.detailFooter) {
		reportstructure.detailFooter.content[colNb-1] = {
			formula		: "",
			indicators	: new Array (),
			format		: "",
			iPhoneApp	: "",
			align		: "right"
		};
		reportstructure.detailFooter.visible = false;
		other_structure.detailFooter.visible = false;
		for (var i = 0; i < reportstructure.detailFooter.content.length; i++) {
			if (reportstructure.detailFooter.content[i].formula!="") {
				reportstructure.detailFooter.visible = true;
				other_structure.detailFooter.visible = true;
			}
		}
	}
	
}

function report_updateHeaderText(obj) {
	var reportstructure = "";
	var thisgrid = "";

	if (myReport.nodes.report.viewing_alternate_structure) {
		reportstructure = myReport.nodes.report.alternate_structure;
		other_structure = myReport.nodes.report.structure;
		thisgrid = myReport.nodes.alternatereport;
		selectedCells = myReport.nodes.alternatereport.getSelected();
	}
	else {
		reportstructure = myReport.nodes.report.structure;
		other_structure = myReport.nodes.report.alternate_structure;
		thisgrid = myReport.nodes.report;
		selectedCells = myReport.nodes.report.getSelected();
	}
	
	thisgrid.setCellValue (myReport.zones.detailHeader, selectedCells[0].column, "<div style='display: inline; position: relative; top: 0px;' class='tab_close tab_close_on' onmousedown='removeColumn(this);return false;'></div><span style='vertical-align: middle;position:relative;top:3px;'> " + obj.value + "</span>");
	reportstructure.detailHeader.content[selectedCells[0].column-1].value = obj.value;
}

function report_updateColumnWidth(obj) {
	var reportstructure = "";
	var thisgrid = "";

	if (myReport.nodes.report.viewing_alternate_structure) {
		reportstructure = myReport.nodes.report.alternate_structure;
		other_structure = myReport.nodes.report.structure;
		thisgrid = myReport.nodes.alternatereport;
		theothergrid = myReport.nodes.report;
		selectedCells = myReport.nodes.alternatereport.getSelected();
	}
	else {
		reportstructure = myReport.nodes.report.structure;
		other_structure = myReport.nodes.report.alternate_structure;
		thisgrid = myReport.nodes.report;
		theothergrid = myReport.nodes.alternatereport;
		selectedCells = myReport.nodes.report.getSelected();
	}
	
	thisgrid.setColumnWidth (selectedCells[0].column, obj.value);
	theothergrid.setColumnWidth (selectedCells[0].column, obj.value);
}

function report_updateHeaderAlign(obj) {
	var reportstructure = "";
	var thisgrid = "";

	if (myReport.nodes.report.viewing_alternate_structure) {
		reportstructure = myReport.nodes.report.alternate_structure;
		other_structure = myReport.nodes.report.structure;
		thisgrid = myReport.nodes.alternatereport;
		theothergrid = myReport.nodes.report;
		selectedCells = myReport.nodes.alternatereport.getSelected();
	}
	else {
		reportstructure = myReport.nodes.report.structure;
		other_structure = myReport.nodes.report.alternate_structure;
		thisgrid = myReport.nodes.report;
		theothergrid = myReport.nodes.alternatereport;
		selectedCells = myReport.nodes.report.getSelected();
	}

	reportstructure.detailHeader.content[selectedCells[0].column-1].align = obj.options[obj.selectedIndex].value;
}

function report_updateDetailAlign(obj) {
	var reportstructure = "";
	var thisgrid = "";

	if (myReport.nodes.report.viewing_alternate_structure) {
		reportstructure = myReport.nodes.report.alternate_structure;
		other_structure = myReport.nodes.report.structure;
		thisgrid = myReport.nodes.alternatereport;
		theothergrid = myReport.nodes.report;
		selectedCells = myReport.nodes.alternatereport.getSelected();
	}
	else {
		reportstructure = myReport.nodes.report.structure;
		other_structure = myReport.nodes.report.alternate_structure;
		thisgrid = myReport.nodes.report;
		theothergrid = myReport.nodes.alternatereport;
		selectedCells = myReport.nodes.report.getSelected();
	}

	reportstructure.detail.content[selectedCells[0].column-1].align = obj.options[obj.selectedIndex].value;
}

function report_updateFormulaAlign(obj) {
	var reportstructure = "";
	var thisgrid = "";

	if (myReport.nodes.report.viewing_alternate_structure) {
		reportstructure = myReport.nodes.report.alternate_structure;
		other_structure = myReport.nodes.report.structure;
		thisgrid = myReport.nodes.alternatereport;
		theothergrid = myReport.nodes.report;
		selectedCells = myReport.nodes.alternatereport.getSelected();
	}
	else {
		reportstructure = myReport.nodes.report.structure;
		other_structure = myReport.nodes.report.alternate_structure;
		thisgrid = myReport.nodes.report;
		theothergrid = myReport.nodes.alternatereport;
		selectedCells = myReport.nodes.report.getSelected();
	}
	
	if (selectedCells[0].row < myReport.zones.detailFooter) 
		thiscellstructure = reportstructure.groups[myReport.zones.detailFooter - selectedCells[0].row - 1].footer[selectedCells[0].column - 1];
	else 
		thiscellstructure = reportstructure.detailFooter.content[selectedCells[0].column - 1];

	thiscellstructure.align = obj.options[obj.selectedIndex].value;
}

function report_updateFormulaText(obj) {
	var reportstructure = "";
	var thisgrid = "";

	if (myReport.nodes.report.viewing_alternate_structure) {
		reportstructure = myReport.nodes.report.alternate_structure;
		other_structure = myReport.nodes.report.structure;
		thisgrid = myReport.nodes.alternatereport;
		selectedCells = myReport.nodes.alternatereport.getSelected();
	}
	else {
		reportstructure = myReport.nodes.report.structure;
		other_structure = myReport.nodes.report.alternate_structure;
		thisgrid = myReport.nodes.report;
		selectedCells = myReport.nodes.report.getSelected();
	}
	
	if (selectedCells[0].row < myReport.zones.detailFooter) 
		thiscellstructure = reportstructure.groups[myReport.zones.detailFooter - selectedCells[0].row - 1].footer[selectedCells[0].column - 1];
	else 
		thiscellstructure = reportstructure.detailFooter.content[selectedCells[0].column - 1];

	thisgrid.setCellValue (selectedCells[0].row, selectedCells[0].column, '<div style="backgrwidth: 100px; height: 20px; width: 200px; float: left; position:relative; top: 0px; left: 0px;"><img src="dax/themes/basic/images/console.png" /><span style="vertical-align: middle;"> ' + obj.value + '</span></div><div style="display: inline; position: relative; top: -18px;" class="tab_close tab_close_on" onmousedown="removeFormula(this);return false;"></div>');
	thiscellstructure.formula = obj.value;
}

function report_updateGroupHeaderAlign(obj) {

	thiscellstructure = myReport.nodes.report.structure.groups[reportgroupnb - 1];
	thisothercellstructure = myReport.nodes.report.alternate_structure.groups[reportgroupnb - 1];
	
	thiscellstructure.align = obj.options[obj.selectedIndex].value;
	thisothercellstructure.align = obj.options[obj.selectedIndex].value;
}

function report_updateGroupHeaderText(obj) {
	
	thiscellstructure = myReport.nodes.report.structure.groups[reportgroupnb - 1];
	thisothercellstructure = myReport.nodes.report.alternate_structure.groups[reportgroupnb - 1];
	
	myReport.nodes.report.setCellValue (myReport.zones.detailHeader+reportgroupnb, 1, '<div style="display: inline; position: relative; top: -2px; float: left;" class="tab_close tab_close_on" onmousedown="deleteGroup('+reportgroupnb+');return false;"></div><div style="backgrwidth: 100px; height: 20px; float: left; position:relative; top: 0px; left: 0px;"></div><img src="dax/themes/basic/images/datamatrix.png" /><span style="vertical-align: middle;"> ' + obj.value + '</span>');
	myReport.nodes.alternatereport.setCellValue (myReport.zones.detailHeader+reportgroupnb, 1, '<div style="display: inline; position: relative; top: -2px; float: left;" class="tab_close tab_close_on" onmousedown="deleteGroup('+reportgroupnb+');return false;"></div><div style="backgrwidth: 100px; height: 20px; float: left; position:relative; top: 0px; left: 0px;"></div><img src="dax/themes/basic/images/datamatrix.png" /><span style="vertical-align: middle;"> ' + obj.value + '</span>');

	thiscellstructure.headerformula = obj.value;
	thisothercellstructure.headerformula = obj.value;
}

function report_getpresetqueries(tableid) {
 	var sessionId = connection.sessionId;
 
 	if (sessionId == "")
 		return;
 			
	var http_request = getXMLHttpRequest();
		
	if (http_request) {
		
		var url = connection.address.admingetQueryList+"?sessionId="+sessionId;
		
		http_request.onreadystatechange = 
			function() {
				reportparseQueryList(http_request, tableid);
			};
			
		try {
			
			debugAlert('<b>Admin:</b>'+'<a href="'+url+'" target="_blank">'+url+'</a>');
	
			http_request.open("GET", url, false); // synccall
	  	  	http_request.send(null);
	   	} catch(e) {
	   		delete http_request;
		}
	}	
}

function reportparseQueryList(http_request, filter)
{
	if (http_request.readyState != 4)
		return;
		
	var result = http_request.responseXML.getElementsByTagName("queries").item(0);
	var responseError = checkResponse (http_request);
		
	if (!isDefined(result)) {
		return false;
	}
	
	currentreportpresetquerieslist = ['none'];
	
	var queryElems= result.getElementsByTagName("query");
				
	for (var i = 0; i < queryElems.length; i++) {
		var queryElem = queryElems.item(i);
		
		if (queryElem) {
		
			var tableid = queryElem.getAttribute("tableid");
			
			if (tableid == filter)
				if (queryElem.getAttribute("name").match("4daf_unique_")==null)
					currentreportpresetquerieslist.push(queryElem.getAttribute("name"));
			
		}
	}
			
	// free
	delete http_request;


};

