//
// TaskbarObject
// Rudolf Psenicnik

function taskbarObject () {

	var node = getTemplate("dax_taskbar");
	var expandWindow = getTemplate ('dax_taskbar_expand_window');
	
	if (!node)
		return null;
	
	this.dom = node;
	this.expandWindow = expandWindow;
	
	this.taskbarItems = new Array();
	this.taskbarexpand = getElementByClassName (this.dom, 'dax_taskbar_expand', true);
	this.isExpanded = false;
	this.currentPosition = 'top';
	
	document.body.appendChild (this.expandWindow);
	
	// handle unique id number
	i = 1;
	while ($('dax_taskbar' + i) != null) {
		i++;
	}
	
	this.idNumber = i;
	this.dom.id = 'dax_taskbar' + this.idNumber;
	this.taskbarexpand.id = 'dax_taskbar_expand' + this.idNumber;

	// insert taskbar and dummy
	var body = document.body;
	body.insertBefore(this.dom, body.firstChild);
	
	setStyle (this.dom, 'display','block');

	// fix for ie6
	if (browser.ie6) {
		this.dom.style.position = 'absolute';
		this.expandWindow.style.position = 'absolute';
	}
	
	
	// default display
	this.dom.style.display = "block";

	this.dom.className = 'dax_taskbar_top';

	this.position = function(newPosition) {
		switch (newPosition) {
			case 'top': 
				this.dom.className = 'dax_taskbar_top';
				this.expandWindow.className = 'dax_taskbar_expand_window';
				this.currentPosition = 'top';
				this.setHorButtons ();
				break
			case 'bottom': 
				this.dom.className = 'dax_taskbar_bottom';
				this.expandWindow.className = 'dax_taskbar_expand_window_bottom';
				this.currentPosition = 'bottom';
				this.setHorButtons ();
				break
			default:
				this.dom.className = 'dax_taskbar_top';
				this.setHorButtons ();
		}
	}

	this.setHorButtons = function () {
		buttons = getElementsByClassName (this.dom, 'dax_taskbar_button', true);
		for (i = 0; i < buttons.length; i++) {
			buttons[i].className = 'dax_taskbar_button dax_taskbar_button_hor';
		}		
	}
	
	// checks if all buttons fit on the taskbar
	// moves the 'extras' on the side expand window
	this.refresh = function () {
		var expandNeeded = false;
		expButtons = getElementsByClassName (this.expandWindow, 'dax_taskbar_button', true);
		if (expButtons.length > 0) {
			for (i = 0; i < expButtons.length; i++) {
				this.dom.appendChild(expButtons[i]);
				expButtons[i].isExtended = false;
				setStyle (expButtons[i], 'clear', 'none');
			}
		}
		var buttons = new Array (0);
		buttons = getElementsByClassName (this.dom, 'dax_taskbar_button', true);
		if (buttons.length > 0) {
			for (i = 0; i < buttons.length; i++) {
				try {
					if ((buttons[i].offsetTop > 10) || (buttons[i].offsetHeight > 30)){
						setStyle (buttons[i], 'clear', 'both');
						this.expandWindow.appendChild (buttons[i]);
						buttons[i].isExtended = true;
						expandNeeded = true;
					}
				} catch (er) {
//					alert (buttons[i]);
				}
			}
		}
		if (expandNeeded == true) {
			setStyle (this.taskbarexpand, 'display', 'block');
			if (this.isExpanded == true) { 
				setStyle (this.expandWindow, 'display', 'block');
			}
		} else {
			setStyle (this.taskbarexpand, 'display', 'none');
			setStyle (this.expandWindow, 'display', 'none');
		}
		// if browser is ie6, we'll need custom positioning
		if (browser.ie6) {
			var windowHeight = getWindowHeight();
			var scrollPosition = document.body.scrollTop;
			var toolbarHeight = this.dom.offsetHeight;
			if (this.currentPosition == 'top') {
				this.dom.style.top = scrollPosition + 'px';
				this.expandWindow.style.top = scrollPosition + toolbarHeight + 'px';
			} else {
				this.dom.style.top = scrollPosition + windowHeight - this.dom.offsetHeight + 'px';
				this.expandWindow.style.top = scrollPosition + windowHeight - toolbarHeight - this.expandWindow.offsetHeight + 'px';
			}
		}
	}

	this.taskbarexpand.parent = this;
	
	this.taskbarexpand.onmouseover = function (){
		this.className = 'dax_taskbar_expand dax_taskbar_expand_over';
	}
	
	this.taskbarexpand.onmouseout = function () {
		if (this.parent.isExpanded == false) {
			this.className = 'dax_taskbar_expand dax_taskbar_expand_normal';
		} else {
			this.className = 'dax_taskbar_expand dax_taskbar_expand_selected';
		}
	}

	this.taskbarexpand.onclick = function () {
		if (this.parent.isExpanded == false) {
			this.className = 'dax_taskbar_expand dax_taskbar_expand_selected';
			setStyle (this.parent.expandWindow, 'display', 'block');
			this.parent.isExpanded = true;
		} else {
			this.className = 'dax_taskbar_expand dax_taskbar_expand_normal';
			setStyle (this.parent.expandWindow, 'display', 'none');
			this.parent.isExpanded = false;
		}
	}

	// returns an item object of passed dom
	this.findItemObject = function(domRef) {
		for (i; i < this.taskbarItems.length; i++) {
			if (domRef == this.taskbarItems[i].dom) {
				return this.taskbarItems[i];
			}
		}
		return null;
	}

	{
		setStyle(this.dom, "display", "none");
	}
}

function taskbarItem (aParent) {

	if (!aParent)
		return false;

	var node = getTemplate ("dax_taskbar_button");
	
	this.parent = aParent;
	
	this.parent.dom.appendChild(node);
	this.parent.taskbarItems.push(this);
	
	this.dom = node;
	this.dom.parent = this;

	this.button_l = getElementByClassName (this.dom, 'button_l', true);
	this.button_m = getElementByClassName (this.dom, 'button_m', true);
	this.button_r = getElementByClassName (this.dom, 'button_r', true);
	this.icon = getElementByClassName (this.dom, 'icon', true);

	this.selected = false;
	
	// used for duplicate buttons in expanded window
	this.dom.isExtended = false;
	
	// handle unique id number
	i = 1;
	while ($('dax_taskbar_button' + i) != null) {
		i++;
	}
	
	this.dom.id = 'dax_taskbar_button' + i;

	// set id's for the button elements as well

	this.button_l.id = 'button_l' + i;
	this.button_m.id = 'button_m' + i;
	this.button_r.id = 'button_r' + i;
	
	// mouse events
	
	this.dom.onmouseover = function () {
		this.parent.button_l.className = 'button_l button_over_l';
		this.parent.button_m.className = 'button_m button_over_m';
		this.parent.button_r.className = 'button_r button_over_r';
	}

	this.dom.onmouseout = function () {
		if (this.parent.selected == true) {
			this.parent.button_l.className = 'button_l button_down_l';
			this.parent.button_m.className = 'button_m button_down_m';
			this.parent.button_r.className = 'button_r button_down_r';
		} else {
			this.parent.button_l.className = 'button_l button_normal_l';
			this.parent.button_m.className = 'button_m button_normal_m';
			this.parent.button_r.className = 'button_r button_normal_r';
		}
	}	

	this.dom.onmousedown = function () {
		this.parent.button_l.className = 'button_l button_down_l';
		this.parent.button_m.className = 'button_m button_down_m';
		this.parent.button_r.className = 'button_r button_down_r';
	}	

	this.dom.onmouseup = function () {
		this.parent.button_l.className = 'button_l button_over_l';
		this.parent.button_m.className = 'button_m button_over_m';
		this.parent.button_r.className = 'button_r button_over_r';
	}
	
	// set and get button label
	this.setLabel = function (newLabel) {
		labelParent = getElementByClassName (this.dom, 'button_text');
		label = getTextNode (labelParent);
		label.nodeValue = newLabel;
	}
	this.getLabel = function () {
		labelParent = getElementByClassName (this.dom, 'button_text');
		label = getTextNode (labelParent);
		return (label.nodeValue);
	}
	
	this.setSelected = function (selected, unselectOthers) {
		// unselect other taskbar elements
		if (unselectOthers == true) {
			for (i = 0; i < this.parent.taskbarItems.length; i++) {
				if (this.parent.taskbarItems[i].selected == true) {
					this.parent.taskbarItems[i].button_l.className = 'button_l button_normal_l';
					this.parent.taskbarItems[i].button_m.className = 'button_m button_normal_m';
					this.parent.taskbarItems[i].button_r.className = 'button_r button_normal_r';
					this.parent.taskbarItems[i].selected = false;
				}
			}
		}
		
		if (selected == true) {
			this.button_l.className = 'button_l button_down_l';
			this.button_m.className = 'button_m button_down_m';
			this.button_r.className = 'button_r button_down_r';
			this.selected = true;
		} else {
			this.button_l.className = 'button_l button_normal_l';
			this.button_m.className = 'button_m button_normal_m';
			this.button_r.className = 'button_r button_normal_r';
			this.selected = false;
		}
	}
	
	// set button icon
	//newIcon - URL to the icon
	this.setIcon = function (newIcon) {
		this.icon.className = newIcon;
	}
	
	this.remove = function () {
		for (i; i < this.parent.taskbarItems.length; i++) {
			if (this.dom == this.parent.taskbarItems[i].dom) {
				removed = this.parent.taskbarItems.splice(i,1);
			}
		}
		if (this.dom) {
			if (this.dom.isExtended == true) {
				this.parent.expandWindow.removeChild (this.dom);
			} else {
				this.parent.dom.removeChild (this.dom);
			}
		}
		this.parent.refresh();
	}
	
	// J.L. - added initializer
	{
		setStyle(this.dom, "display", "none");
	}
}