// tools.js by Jonathan Le

function $(id)
{
	var elem = document.getElementById(id);
	return elem;
}


// assert
function assert(id, string)
{
	var el = document.getElementById(id);
	if (!isDefined(el) || el.nodeType != 1) {
		document.write(string);
	} else {
		el.innerHTML = string;
	}
}

function isDefined(variable)
{
	return variable != null && variable != undefined
}

function Browser() {
	var ua = navigator.userAgent;
	
	this.ie = false;
	this.ie6 = false;
	this.ie7 = false;
	this.gecko = false;
	this.safari = false;
	this.safari2 = false;
	this.safari3 = false;
	
	if (ua.indexOf("MSIE") >= 0) {
		this.ie = true;
		if (ua.indexOf("MSIE 7") >= 0) {
			this.ie7 = true;
		}	
		if (ua.indexOf("MSIE 6") >= 0) {
			this.ie6 = true;
		}	
	} else if (ua.indexOf("iPhone") >= 0) {
		this.iphone = true;
		this.safari = true;
	} else if (ua.indexOf("WebKit") >= 0) {
		this.safari = true;
		if (ua.indexOf("Version/3") >= 0) {
			this.safari3 = true;
		} else {
			this.safari2 = true;
		}
	} else if (ua.indexOf("Gecko") >= 0) {
		this.gecko = true;
	}
	
	this.theme = "basic";
	this.themePath = "themes/" + this.theme + "/";
}

var browser = new Browser();

function OS() {
	var os = navigator.appVersion;
	
	this.mac = false;
	this.win = false;
	this.linux = false;
	this.unix = false;
	
	if (os.indexOf("Win") >= 0) {
		this.win = true;
	} else if (os.indexOf("Mac") >= 0) {
		this.mac = true;
	} else if (os.indexOf("X11") >= 0) {
		this.unix = true;
	} else if (os.indexOf("Linux") >= 0) {
		this.linux = true;
	}

}

var os = new OS();


 function getParentByClassName(child, className, matchString)
 {
  // find the parent
  var parent = null;
  while (child && !parent) {
   if (!matchString)
    var matched = (child.className == className) ? true : false;
   else
    var matched = (child.className.indexOf(className) != -1) ? true : false;
   
   if (matched)
    parent = child;
   else
    child = child.parentNode;
  }
  
  return parent;
 }

function getElementsByClassName(parent, className, match)
{
	var elements = new Array(0);

	if (parent.nodeType == 1) {
		if (match != null && match != undefined && match) {
			var cname = parent.className != undefined ? parent.className : "";
			if (cname.indexOf(className) >= 0) {
				elements.push(parent);
			}
		} else {
			if (parent.className == className)
				elements.push(parent);
		}
	
		if (parent.hasChildNodes()) {
			var children = parent.childNodes;
			for (var i = 0; i < children.length; i++) {
				elements = elements.concat(getElementsByClassName(children[i], className, match));
			}
		}
	}
	return elements;
}

function getElementByClassName(parent, className, match)
{
	if (!parent || className == "")
		return null;
	
	if (match != null && match != undefined && match) {
		var cname = parent.className != undefined ? parent.className : "";
		if (cname.indexOf(className) >= 0) {
			return parent;
		}
	} else {
		if (parent.className == className)
			return parent;
	}
	
	// get the first level of children
	var children = parent.childNodes;
	var node = null;
	var i = 0;
	
	while (!node && i < children.length) {
		node = getElementByClassName(children.item(i), className, match);
		i++;
	}
			
	return node;
}

function getCSSPropertyValue(className, property)
{
  	var className = "." +className;
   	
	if (browser.ie) {
		rules = document.styleSheets.item(0).rules;
	} else {
		rules = document.styleSheets.item(0).cssRules;
	}
	
	var value = "";
	var st = "";
		
	for (var i = 0; i < rules.length; i++) {
		st = rules.item(i).selectorText;
		
		if (st) {
			var tokens = st.split(',');
			
			for (var k = 0; k < tokens.length; k++) {
				if (strip(tokens[k], ' ') == className) {
					if (browser.ie) {
						value = rules.item(i).style.getAttribute(property);
					} else {
						value = rules.item(i).style.getPropertyValue(property);
					}
					
					// break
					k = tokens.length;
					i = rules.length;					
				}
			}
		}
   	}
   	
   	return value;
}

function dax_setNodeWidth(nodeRef, width) {
	
	var padding = parseInt(getStyle(nodeRef,'padding-left', 'paddingLeft'),10) + parseInt(getStyle(nodeRef,'padding-right', 'paddingRight'),10);
	var margin = parseInt(getStyle(nodeRef,'margin-left', 'marginLeft'),10) + parseInt(getStyle(nodeRef,'margin-right', 'marginLeft'),10);
	var border = parseInt(getStyle(nodeRef,'border-left-width', 'borderLeftWidth'),10) + parseInt(getStyle(nodeRef,'border-right-width', 'borderRightWidth'),10);
	
	// for IE7
	if (!padding)
		padding = 0;
	if (!margin)
		margin = 0;
	if (!border)
		border = 0;
		
	width = width - padding - margin - border;
	
	nodeRef.style.width = width + 'px';
	
}

function dax_setNodeHeight(nodeRef, height) {

	var padding = parseInt(getStyle(nodeRef,'padding-top', 'paddingTop'),10) + parseInt(getStyle(nodeRef,'padding-bottom', 'paddingBottom'),10);
	var margin = parseInt(getStyle(nodeRef,'margin-top', 'marginTop'),10) + parseInt(getStyle(nodeRef,'margin-bottom', 'marginBottom'),10);
	var border = parseInt(getStyle(nodeRef,'border-top-width', 'borderTopWidth'),10) + parseInt(getStyle(nodeRef,'border-bottom-width', 'borderBottomWidth'),10);

	// for IE7
	if (!padding)
		padding = 0;
	if (!margin)
		margin = 0;
	if (!border)
		border = 0;
	
	height = height - padding - margin - border;

	nodeRef.style.height = height + 'px';

}

// remove all instances of char from a string
function strip(string, symbol) {
	var newstring = "";
	
	for (var i = 0; i < string.length; i++) {
		if (string.charAt(i) != symbol)
			newstring += string.charAt(i);
	}
	return newstring;
}

function getTextNode(aNode)
{
	if (!isDefined(aNode) || !aNode.hasChildNodes())
		return null;
	
	for (var child = aNode.firstChild; child; child = child.nextSibling) {
		if (child.nodeType == 3) {
			return child;
		}
	}	
	
	return null;
}

function getTextValue(aNode)
{
	if (!isDefined(aNode) || !aNode.hasChildNodes())
		return null;
	
	for (var child = aNode.firstChild; child; child = child.nextSibling) {
		if (child.nodeType == 3) {
			return child.nodeValue;
		}
	}	
	
	return null;
}

///////////////////////

function shrink()
{
	var ws = window.shrinking;
	var shrinkage = 10;
	var rate = 10;
	
	if (!ws) {
		window.shrinking = this;
		ws = this;
		
		// now we have to set the object's children to no display
		var children = ws.object.childNodes;
		
		for (var i = 0; i < children.length; i++) {
			if (children[i].style)
				children[i].style.visibility = "hidden";
		}
		
	}
	
	switch (ws.direction)
	{
		case "left":
			var width = ws.object.currentWidth;
			
			if (width) {
				if (width > shrinkage)
					width -= shrinkage;
				else
					width = 0;
				
				ws.object.style.width = width + "px";
				ws.object.currentWidth = width;
				
				setTimeout("shrink()", rate);
			} else {
				// we're done.
				ws.object.currentWidth = 0;
				ws.object.style.display = "none";
				delete window.shrinking;
			}
		break;
		case "up":
			var height = ws.object.currentHeight;
			
			if (height) {
				if (height > shrinkage)
					height -= shrinkage;
				else
					height = 0;
				
				ws.object.style.height = height + "px";
				ws.object.currentHeight = height;
				
				setTimeout("shrink()", rate);
			} else {
				// we're done.
				ws.object.currentHeight = 0;
				ws.object.style.display = "none";
				delete window.shrinking;
			}
		
		break;
	}
	
	return ws.object;
}

// same thing as shrink but increasing instead of decreasing
function grow()
{
	var ws = window.growing;
	var shrinkage = 10;
	var rate = 10;
	
	if (!ws) {
		window.growing = this;
		ws = this;
		
		// now we have to set the object's children to visible
		var children = ws.object.childNodes;
		
		for (var i = 0; i < children.length; i++) {
			if (children[i].style)
				children[i].style.visibility = "visible";
		}
		
	}
	
	switch (ws.direction)
	{
		case "right":
			var width = ws.object.currentWidth;
			
			if (width < ws.object.startWidth) {
				if ((ws.object.startWidth - width) > shrinkage)
					width += shrinkage;
				else
					width = ws.object.startWidth;
				
				ws.object.style.width = width + "px";
				ws.object.currentWidth = width;
					
				setTimeout("grow()", rate);
			} else {
				// we're done.
				ws.object.startWidth = 0;
				delete window.growing;
			}
		break;
		case "down":
			var height = ws.object.currentHeight;
			
			if (height < ws.object.startHeight) {
				if ((ws.object.startHeight - height) > shrinkage)
					height += shrinkage;
				else
					height = ws.object.startHeight;
				
				ws.object.style.height = height + "px";
				ws.object.currentHeight = height;
				
				setTimeout("grow()", rate);
			} else {
				// we're done.
				ws.object.startHeight = 0;
				delete window.growing;
			}
		
		break;
	}
	
	return ws.object;
}

/**
 *
 *
 **/
function Dashboard(parent) {
	// properties
	this.parent = parent;
	this.widgets = new Array(0);
	
	// member functions
	this.add = dashboardAdd;
	this.remove = dashboardRemove;
	
	return this;
}

function dashboardAdd(object) {
	if (!this.widgets)
		return;
	
	var widget = null;
	
	// find the widget in the existing array
	for (var i in this.widgets) {
		if (this.widgets[i] == object) {
			widget = this.widgets[i];
			break;
		}
	}
	
	if (!widget)
		widget = this.widgets[this.widgets.push(object)];
		
	return widget;
}

function dashboardRemove(object) {
	if (!this.widgets)
		return;
	
	var widget = null;
	
	// find the widget in the existing array
	for (var i in this.widgets) {
		if (this.widgets[i] == object) {
			widget = this.widgets[i];
			break;
		}
	}
	
	if (widget)
		this.widgets.splice(i,1);
		
	return true;
}

/**
 *
 **/
 
 // flags
var DAX_Global_disableDragging = false;
 
 function startDragObject(event)
 {
	
	if (DAX_Global_disableDragging) {
		DAX_Global_disableDragging = false;
		return false;
	}
 
 	var event = xpEvent(event, true);
 	Controller.dragObject = this;
 	
 	var x = 0;
	var y = 0;
	
	if (event.pageX || event.pageY) {
		x = event.pageX;
		y = event.pageY;
 	} else if (event.screenX || event.screenY) {
	    x = event.screenX;
	    y = event.screenY;
	}
	
	if (this.style.zIndex < 9000) {
		setStyle(this, "zIndex", ++WindowManager.maxZIndex);
	} else { 
		setStyle(this, "zIndex", ++WindowManager.maxZDashIndex);
	}
		
	this.offsetX = this.offsetLeft - x;
    this.offsetY = this.offsetTop - y;
    
    if (document.addEventListener) {
    	document.addEventListener("mousemove", draggingObject, true);
  	 	document.addEventListener("mouseup",   stopDragObject, true);
    } else {
       document.onmousemove = draggingObject;
 	   document.onmouseup   = stopDragObject;
    }
    
    // propagate user-defined event
    if (this.ondragstart) {
    	this.ondragstart(event);
    }
 }
 
 /**
 *
 **/
 function startDragOtherObject(event, object)
 {
 	var event = xpEvent(event, true);
 	Controller.dragObject = object;
 	
 	var x = 0;
	var y = 0;
	
	if (event.pageX || event.pageY) {
		x = event.pageX;
		y = event.pageY;
 	} else if (event.screenX || event.screenY) {
	    x = event.screenX;
	    y = event.screenY;
	}
	
	if (object.style.zIndex < 9000) {
		setStyle(object, "zIndex", ++WindowManager.maxZIndex);
	} else { 
		setStyle(object, "zIndex", ++WindowManager.maxZDashIndex);
	}
	object.offsetX = object.offsetLeft - x;
    object.offsetY = object.offsetTop - y;
    
    if (document.addEventListener) {
    	document.addEventListener("mousemove", draggingObject, true);
  	 	document.addEventListener("mouseup",   stopDragObject, true);
    } else {
       document.onmousemove = draggingObject;
 	   document.onmouseup   = stopDragObject;
    }
    
    // propagate user-defined event
    if (object.ondragstart) {
    	object.ondragstart(event);
    }
 }

 function draggingObject(event)
 {
 	var event = xpEvent(event, true, true);
 	var object = Controller.dragObject;
 	
 	if (!object)
 		return;
 	
 	object.dragging = true;
 	
 	var x = 0;
	var y = 0;
	
	if (event.pageX || event.pageY) {
		x = event.pageX;
		y = event.pageY;
	} else if (event.screenX || event.screenY) {
		x = event.screenX;
		y = event.screenY;
	}
	
	object.style.left = (x+object.offsetX)+"px";
	object.style.top = (y+object.offsetY)+"px";
	
	// propagate user-defined event
	if (object.ondragging) {
		object.ondragging(event);
	}
	
	return false;
 }
 
 function stopDragObject(event)
 {
 	if (!Controller.dragObject)
 		return;
 		
	if (document.removeEventListener) {
 		document.removeEventListener("mousemove", draggingObject, true);
	    document.removeEventListener("mouseup",   stopDragObject, true);
 	} else {
		document.onmousemove = null;
 		document.onmouseup   = null;	
    }
    
 	// propagate user-defined event
    if (Controller.dragObject.dragging && Controller.dragObject.ondragstop) {
    	Controller.dragObject.ondragstop(event);
    }
    
    Controller.dragObject.dragging = false;
    Controller.dragObject = null;
 }
 
 // JL
// node 2 string conversion. gets the value of a node, returns as string object
function n2String(aNode)
{
	var tn = getTextNode(aNode);
	return isDefined(tn) ? new String(tn.nodeValue) : new String("");
}

function removeChildren(nodeToClean)
{
	while(nodeToClean.firstChild) {
		nodeToClean.removeChild(nodeToClean.firstChild);
	}
}

function getElementById(aNode, aElementId) {
	if (aNode.nodeType != 1)
		return null;
	
	if (aNode.id == aElementId)
		return aNode;
	
	var node = null;
	
	for (var child = aNode.firstChild; child; child = child.nextSibling) {
		node = getElementById(child, aElementId);
	}
	
	return node;
}

/*
function initTemplates()
{
	if (this.initialized)
		return;
	else
		this.initialized = true;
	

	// insert the framework templates
	var inlines = new Array();
	inlines[0] = 'framework';
	//inlines[1] = 'dax';

	var body = document.body;

	for (var i in inlines) {
		var iframe = document.createElement("iframe");
		
		iframe.id = inlines[i];
		iframe.name = inlines[i];
		iframe.src = 'js/templates/'+inlines[i]+'.html';
		iframe.width = 0;
		iframe.height = 0;
		
		if (browser.gecko) {
			setStyle(iframe, "display", "none");
		}
		body.insertBefore(iframe, null);
	}
}
*/

function getTemplate(id, aTemplate)
{
	var obj = document.getElementById(id);
	if (obj)
		return obj;
	
	// TODO: uncomment below when other templates really exist...
	// if (!isDefined(aTemplate))
		var aTemplate = "framework";
	
	var templ = this.frames[aTemplate] ? this.frames[aTemplate].document : null;
	obj = templ ? templ.getElementById(id) : null;

	if (obj) {
		obj = document.importNode(obj, true);
		document.body.insertBefore(obj, null);
	}
	
	return obj;
}

function getAdmin()
{
	var obj = document.getElementById("adminSettings");
	if (obj)
		return obj;
	
	var aTemplate = "admin";
	
	var templ = frames[aTemplate] ? frames[aTemplate].document : null;
	obj = templ ? templ.getElementById("adminSettings") : null;
	
	if (obj) {
		obj = document.importNode(obj, true);
		document.body.insertBefore(obj, null);
	}
	
	return obj;
}

//
// Create properties based on HTML elements' classnames.
//
// Ex.
//  var a = ...
//  probe(a);
//  alert(a.b);
//
// <div class="a">
//  <div class="b"></div>
// </div>
//
//
// by Jonathan Le
function probe(aParentNode)
{
	// loop through each child
	if (aParentNode.hasChildNodes()) {
		for (var child = aParentNode.firstChild; child; child = child.nextSibling) {
			if (child.nodeType == 1) {// Node.ELEMENT_NODE
				if (child.className != "") {
					var cname = new String();
					for (var i = 0; i < child.className.length; i++) {
						if (child.className.charAt(i) != "_")
							cname += child.className.charAt(i);
						else {
							if (i+1 < child.className.length) {
								cname += child.className.charAt(i+1).toUpperCase();
								i++;
							}
						}
					}
					aParentNode[cname] = child;
				}
				probe(child);
			}
		}
	} else
		return;
}

// Get the style of the element (with checks)
function getStyle(aHTMLElement, aStyle, aStyleAlt)
{
	var value = aHTMLElement.style[aStyle];
	if (!value) {
		if (document.defaultView && document.defaultView.getComputedStyle) {
			var css = document.defaultView.getComputedStyle(aHTMLElement, null);
			value = css ? css.getPropertyValue(aStyle) : null;
		} else if (aHTMLElement.currentStyle) {
			value = aHTMLElement.currentStyle[aStyleAlt];
		}
	}

	return value;
}

function setStyle(aHTMLElement, aStyle, aValue)
{
	try {
			// compensate for sizing in IE
		if (aStyle.toLowerCase() == "width" && browser.ie && false) {

		// $('fwdebug').value += '('+aHTMLElement.id+','+aHTMLElement.className+'):'+aHTMLElement.currentStyle.paddingTop;

			// check if value is in pixels
			if ( (aValue.indexOf('px') != -1) || (!(isNaN(aValue))) ){

				aValue = parseFloat(aValue);

				paddingOffset = parseFloat(aHTMLElement.currentStyle.paddingLeft) + parseFloat(aHTMLElement.currentStyle.paddingRight);

				if (!(isNaN(paddingOffset))) {
					aValue = aValue + paddingOffset;
				}

				borderOffset = parseFloat(aHTMLElement.currentStyle.borderLeftWidth) + parseFloat(aHTMLElement.currentStyle.borderRightWidth);
				if (!(isNaN(borderOffset))) {
					aValue = aValue	+ borderOffset;
				}
			}
		} else if (aStyle.toLowerCase() == "height" && browser.ie && false) {
			// check if value is in pixels
			if ( (aValue.indexOf('px') != -1) || (!(isNaN(aValue))) ){

				/*
				paddingOffset = parseFloat(aHTMLElement.currentStyle.paddingTop) + parseFloat(aHTMLElement.currentStyle.paddingBottom);

				if (!(isNaN(paddingOffset))) {
					aValue = parseFloat(aValue);
					aValue = aValue + paddingOffset;
				}

				borderOffset = parseFloat(aHTMLElement.currentStyle.borderTopWidth) + parseFloat(aHTMLElement.currentStyle.borderBottomWidth);
				if (!(isNaN(borderOffset))) {
					aValue = parseFloat(aValue);
					aValue = aValue	+ borderOffset;

				}
				*/				
			}
		}
		
		aHTMLElement.style[aStyle] = aValue;
	} catch (e) {
	//	 alert("style error: " + setStyle.caller + " " + e);
	}
}

function getMousePosition(aEvent)
{
	var x = 0;
	var y = 0;
	
	if (!aEvent) var aEvent = window.event;
	if (aEvent.pageX || aEvent.pageY) {
		x = aEvent.pageX;
		y = aEvent.pageY;
	} else if (aEvent.clientX || aEvent.clientY){
		x = aEvent.clientX;
		y = aEvent.clientY;
	}
	
	return { x : x, y : y};
}

function getObjectPosition(object)
{
	var px = 0;
	var py = 0;
	
	if (object.offsetParent) {
		for (var px = 0, py = 0; object.offsetParent; object = object.offsetParent) {
			px += object.offsetLeft;
			py += object.offsetTop;
		}
	} else {
		px = object.offsetLeft;
		py = object.offsetTop;
	}
	
    return { x : px, y : py  };
}

// FUNCTION: xpEvent(aEvent, aCancel) by Jonathan Le
// Pass in an Event to ensure it is cross-platform
function xpEvent(aEvent, aCancel, aPreventDefault)
{
	var aCancel = isDefined(aCancel) ? aCancel : false;
	var aEvent = !aEvent ? window.event : aEvent;
	var aPreventDefault = isDefined(aPreventDefault) ? aPreventDefault : false;
	
	if (aCancel) {
		aEvent.cancelBubble = aCancel;
		
		if (aEvent.stopPropagation)
			aEvent.stopPropagation();
	}
	
	if (aPreventDefault) {
		if (aEvent.preventDefault)
			aEvent.preventDefault();
	}

	aEvent._target = isDefined(aEvent.target) ? aEvent.target : aEvent.srcElement;
	if (aEvent._target) {
		if (aEvent._target.nodeType == 3) // handle safari
			aEvent._target = aEvent._target.parentNode;
	}
	
	return aEvent;
}

// returns an object with properties {width, height}
function xpGetSize(aElement)
{
	if (getStyle(aElement, "display") != "none")
		return (browser.ie) ? { width: aElement.clientWidth, height: aElement.clientHeight} :
			{ width: aElement.offsetWidth, height: aElement.offsetHeight };
				
    // adapted from prototype...enable visibility temporarily
    var els = aElement.style;
    var originalVisibility = els.visibility;
    var originalPosition = els.position;
    
    els.visibility = 'hidden';
    els.position = 'absolute';
    els.display = '';
    
    var originalWidth = aElement.clientWidth;
    var originalHeight = aElement.clientHeight;
    
    els.display = 'none';
    els.position = originalPosition;
    els.visibility = originalVisibility;
    
    return {width: originalWidth, height: originalHeight};
}

// validate date
// Rudolf Psenicnik

function validateDate (date) {
	//assert ('testA',date);
	if (isDefined(date)) {
		brokenDate = date.split("-");
		if (brokenDate.length == 3) {
			year = brokenDate[0];
			month = brokenDate[1];
			date = brokenDate[2];
			// check date validity
			testDate = new Date(year, month-1, date);
			if ((testDate.getFullYear() == year) && 
				(testDate.getMonth() == month-1) &&
				(testDate.getDate() == date)) {
				return true;
			} else {
				return false;
			}
		} else {	
			return false;
		}
	}
}

// Courtesy of Omid Tavallai
function setActiveStyleSheet(title) {
  var i, a, main;
  for(i=0; (a = document.getElementsByTagName("link")[i]); i++) {
	curTitle = a.getAttribute("title");
    if(a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title")) {
      a.disabled = true;
      if(curTitle == title) {
		a.disabled = false;
	  }
    }
  }
}

function getActiveStyleSheet() {
  var i, a;
  for(i=0; (a = document.getElementsByTagName("link")[i]); i++) {
    if(a.getAttribute("rel").indexOf("style") != -1 && a.getAttribute("title") && !a.disabled) return a.getAttribute("title");
  }
  return null;
}

function getPreferredStyleSheet() {
  var i, a;
  for(i=0; (a = document.getElementsByTagName("link")[i]); i++) {
    if(a.getAttribute("rel").indexOf("style") != -1
       && a.getAttribute("rel").indexOf("alt") == -1
       && a.getAttribute("title")
       ) return a.getAttribute("title");
  }
  return null;
}

function GetPopupTemplate(name, array_values, array_titles, size, display) {

	var display = (display == null) ? "block" : display;
	
	var selectdiv = cachedselectdiv.cloneNode(true);
	var select = cachedselect.cloneNode(true);
	
	if (selectdiv) {
		selectdiv.style.display = display;
		selectdiv.id = name+"_div";
	
		if (select) {
			if (size != null) 
				select.style.width = size + "px";
			select.id = name;
			var option = select.options[0];
		
			for (var k in array_titles) {
				if (k > 0)
					option = option.cloneNode(true);
				
				option.innerHTML = array_titles[k];
				option.value = array_values[k];
				select.appendChild(option);
			}
		
		}
	}
	
	return select;
}

// get window height
function getWindowHeight() {
	var windowHeight=0;
	if (typeof(window.innerHeight)=='number') {
		windowHeight=window.innerHeight;
	}
	else {
		if (document.documentElement&&
		document.documentElement.clientHeight) {
			windowHeight=
			document.documentElement.clientHeight;
		}
		else {
			if (document.body&&document.body.clientHeight) {
				windowHeight=document.body.clientHeight;
			}
		}
	}
	return windowHeight;
}

// find object position
function getPosition(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return [curleft,curtop];
}

// check if object is an array
function isArray(obj) {
//returns true is it is an array
	if (obj.constructor.toString().indexOf("Array") == -1)
		return false;
	else
		return true;
}

function findInArray (obj, value, fromIndex, useCaps, subStringSearch) {
	if (!useCaps)
		useCaps = false;
		
	if (fromIndex == null) {
		fromIndex = 0;
	} else if (fromIndex < 0) {
		fromIndex = Math.max(0, obj.length + fromIndex);
	}
	for (var i = fromIndex; i < obj.length; i++) {
		if (useCaps) {
			if (obj[i].toLowerCase() === value.toLowerCase())
				return i;
		} else if (subStringSearch) {
			if (obj[i].indexOf(value) != -1)
				return i;
		} else {
			if (obj[i] === value)
				return i;
		}
	}
	return -1;
}

function initTooltop() {

	// if tooltip object exists, return
	if ($('dax_tooltip0'))
		return $('dax_tooltip0');
		
	// add node to the page
	var tooltipNode = getTemplate ('dax_tooltip').cloneNode (true);
	var tooltip = document.body.appendChild (tooltipNode);
	tooltip.id = 'dax_tooltip0';
	
	if (tooltip)
		return tooltip;
	else
		return null;
}

function showTooltip(message, x, y) {

	var tooltip = initTooltop();
	
	if (!tooltip)
		return;
		
	setStyle (tooltip, 'display', 'block');
	
	tooltip.innerHTML = message;
	
	setStyle (tooltip, 'top', y - 22 + 'px');
	setStyle (tooltip, 'left', x + 8 + 'px');
	
}

function hideTooltip () {

	var tooltip = $('dax_tooltip0');
	
	if (!tooltip)
		return;

	setStyle (tooltip, 'display', 'none');

}

function ReplaceString(sString, sReplaceThis, sWithThis) {
	if (sReplaceThis != "" && sReplaceThis != sWithThis) {
		var counter = 0;
		var start = 0;
		var before = "";
		var after = "";
		while (counter<sString.length) {
			start = sString.indexOf(sReplaceThis, counter);
			if (start == -1){
				break;
			} else {
				before = sString.substr(0, start);
				after = sString.substr(start + sReplaceThis.length, sString.length);
				sString = before + sWithThis + after;
				counter = before.length + sWithThis.length;
			}
		}
	}
	return sString;
} 

function EncodeString(aString) {
	var sReplaceThis = "%";
	var sWithThis = "&#x";
	var sString = dax_bridge.encode(aString);
	
	if (sReplaceThis != "" && sReplaceThis != sWithThis) {
		var counter = 0;
		var start = 0;
		var before = "";
		var after = "";
		while (counter<sString.length) {
			start = sString.indexOf(sReplaceThis, counter);
			if (start == -1){
				break;
			} else {
				before = sString.substr(0, start);
				after = sString.substr(start + sReplaceThis.length + 2, sString.length);
				sString = before + sWithThis + sString.substr(start + sReplaceThis.length, 2) + ";" + after;
				counter = before.length + sWithThis.length + 3;
			}
		}
	}
	return dax_bridge.encode(sString);
} 

// Stubs.js by Jonathan Le

function test()
{
	try {
	/*
		var editor = new Editor();
		document.body.appendChild(editor.getDOM());
		
		editor.pull(2, 1);

	var a = $('a');
	var gridobject = new GridObject(a);
	//grid.grid.size(3,3);
	gridobject.load(
		[
			['nav a'],
			['nav b'],
			['nav c']
		]
	);
	
	var grid = gridobject.grid;
	var row = grid.row(0);
	
	row.prv.mDOM.onclick = function() { alert(this.parent.getIndex()); }
	gridobject.viewport.setOverflow(0,0);
		/*
		editor.size(3, 1);
		editor.assign([
			{label: 'a', value: 'b'},
			{label: 'b', value: 2},
			{label: 'c', value: $('a')}
		]);
	*/
	
	var toolbar = new Toolbar();
	toolbar.addButton("Create");
	document.body.insertBefore(toolbar.prv.mDOM, null);
	
	} catch (e) {
		alert(e); 
	}
}

// New all records function
function do_AR(element, tablenumber, aComparison, aObject)
{
	var grid = new GridObject(element);
	/*
	// hack for column width
	for (q = 0; q < grid.grid.prv.mColCount; q++) {
		grid.grid.column(q).setWidth(grid.grid.column(q).prv.mHeader.prv.mWidth);
	}
	*/
	
	grid.owner = aObject;

	// set a grid property
	element.grid = grid;
	
	if (element.parent)
		element.parent.grid = grid;
	
	//grid.clear();
	if (aObject.currentTab) {
		if (aObject.currentTab.queryName)
			grid.populate({tableId : tablenumber, comparison : aComparison, queryName: aObject.currentTab.queryName });
		else
			grid.populate({tableId : tablenumber, comparison : aComparison });
	} else {
		grid.populate({tableId : tablenumber, comparison : aComparison });
	}
	
	//grid.viewport.refresh();
	return grid;
}

/**
 * The "easy button"
 *
 * @author Jonathan Le
 * 
 * @param objectname	the name of the object to draw
 * @param arguments		some arguments, if you know them ;)
 * @param givenname		an id to assign to the object otherwise it takes the id
 * 		of objectname+{number}
 **/
function DAX(objectname, aArguments)
{
	var aArguments = isDefined(aArguments) ? aArguments : "";
	switch (objectname)
	{
		case "window":
		{
			schedule(function() { return getTemplate(objectId);},
				"do_drawWindow("+aArguments+")");
		}
		break;
		case "datawindow":
		{
			schedule(function() { return getTemplate("window") && structure.isUpdated();},
				"do_allRecords("+aArguments+")");
		}
		break;
		case "query":
		{
			schedule(function() { return getTemplate("recordsArea") && structure.isUpdated();},
				"do_queryInto("+aArguments+")");
		}
		break;
		case "queryrelated":
		{
			schedule(function() { return getTemplate("recordsArea") && structure.isUpdated();},
				"do_queryRelated("+aArguments+")");
		}
		break;
		case "login":
		{
			schedule(function() { return true; }, "do_login("+aArguments+")");
		}
		break;
		case "grid":
		{
			schedule(function() { return getTemplate("grid");}, "do_grid("+aArguments+")");
		}
		break;
		case "hl":
		{
			schedule(function() { return getTemplate("hl");}, "do_hl("+aArguments+")");
		}
		break;
		case "AllRecords":
		{
			schedule(function() { return getTemplate("newgrid"); }, "do_AR("+aArguments+")");
		}
		break;
		case "test":
		{
			schedule(function() { return getTemplate("editor"); }, "test("+aArguments+")");
		}
		break;
		case "NavBar":
		{
			schedule(function() { return getTemplate("newgrid"); }, "NavBar("+aArguments+")");
		}

		default:
			return;
	}
}

/**
 * @param condition is a 0P function that returns a boolean
 **/
function schedule(condition, callback)
{
	if (condition()) {
		// use js EVAL to run the function
		eval(callback);
	} else {
		// delay the function call until later
		setTimeout("schedule(" + condition + ", '" + callback + "')", 1);
	}
	
	return true;
}

function do_getPreferences()
{
}

function do_hl(element, listElement)
{
	if (listElement == null || listElement == undefined)
		return;
		
	var hl = new HList();
	hl.build(listElement);
	
	if (element == null || element == undefined) {
		element = document.body;
	}
	
	hl.refresh();
	element.insertBefore(hl.dom, null);
	
	// remove the list
	document.body.removeChild(listElement);
}

function do_grid(element)
{
	if (arguments.length > 0) {
		var grid = new Grid();
		for (var i = 1; i < arguments.length; i++) {
			var col = new GridColumn(arguments[i]);
			grid.insert(col);
		}
		
		element.insertBefore(grid.dom, null);
		grid.refresh();
		
		return grid;
	}
	
	return null;
}


/**
 * Performs an initial query, returning all possible records, then drawing them into a new
 * window.
 *
 * @author Jonathan Le
 *
 * @param tableId	numerical id of a table
 **/ 
function do_allRecords(tableId)
{
	var dw = new DataWindow(tableId, null, null, null, null, true);
	dw.open();
}

/**
 * Perform a query on the component database; display results in a new window.<b> 
 *
 * @author Jonathan Le
 *
 * @param queryid	string of the last known query id
 * @param start 	integer denoting starting point of record selection
 * @param length	number of records to return
 **/
function do_query(queryid, start, length)
{
	var sessionId = connection.sessionId;
		
	if (sessionId == "" || queryid == "")
		return;
		
	var url = connection.address.query+"?sessionId="+sessionId+"&queryid="+queryid+"&start="+start+"&length="+length;
	
	makeRequest(url, query, null);
}

/**
 * Perform a query but instead of opening a new window, add the result into a
 * given element. 
 *
 * @author Jonathan Le
 *
 * @param comparison	comparison string is appended to the end of a URL
 *						&fieldid=1&comp=equal&value=CA
 *
 * @param element	a reference to add the results into
 **/
function do_queryInto(tableid, queryid, start, length, element, comparison)
{
	var sessionId = connection.sessionId;
		
	if (sessionId == "" || (tableid == "" && queryid == "") || !element)
		return;
	
	if (start == null || start == undefined) {
		start = 0;
	}
	
	if (length == null || length == undefined) {
		length = 25;
	}
	
	if (queryid) {			
		var url = connection.address.query+"?sessionId="+sessionId+"&queryid="+queryid+"&start="+start+"&length="+length;
	} else if (comparison) {
		var url = connection.address.query+"?sessionId="+sessionId+"&tableid="+tableid+"&queryid=&start="+start+"&length="+length;
	} else {
		var url = connection.address.allrecords+"?sessionId="+sessionId+"&tableid="+tableid+"&start="+start+"&length="+length
	}
	
	if (comparison && comparison != "")
		url += comparison;
		
	var http_request = getXMLHttpRequest();
		
	if (http_request) {
		http_request.onreadystatechange = function() { query(http_request, element);};
			
		try {
			// call event handler
			if (element.onbeforeload) {
				element.onbeforeload();
			}
			
			http_request.open("GET", url, true);
	  	  	http_request.send(null);
	   	} catch(e) {
			if (browser.ie6)
				http_request.onreadystatechange = function(){};
			else
				http_request.onreadystatechange = null;
	   		delete http_request;
		}
	}
}

function do_queryRelated(related_tableid, related_recordid, link_tableid, target_tableid, element)
{
	var sessionId = connection.sessionId;
		
	if (sessionId == "" || !element)
		return;
	
	var url = "QueryRelatedRecords" + "?sessionId=" + sessionId + "&relatedtableid=" +
		related_tableid + "&relatedrecordid=" + related_recordid + "&linktableid=" +
		link_tableid + "&targettableid=" + target_tableid;
			
	var http_request = getXMLHttpRequest();
		
	if (http_request) {
		http_request.onreadystatechange = function() { query(http_request, element);};
			
		try {
			http_request.open("GET", url, true);
	  	  	http_request.send(null);
	   	} catch(e) {
			if (browser.ie6)
				http_request.onreadystatechange = function(){};
			else
				http_request.onreadystatechange = null;
	   		delete http_request;
		}
	}
}

/**
 * Draws a generic window based on the 'frame' class.
 *
 * @author Jonathan Le
 *
 * @param title		STRING
 * @param toolbar	NODE
 * @param content	NODE
 * @param status	NODE
 *
 * @see index.html
 **/
function do_drawWindow(title, toolbar, content, status)
{
	// initialize framework
	dax.init();
	   	
   	var newWindow = WindowManager.createNewWindow();
   	
   	if (content) {
		newWindow.contentArea.appendChild(content);
	}
	
	if (title) {
		newWindow.titleBar.innerHTML = title;
	}
	
	if (toolbar) {
		newWindow.addToolbar(toolbar);
	}
	
	if (status) {
		var sbar = newWindow.status.appendChild(status);
		sbar.parent = newWindow;
	}
   	
   	// open the window
   	newWindow.open();
   	
   	// set the size of the new window and activate it
   	newWindow.size(newWindow.dom.offsetWidth, newWindow.dom.offsetHeight);
   	newWindow.activate();
   	
   	return newWindow.dom;
}

/**
 * Shrinks an HTML element in the direction that is specified.  The function does
 * not take into account the padding, margin, or border.
 *
 * @author Jonathan Le
 *
 * @param object	reference to an HTML element
 * @param direction	either "left" or "up"
 *
 * @return the object that is shrinking.
 **/
function do_shrink(object, direction)
{
	// already shrinking something...escape
	if (window.shrinking || object.style.display == "none")
		return null;
	
	// first we need a generic object
	var shrinker = new Object();
	
	// save the original widths
	object.startWidth = object.offsetWidth;
	object.startHeight = object.offsetHeight;
	object.startDisplay = object.style.display;
	
	// this is the current width
	object.currentWidth = object.offsetWidth;
	object.currentHeight = object.offsetHeight;
	
	// set properties
	shrinker.object = object;	
	shrinker.direction = direction;
	shrinker.shrink = shrink;
	
	// do the shrinking
	return shrinker.shrink();
}

/**
 * Grows an HTML element in the direction that is specified.  the object can only be
 * grown if it had previously been shrunk.  see do_shrink().
 *
 * @author Jonathan Le
 *
 * @param object	reference to an HTML element
 * @param direction	either "right" or "down"
 *
 * @return	the object that is growing
 **/
function do_grow(object, direction)
{
	// already shrinking something...escape
	if (window.growing)
		return null;
		
	if (!object.startHeight && !object.startWidth)
		return null;
		
	// first we need a generic object
	var grower = new Object();
	
	// reset
	object.style.display = object.startDisplay;
	
	// set properties
	grower.object = object;	
	grower.direction = direction;
	grower.grow = grow;
	
	// do the growing
	return grower.grow();
}

/**
 * Add a rounded corner appearance to an object
 *
 * @author Jonathan Le
 *
 * @param object			reference to an HTML element
 * @param backgroundColor	string for HTML color, eg "red" or "#ff0000"
 **/
function do_roundCorners(object, backgroundColor)
{
	// first look for our template
	var rc = getElementByClassName(document, "roundedCornerObject");

	if (!rc)
		return;
	
	rc = rc.cloneNode(true);
		
	var body = document.getElementsByTagName("body").item(0);
	body.insertBefore(rc, object);
	
	var rbody = getElementByClassName(rc, "roundedCornerObjectBody");
	rbody.appendChild(object);
	
	// set some styles
	rc.style.display = "";
	
	// try to match the background color of the contained object
	var bg = object.style.backgroundColor;
	
	if (bg.length == 0) {
		bg = getCSSPropertyValue(object.className, "background-color");
	}
	
	rc.style.backgroundColor = bg;
}

/**
 * Creates an accordion effect for a specified object in the specified direction.
 *
 * Ex. onclick="do_accordion($('myobj'), 'up')"
 * 
 * @author Jonathan Le
 * @param object	a reference to an HTML element
 * @param direction	a string that is either "up" or "left"
 *
 * @return the reference to the object that has been given the accordion effect.
 **/
function do_accordion(object, direction)
{
	var growdir = "";
	
	if (direction == "up")
		growdir = "down";
	else if (direction == "left")
		growdir = "right";
	else
		return;
	
	var rv = null;
	
	if (!(rv = do_shrink(object, direction))) {
		rv = do_grow(object, growdir);
	}
	
	return rv;
}

/**
 * Shows a blackout screen with widgets.  Optionally adds an object as a widget to the
 * dashboard.
 *
 * @author Jonathan Le
 *
 * @param object	HTML element reference to add as widget
 **/
function do_showDashboard(object, enabledragging)
{
	// dashboard based on this blackout object
	var blackout = $('blackout');
	
	if (!blackout)
		return;
		
	if (!blackout.dashboard)
		blackout.dashboard = new Dashboard(blackout);
	
	if (object) {
		object.style.position = "absolute";
		blackout.dashboard.add(object);
		if (enabledragging==undefined)
			do_enableDragging(object);
		else
			switch(enabledragging) 
			{
				case "Full":
					do_enableDragging(object);	
					break;
				case "None":
					break;
				default:
					// Borders
					var borderobject = $('top_dash'+enabledragging);
					setStyle(borderobject, "cursor", "move");
					borderobject.onmousedown = function(event) {
						startDragOtherObject(event, object);
					}
					var borderobject = $('left_dash'+enabledragging);
					setStyle(borderobject, "cursor", "move");
					borderobject.onmousedown = function(event) {
						startDragOtherObject(event, object);
					}
					var borderobject = $('right_dash'+enabledragging);
					setStyle(borderobject, "cursor", "move");
					borderobject.onmousedown = function(event) {
						startDragOtherObject(event, object);
					}
					var borderobject = $('bottom_dash'+enabledragging);
					setStyle(borderobject, "cursor", "move");
					borderobject.onmousedown = function(event) {
						startDragOtherObject(event, object);
					}
					break;
				
			}
		
	}
	
	//var zindextoapply = ++WindowManager.maxZIndex;
	var zindextoapply = 9100;
	
	// now show the dashboard and all its widgets
	for (var i in blackout.dashboard.widgets) {
		blackout.dashboard.widgets[i].style.display = "";
		blackout.dashboard.widgets[i].style.zIndex = zindextoapply+1;
	}
	
	// show the blackout
	blackout.style.display = "block";
	blackout.style.left = "0px";
	blackout.style.zIndex = zindextoapply;
}

/**
 * Hide the dashboard and all its widgets.
 *
 * @author Jonathan Le
 **/
function do_hideDashboard(object)
{

	if ((isAdminAccessedFromMainPage) && (isAdminLoaded)) {
		window.onbeforeunload = null;
		window.location.reload(false);
	}

	var blackout = $('blackout');
	
	if (!blackout)
		return;
		
	if (blackout.dashboard) {
		for (var i in blackout.dashboard.widgets) {
			blackout.dashboard.widgets[i].style.display = "none";
			blackout.dashboard.widgets[i].style.zIndex = "";
		}
	}

	if (object) {
		if (blackout.dashboard) {
			blackout.dashboard.remove(object);
		}	
	}
	
	if (aSidebar)
		do_redrawSidebar();
		
	blackout.style.display = "none";
	blackout.style.zIndex = "";
}

function do_removeDashboardObject(object)
{
	var blackout = $('blackout');
	
	if (!blackout)
		return;

	if (object) {
		if (blackout.dashboard) {
			blackout.dashboard.remove(object);
			object.style.display = "none";
		}	
	}	
}

/**
 * Enable dragging of an object in the browser.
 *
 * @author Jonathan Le
 *
 * @param object	the object to make draggable.
 **/
function do_enableDragging(object)
{
	setStyle(object, "cursor", "move");
	object.onmousedown = startDragObject;
}

/**
 * Disable dragging of the object.
 *
 * @author Jonathan Le
 *
 * @param object the object to disable dragging
 **/
function do_disableDragging(object)
{
	object.style.cursor = "auto";
	object.onmousedown = null;
}


/* J.L - Below is deprecated by the replacement of the Taskbar Object */
/**
 * Displays the taskbar.  The taskbar object (id='taskbar') must be present in the file
 * that is going to call this function.
 *
 * @author	Jonathan Le
 * @see		index.html
 
function do_showTaskbar()
{
	var tb = $("taskbar");
	
	if (!tb)
		return;
	
	// default display
	tb.style.display = "block";
}
*/

/**
 * Appends the item reference to the taskbar.
 *
 * @author	Jonathan Le
 *
 * @param item	a reference to an HTML element to append to the taskbar element
 **
function do_addTaskbarItem(item)
{
	var tb = $("taskbar");
	
	if (!tb)
		return;
	
	tb.appendChild(item);
	
	return item;
}
*/

/**
 * Remove the specified item from the task bar.
 *
 * @author Jonathan Le
 *
 * @param item	a reference to the item to remove
 *
 function do_removeTaskbarItem(item)
 {
 	var tb = $("taskbar");
 	
 	if (!tb)
 		return;
 	
 	try {
	 	tb.removeChild(item);
	} catch(e) { }
 }
 */
 
 /**
  * Create a new tab holder and return a reference to it.
  * <br>
  * The tab object contains the following properties:
  * <ol>
  *  <li>tabs - an array of references to tabs</li>
  *  <li>first - reference to the first tab</li>
  *  <li>last - reference to the last tab</li>
  *  <li>current - reference to the currently active tab</li>
  * </ol>
  *
  * @author Jonathan Le
  *
  * @param parent	Optional. place the tab holder in this element.
  * @param text		text of the first tab
  *
  * @return a reference to the newly created tab holder
  **/
 function do_createTabHolder(text, parent)
 {
 	if (text == '')
 		return;
 		
 	// based on a template
 	var tabObject = $('tabObject');
 	
 	if (!tabObject)
 		return null;
 	
 	// duplicate it
 	tabObject = tabObject.cloneNode(true);
 	tabObject.tabs = new Array(0);
 	
 	do_addTab(tabObject, text);
 	
 	if (parent) {
 		var children = parent.childNodes;
 		
 		if (children) {
 			parent.insertBefore(tabObject, children[0]);
 		} else { 			
	 		parent.appendChild(tabObject);
 		}
 		tabObject.parent = parent;
 	}
 	
 	tabObject.style.display = "block";
 	
 	return tabObject;
 }
 
 /**
  * Add a new tab to a given tab holder with text.
  *
  * @author Jonathan Le
  * 
  * @param tabholder	the tab holder to add the new tab to
  * @param text			the text to put on the tab
  *
  * @return a reference to the newly created tab
  **/
 function do_addTab(tabholder, text)
 {
 	if (!tabholder || text == '')
 		return;
 		
 	var tabContainer = getElementByClassName(tabholder, "tabContainer");
 	var tabItem = null;
 	
 	// first count the tab objects that this tabholder currently contains
 	if (tabholder.first) {
 		// first tab was already added
 		tabItem = tabholder.first.cloneNode(true);
 	} else {
 		// this is the first tab to be added
 		tabItem = getElementByClassName(tabContainer, "tabItem");
 		tabholder.first = tabItem;
 	}
 	
 	if (tabItem) {
 		var tabBody = getElementByClassName(tabItem, "tabItemBody");	
 		tabBody.innerHTML = text;
 		tabholder.last = tabItem;
 		tabContainer.appendChild(tabItem);
 		
 		tabItem.onclick = function(event) { activateTab(event, this); };
 		tabItem.parent = tabholder;
 		tabItem.value = text;
  		
 		var actor = getElementByClassName(tabItem, "tabItemActive");
 		tabItem.actor = actor ? actor : getElementByClassName(tabItem, "tabItemInactive");
 		
 		var index = tabholder.tabs.push(tabItem);
 
 		// assign function to close the tab
 		var tabCloser = getElementByClassName(tabholder, "tabCloser");
 		if (tabCloser)
	  		tabCloser.onclick = function() { do_removeTab(tabholder); };
 		
 		activateTab(null, tabItem);
 	}
 	
 	return tabItem;
 }
 
 /**
  * Closes and removes a tab from the tab holder.
  *
  * @author Jonathan Le
  *
  * @param tabholder	reference to the container holding the tabs
  * @param tabIndex		number of the tab to remove
  **/
 function do_removeTab(tabholder, tabIndex)
 {
 	if (!tabholder.tabs)
 		return;
 	
 	if (tabIndex >= 0) {
 		// get the tab to remove from list of tabs
 		var tab = tabholder.tabs[tabIndex];
 	} else {
 		var tab = tabholder.current;
 		
 		for (var i in tabholder.tabs) {
 			if (tabholder.tabs[i] == tab)
 				tabIndex = i;
 		}
 	}
 	
 	if (tab) {
 		var tabContainer = getElementByClassName(tabholder, "tabContainer");
 		tabContainer.removeChild(tab);
 		
 		// remove the item from the tabs
 		tabholder.tabs.splice(tabIndex, 1);
 		
 		if (tabholder.tabs.length > 0) {
 			tabholder.current = tabholder.tabs[tabholder.tabs.length-1];
 			tabholder.last = tabholder.current;
 			tabholder.current.onclick();
 		} else {
 			// remove the tabholder
 			if (tabholder.parent) {
 				tabholder.parent.tabholder = null;
 				tabholder.parent.removeChild(tabholder);
 			}
 		}
 	}
 }
 
 /**
  * Populates the innerHTML or optionally an attribute.
  **/
  function do_populateElementsByIds(ids, tableid, recordid, propertyNames)
 {
 	var sessionId = connection.sessionId;
 
 	if (!ids || sessionId == "")
 		return;
 		
 	var http_request = getXMLHttpRequest();
		
	if (http_request) {
		var url = connection.address.getrecord + "?sessionId=" + sessionId + "&tableid=" + tableid + "&recordid=" + recordid;
		
		http_request.onreadystatechange = 
			function() {
				populateElementsByIds(http_request, ids, propertyNames);
			};
			
		try {
			http_request.open("GET", url, true);
	  	  	http_request.send(null);
	   	} catch(e) {
			if (browser.ie6)
				http_request.onreadystatechange = function(){};
			else
				http_request.onreadystatechange = null;
	   		delete http_request;
		}
	}
 }

// JF
function purgeparents(d) {
	for (var property in d) {
		if (d[property]) {
			if (d[property].parent)
				d[property].parent = null;
		}
	}
};

// http://javascript.crockford.com/memory/leak.html 
function purge(d) {
	var a = d.attributes, i, l, n; 
	if (a) {
		l = a.length;
		for (i = 0; i < l; i += 1) {
			n = a[i].name;
			if (typeof d[n] === 'function') {
				d[n] = null;
			}
			if (n == 'parent')
				d[n] = null;
		}
	}
	a = d.childNodes;
	if (a) {
		l = a.length;
		for (i = 0; i < l; i += 1) {
			purge(d.childNodes[i]);
		}
	}
}
 
function dax_setDraggable(object){

	dax_bridge.dax_nodrag = false;
	object.onmousedown = dax_startHoverDragging;
	
}

function dax_setNoDrag(){

	dax_bridge.dax_nodrag = true;
	
}

function dax_setDrag(){

	dax_bridge.dax_nodrag = false;
	
}
 
function dax_startHoverDragging(event)
{

	if (dax_bridge.hoverDragging)
		return false;
	
	if (dax_bridge.dax_nodrag)
		return true;
		
	dax_bridge.hoverDragging = {
		dragObjectSource	: this,
		dragObjectHover		: this.cloneNode(true)		
	}
	
	generateUniqueId(dax_bridge.hoverDragging.dragObjectHover);
	
	var dragObjectHover = dax_bridge.hoverDragging.dragObjectHover;
	var dragObjectSource = dax_bridge.hoverDragging.dragObjectSource;
	
	document.body.appendChild(dragObjectHover);
	
	// var objectPosition = getObjectPosition(dragObjectSource);
	
	dax_bridge.hoverDragging.dragObjectHover.style.zIndex = 9999;
	dax_bridge.hoverDragging.dragObjectHover.style.position = 'absolute';
	
 	var event = xpEvent(event, true);
	
	/*
 	var x = 0;
	var y = 0;
	
	if (event.pageX || event.pageY) {
		x = event.pageX;
		y = event.pageY;
 	} else if (event.screenX || event.screenY) {
	    x = event.screenX;
	    y = event.screenY;
	}

	$('debugA').innerHTML = 'ox:' + objectPosition.x + ' oy:' + objectPosition.y +
		'ex:' + x + ' ey:' + y;
	
	dragObjectHover.offsetX = dragObjectHover.offsetLeft - x;
    dragObjectHover.offsetY = dragObjectHover.offsetTop - y;
 
	*/
 
	var mousePosition = getMousePosition(event);

	dragObjectHover.style.left = mousePosition.x- 20 +"px";
	dragObjectHover.style.top = mousePosition.y- 20 +"px";
 
    if (document.addEventListener) {
    	document.addEventListener("mousemove", dax_hoverDragging, true);
  	 	document.addEventListener("mouseup",   dax_hoverDraggingStop, true);
    } else {
       document.onmousemove = dax_hoverDragging;
 	   document.onmouseup   = dax_hoverDraggingStop;
    }
    
    // propagate user-defined event
    if (dragObjectSource.ondragstart) {
    	dragObjectSource.ondragstart(event);
    }
    return false;
 }

function dax_hoverDragging(event) {
 
	if (!dax_bridge.hoverDragging)
 		return;
		
	var event = xpEvent(event, true, true);
 
	var dragObjectSource = dax_bridge.hoverDragging.dragObjectSource;
	var dragObjectHover = dax_bridge.hoverDragging.dragObjectHover;

	/*
	
  	var x = 0;
	var y = 0;
	
	if (event.pageX || event.pageY) {
		x = event.pageX;
		y = event.pageY;
	} else if (event.screenX || event.screenY) {
		x = event.screenX;
		y = event.screenY;
	}
	
	*/
	
	var mousePosition = getMousePosition(event);

	dragObjectHover.style.left = mousePosition.x- 20 + "px";
	dragObjectHover.style.top = mousePosition.y- 20 +"px";

//	dragObjectHover.style.left = (x+dragObjectHover.offsetX)+"px";
//	dragObjectHover.style.top = (y+dragObjectHover.offsetY)+"px";
	
	// propagate user-defined event
	if (dragObjectSource.ondragging) {
		dragObjectSource.ondragging(event);
	}
	
	return false;
 }
 
 function dax_hoverDraggingStop(event)
 {
 	if (!dax_bridge.hoverDragging)
 		return;
 
	var dragObjectSource = dax_bridge.hoverDragging.dragObjectSource;
	var dragObjectHover = dax_bridge.hoverDragging.dragObjectHover;
 
	if (document.removeEventListener) {
 		document.removeEventListener("mousemove", dax_hoverDragging, true);
	    document.removeEventListener("mouseup",   dax_hoverDraggingStop, true);
 	} else {
		document.onmousemove = null;
 		document.onmouseup   = null;	
    }
	
	if (dragObjectSource.ondragrelease) {
		dragObjectSource.ondragrelease(event);
	}
	
    
 	// propagate user-defined event
    if (dax_bridge.hoverDragging.target) {
    	dax_bridge.hoverDragging.target.ondragrelease(event);
    }
    
	document.body.removeChild(dragObjectHover);
	
    dax_bridge.hoverDragging = null;
 }
 
 
function makeCSS(selector, declaration) {

		if (!dax_bridge.styleNode) {
			// create the style node for all browsers
	        var style_node = document.createElement("style");
			style_node.setAttribute("type", "text/css");
	        style_node.setAttribute("media", "screen");
	        // append the style node
	        document.getElementsByTagName("head")[0].appendChild(style_node);
			dax_bridge.styleNode = style_node;		
		} else {
			var style_node = dax_bridge.styleNode;
		}

        // append a rule for good browsers
        if (!browser.ie) style_node.appendChild(document.createTextNode(selector + " {" + declaration + "}"));


        // use alternative methods for IE
        if (browser.ie && document.styleSheets && document.styleSheets.length > 0) {
                var last_style_node = document.styleSheets[document.styleSheets.length - 1];
                if (typeof(last_style_node.addRule) == "object") last_style_node.addRule(selector, declaration);
        }
};